// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import java.applet.Applet;
import java.awt.*;

// Referenced classes of package communities:
//            IPalaceCore, Tooltip

public class ButtonPanel extends Panel
    implements Runnable {

    IPalaceCore itsCore;
    int numButtons;
    int numInitialized;
    Component buttons[];
    Component activeButton;
    String helpStrings[];
    Thread tooltipThread;
    boolean bHasTooltips;
    boolean tooltipActive;
    boolean bMouseMoved;
    int bMouseInside;
    long curTime;
    long lastTime;
    long timeSinceMouseMoved;
    int mouseX;
    int mouseY;
    public static long TIP_DELAY = 1000L;

    public void addButton(Component newButton, String helpText) {
        add(newButton);
        buttons[numInitialized] = newButton;
        if(helpText != null) {
            helpStrings[numInitialized] = helpText;
            bHasTooltips = true;
        }
        numInitialized++;
    }

    private Point normalize(int x, int y) {
        Component c = this;
        do {
            if(c instanceof Applet)
                break;
            Point p = c.location();
            x += p.x;
            y += p.y;
            c = c.getParent();
        } while(!(c instanceof Frame));
        return new Point(x, y);
    }

    public void reset() {
        bMouseInside = 0;
        removeActiveTooltip();
    }

    public ButtonPanel(int numButtons, IPalaceCore itsCore) {
        this.numButtons = 0;
        numInitialized = 0;
        buttons = null;
        activeButton = null;
        helpStrings = null;
        tooltipThread = null;
        bHasTooltips = false;
        tooltipActive = false;
        bMouseMoved = false;
        bMouseInside = 0;
        curTime = 0L;
        lastTime = 0L;
        timeSinceMouseMoved = 0L;
        mouseX = 0;
        mouseY = 0;
        this.numButtons = numButtons;
        this.itsCore = itsCore;
        buttons = new Component[numButtons];
        helpStrings = new String[numButtons];
    }

    public synchronized void addNotify() {
        super.addNotify();
        if(bHasTooltips && tooltipThread == null) {
            tooltipThread = new Thread(this, "Tooltip");
            try {
                tooltipThread.setDaemon(true);
            }
            catch(Exception e) { }
            tooltipThread.start();
        }
    }

    private boolean myInside(Rectangle r, int x, int y) {
        return x >= r.x && x <= r.x + r.width && y >= r.y && y <= r.y + r.height;
    }

    private void removeActiveTooltip() {
        itsCore.getTooltip().hide();
        tooltipActive = false;
        activeButton = null;
    }

    private void displayTooltip(String text, Component button) {
        boolean bIntersects = false;
        Tooltip tooltip = itsCore.getTooltip();
        tooltip.setText(text);
        FontMetrics fm = tooltip.getFontMetrics(tooltip.getFont());
        int width = fm.stringWidth(tooltip.itsText) + 12;
        int panelWidth = ((Applet)itsCore).size().width;
        int height = fm.getHeight() + 4;
        int panelHeight = ((Applet)itsCore).size().height;
        Point p = normalize(mouseX, mouseY);
        int x;
        if(panelWidth - p.x >= width + 8)
            x = p.x + 6;
        else
        if(p.x - bounds().x >= width + 6) {
            x = p.x - width - 4;
        } else {
            x = panelWidth - width - 2;
            bIntersects = true;
        }
        int y;
        if(panelHeight - p.y >= height + 8 && !bIntersects)
            y = p.y + 6;
        else
        if(p.y - bounds().y >= height + 4)
            y = p.y - height - 2;
        else
            y = p.y;
        tooltip.reshape(x, y, width, height);
        tooltipActive = true;
        activeButton = button;
        tooltip.show();
    }

    public void setHelpText(Component theButton, String helpText) {
        for(int i = 0; i < numInitialized; i++) {
            if(buttons[i] != theButton)
                continue;
            helpStrings[i] = helpText;
            break;
        }

    }

    public void run() {
        lastTime = System.currentTimeMillis();
        while(tooltipThread != null)  {
            curTime = System.currentTimeMillis();
            long elapsed = curTime - lastTime;
            lastTime = curTime;
            if(bMouseInside > 0 && !tooltipActive) {
                if(bMouseMoved) {
                    timeSinceMouseMoved = 0L;
                    bMouseMoved = false;
                }
                timeSinceMouseMoved += elapsed;
                if(timeSinceMouseMoved > TIP_DELAY) {
                    timeSinceMouseMoved = 0L;
                    for(int i = 0; i < numInitialized; i++) {
                        Rectangle bbounds = buttons[i].bounds();
                        if(!myInside(bbounds, mouseX, mouseY))
                            continue;
                        displayTooltip(helpStrings[i], buttons[i]);
                        break;
                    }

                }
            }
            try {
                Thread.sleep(250L);
            }
            catch(InterruptedException ie) { }
        }
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
        case 505: // Event.MOUSE_EXIT
            if(activeButton != null)
                removeActiveTooltip();
            bMouseInside--;
            return true;

        case 504: // Event.MOUSE_EVENT
            bMouseInside++;
            bMouseMoved = false;
            return true;

        case 503: // Event.MOUSE_MOVE
            bMouseMoved = true;
            mouseX = evt.x;
            mouseY = evt.y;
            if(activeButton != null && !myInside(activeButton.bounds(), mouseX, mouseY))
                removeActiveTooltip();
            return true;
        }
        return super.handleEvent(evt);
    }

    public synchronized void removeNotify() {
        super.removeNotify();
        if(tooltipThread != null) {
            Thread aThread = tooltipThread;
            tooltipThread = null;
            aThread.interrupt();
        }
    }

}
