// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import java.awt.*;
import java.util.StringTokenizer;
import java.util.Vector;

// Referenced classes of package communities:
//            IPalaceCore

public class CoolLog extends Panel {

    private static int MAX_VERT_LINES = 550;
    private static int MAX_HORZ_COLS = 80;
    private static int LINE_HEADER = 1;
    private static int LINE_CONTAINS_URL = 2;
    private int m_txtTopPtr;
    private int m_txtNumLns;
    private int m_txtNumCols;
    private int m_txtLeftPtr;
    private String m_textArr[];
    private int mLineFlags[];
    private int m_arrHead;
    private int m_cutNum;
    private int m_fontH;
    private int m_visLns;
    private IPalaceCore mCore;
    private Scrollbar m_vertScr;
    private Scrollbar m_horzScr;
    private Font m_font;
    private FontMetrics m_fontMet;
    private Color m_fgColor;
    private Color m_bgColor;
    private Color mNameColor;
    private Color mPrivateColor;
    private Color mSystemColor;
    private boolean m_horzScroll;
    private boolean m_wrapping;

    private void drawAString(Graphics g, String drawStr, int xPos, int yPos, FontMetrics fm, boolean isHeader) {
        String chatStr = drawStr;
        if(isHeader)
            if(drawStr.charAt(0) == '*') {
                if(drawStr.regionMatches(0, "***", 0, 3)) {
                    g.setColor(mSystemColor);
                    g.drawString("***", xPos, yPos);
                    chatStr = new String(drawStr.substring(3));
                    xPos += fm.stringWidth("***");
                } else {
                    int idx = drawStr.indexOf('*', 1);
                    if(idx == -1) {
                        g.drawString(drawStr, xPos, yPos);
                    } else {
                        String nameStr = new String(drawStr.substring(0, idx + 1));
                        chatStr = new String(drawStr.substring(idx + 1));
                        g.setColor(mPrivateColor);
                        g.drawString(nameStr, xPos, yPos);
                        xPos += fm.stringWidth(nameStr);
                    }
                }
            } else {
                int idx = drawStr.indexOf(':');
                if(idx != -1) {
                    String nameStr = new String(drawStr.substring(0, idx + 1));
                    chatStr = new String(drawStr.substring(idx + 1));
                    g.setColor(mNameColor);
                    g.drawString(nameStr, xPos, yPos);
                    xPos += fm.stringWidth(nameStr);
                }
            }
        if(chatStr.indexOf("://") != -1) {
            StringTokenizer st = new StringTokenizer(chatStr);
            int spaceWidth = fm.stringWidth(" ");
            if(isHeader)
                xPos += spaceWidth * 2;
            while(st.hasMoreElements())  {
                String s = st.nextToken();
                if(s.indexOf("://") != -1) {
                    g.setColor(Color.blue);
                    g.drawLine(xPos, yPos + 2, xPos + fm.stringWidth(s), yPos + 2);
                } else {
                    g.setColor(m_fgColor);
                }
                g.drawString(s, xPos, yPos);
                xPos += fm.stringWidth(s);
                xPos += spaceWidth;
            }
        } else {
            g.setColor(m_fgColor);
            g.drawString(chatStr, xPos, yPos);
        }
    }

    public CoolLog(IPalaceCore core, int maxLns, int maxCols, Color fgColor, Color bgColor, Color nameColor, Color privateColor, 
            Color systemColor, boolean wrapping, boolean horzScroll, Font font) {
        m_txtTopPtr = 0;
        m_txtNumLns = 0;
        m_txtNumCols = 0;
        m_txtLeftPtr = 0;
        m_textArr = null;
        mLineFlags = null;
        m_arrHead = 0;
        m_cutNum = 1;
        m_fontH = 0;
        m_visLns = 0;
        mCore = null;
        m_vertScr = null;
        m_horzScr = null;
        m_font = null;
        m_fontMet = null;
        m_fgColor = null;
        m_bgColor = null;
        mNameColor = null;
        mPrivateColor = null;
        mSystemColor = null;
        m_horzScroll = false;
        m_wrapping = true;
        mCore = core;
        m_txtNumLns = maxLns <= 0 ? MAX_VERT_LINES : maxLns;
        m_txtNumCols = maxCols <= 0 ? MAX_HORZ_COLS : maxCols;
        m_fgColor = fgColor == null ? Color.black : fgColor;
        m_bgColor = bgColor == null ? Color.lightGray : bgColor;
        mNameColor = fgColor == null ? Color.black : nameColor;
        mPrivateColor = fgColor == null ? Color.black : privateColor;
        mSystemColor = fgColor == null ? Color.black : systemColor;
        m_wrapping = wrapping;
        m_horzScroll = horzScroll;
        m_cutNum = m_txtNumLns / 4;
        m_font = font == null ? new Font("Dialog", 0, 12) : font;
        setFont(m_font);
        m_fontMet = getFontMetrics(m_font);
        setForeground(m_fgColor);
        setBackground(m_bgColor);
        m_vertScr = new Scrollbar(1, 0, 1, 0, m_txtNumLns - 1);
        m_horzScr = new Scrollbar(0, 0, 1, 0, m_txtNumCols - 1);
        Color reallyLightGray = new Color(235, 235, 235);
        m_vertScr.setForeground(Color.gray);
        m_vertScr.setBackground(reallyLightGray);
        m_horzScr.setForeground(Color.gray);
        m_horzScr.setBackground(reallyLightGray);
        setLayout(new BorderLayout());
        add("East", m_vertScr);
        add("South", m_horzScr);
        if(!m_horzScroll)
            m_horzScr.hide();
        m_fontH = m_fontMet.getHeight();
        m_textArr = new String[m_txtNumLns];
        mLineFlags = new int[m_txtNumLns];
        m_txtTopPtr = 0;
        m_txtLeftPtr = 0;
    }

    public void paint(Graphics g) {
        Dimension d = size();
        g.draw3DRect(0, 0, d.width, d.height, false);
        d.height -= 2;
        d.width -= 2;
        if(m_textArr == null) {
            g.clearRect(0, 0, d.width, d.height);
            return;
        }
        synchronized(m_textArr) {
            int availH = d.height - m_horzScr.size().height;
            int vRem = availH <= m_fontH ? 0 : availH % m_fontH;
            if(vRem > 0)
                availH -= m_fontH;
            m_visLns = availH <= m_fontH ? 1 : availH / m_fontH <= 1 ? 1 : availH / m_fontH + 1;
            int xPos = 5;
            int yPos = m_fontH;
            int yInc = m_fontH;
            FontMetrics fm = g.getFontMetrics();
            for(int x = m_txtTopPtr; x < m_arrHead && x < m_txtTopPtr + m_visLns; x++) {
                String drawStr = m_txtLeftPtr <= 0 ? m_textArr[x] == null ? null : m_textArr[x] : m_textArr[x] == null || m_textArr[x].length() <= m_txtLeftPtr ? null : m_textArr[x].substring(m_txtLeftPtr);
                if(drawStr != null) {
                    boolean isHeader;
                    if((mLineFlags[x] & LINE_HEADER) != 0)
                        isHeader = true;
                    else
                        isHeader = false;
                    drawAString(g, drawStr, xPos, yPos, fm, isHeader);
                }
                yPos += yInc;
            }

        }
    }

    private String[] wrapStr(String txt) {
        Vector strVect = new Vector();
        Vector wrkVect = new Vector();
        Dimension d = size();
        int availW = d.width - m_vertScr.size().width - 10;
        int maxLineLen = availW;
        for(StringTokenizer lft = new StringTokenizer(txt, "\r\n"); lft.hasMoreTokens(); wrkVect.addElement(lft.nextToken()));
        for(int x = 0; x < wrkVect.size(); x++) {
            String elem = (String)wrkVect.elementAt(x);
            int elemW = m_fontMet.stringWidth(elem);
            if(elemW <= maxLineLen) {
                strVect.addElement(elem);
            } else {
                Vector wordVect = new Vector();
                for(StringTokenizer st = new StringTokenizer(elem, " "); st.hasMoreTokens(); wordVect.addElement(st.nextToken()));
                String addStr = null;
                int pixWid = 0;
                for(int y = 0; y < wordVect.size(); y++) {
                    String currWord = new String(" " + (String)wordVect.elementAt(y) + " ");
                    int wordWid = m_fontMet.stringWidth(currWord);
                    if(wordWid > maxLineLen) {
                        m_horzScr.show();
                        validate();
                    }
                    pixWid += wordWid;
                    if(pixWid > maxLineLen) {
                        strVect.addElement(addStr);
                        addStr = currWord;
                        pixWid = m_fontMet.stringWidth(addStr);
                    } else
                    if(addStr == null)
                        addStr = currWord;
                    else
                        addStr += currWord;
                }

                if(addStr != null)
                    strVect.addElement(addStr);
            }
        }

        String retArr[] = new String[strVect.size()];
        for(int cpx = 0; cpx < retArr.length; cpx++) {
            String copyStr = ((String)strVect.elementAt(cpx)).trim();
            retArr[cpx] = copyStr != null ? copyStr : "";
        }

        return retArr;
    }

    public void show() {
        super.show();
        if(m_txtTopPtr == 0) {
            m_txtTopPtr = m_arrHead - m_visLns <= 0 ? 0 : m_arrHead - m_visLns;
            int max = m_vertScr.getMaximum();
            m_txtTopPtr = m_txtTopPtr <= max ? m_txtTopPtr : (max - m_visLns) + 1;
            m_vertScr.setValue(m_txtTopPtr);
        }
        repaint(1000L);
    }

    private void checkForURLHit(int x, int y, boolean clickFlag) {
        int xPos = 5;
        StringTokenizer st;
        synchronized(m_textArr) {
            int line = m_txtTopPtr + (y - 4) / m_fontH;
            if((mLineFlags[line] & LINE_CONTAINS_URL) == 0) {
                mCore.setCursor(0);
                return;
            }
            st = new StringTokenizer(m_textArr[line]);
        }
        int spaceWidth = m_fontMet.stringWidth(" ");
        int numTokens = st.countTokens();
        for(int i = 0; i < numTokens; i++) {
            String s = st.nextToken();
            if(s.indexOf("://") != -1 && x >= xPos && x <= xPos + m_fontMet.stringWidth(s)) {
                if(clickFlag)
                    mCore.gotoURL(s, "PPSlideShow");
                else
                    mCore.setCursor(12);
                return;
            }
            xPos += m_fontMet.stringWidth(s);
            xPos += spaceWidth;
        }

        mCore.setCursor(0);
    }

    public boolean handleEvent(Event evt) {
        boolean handled = false;
        if(evt.target == m_vertScr && (evt.id == 602 || evt.id == 604 || evt.id == 601 || evt.id == 603 || evt.id == 605)) {
            int val = m_vertScr.getValue();
            if(m_txtTopPtr != val) {
                m_txtTopPtr = val;
                repaint(50L);
            }
            handled = true;
        } else
        if(evt.target == m_horzScr && (evt.id == 602 || evt.id == 601 || evt.id == 604 || evt.id == 603 || evt.id == 605)) {
            int val = m_horzScr.getValue();
            if(m_txtLeftPtr != val) {
                m_txtLeftPtr = val;
                repaint(50L);
            }
            handled = true;
        } else
        if(evt.target == this)
            if(evt.id == 501) {
                checkForURLHit(evt.x, evt.y, true);
                handled = true;
            } else
            if(evt.id == 503) {
                checkForURLHit(evt.x, evt.y, false);
                handled = true;
            } else
            if(evt.id == 505) {
                mCore.setCursor(0);
                handled = true;
            }
        return handled;
    }

    public void appendText(String txt) {
        String localStr = new String(txt);
        String wrapStrs[] = null;
        if(m_wrapping) {
            wrapStrs = wrapStr(localStr);
        } else {
            wrapStrs = new String[1];
            wrapStrs[0] = localStr;
        }
        int highIdx = m_arrHead + wrapStrs.length;
        synchronized(m_textArr) {
            if(highIdx > m_textArr.length) {
                int cutLines = m_cutNum;
                int numOver = highIdx - m_textArr.length;
                cutLines = numOver <= cutLines ? cutLines : numOver;
                System.arraycopy(m_textArr, cutLines, m_textArr, 0, m_textArr.length - cutLines);
                System.arraycopy(mLineFlags, cutLines, mLineFlags, 0, mLineFlags.length - cutLines);
                m_arrHead = m_textArr.length - 1 - cutLines;
                for(int x = m_arrHead; x < m_textArr.length; x++)
                    m_textArr[x] = null;

                System.gc();
                if(m_txtTopPtr <= cutLines) {
                    m_txtTopPtr = 0;
                    m_vertScr.setValue(m_txtTopPtr);
                } else {
                    m_txtTopPtr -= cutLines;
                    m_vertScr.setValue(m_txtTopPtr);
                }
            }
            for(int i = 0; i < wrapStrs.length; i++) {
                m_textArr[m_arrHead] = wrapStrs[i];
                if(i == 0)
                    mLineFlags[m_arrHead] = LINE_HEADER;
                else
                    mLineFlags[m_arrHead] = 0;
                if(wrapStrs[i].indexOf("://") != -1)
                    mLineFlags[m_arrHead] |= LINE_CONTAINS_URL;
                m_arrHead++;
            }

            m_vertScr.setValues(m_txtTopPtr, 1, 0, m_arrHead - 1);
            if(m_arrHead >= m_txtTopPtr + m_visLns + 1 && m_arrHead <= m_txtTopPtr + m_visLns + wrapStrs.length && m_visLns != 0) {
                m_txtTopPtr += wrapStrs.length;
                if(m_horzScr.isVisible())
                    m_txtTopPtr++;
                int max = m_vertScr.getMaximum();
                m_txtTopPtr = m_txtTopPtr <= max ? m_txtTopPtr : (max - m_visLns) + 1;
                m_vertScr.setValue(m_txtTopPtr);
            }
        }
        repaint(100L);
    }

}
