// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.utl.HighlightButton;
import communities.utl.ResourceInfo;
import java.awt.*;

// Referenced classes of package communities:
//            FaceButton

public class FaceCanvas extends Panel {

    private int mNumFaces;
    private FaceButton buttons[];
    private boolean mInitialized;
    private ResourceInfo mResInfo;

    public void depressButton(int faceID) {
        if(faceID > 0 && faceID <= mNumFaces) {
            for(int i = 0; i < mNumFaces; i++)
                if(faceID == buttons[i].getID())
                    buttons[i].stick();
                else
                    buttons[i].unStick();

        }
    }

    private boolean isInitialized() {
        return mInitialized;
    }

    public FaceCanvas(ResourceInfo resInfo) {
        mNumFaces = 0;
        buttons = null;
        mInitialized = false;
        mResInfo = null;
        mNumFaces = 13;
        mResInfo = resInfo;
    }

    public synchronized void paint(Graphics g) {
        checkInit();
        super.paint(g);
        Color save = g.getColor();
        g.setColor(Color.lightGray);
        g.draw3DRect(6, 6, size().width - 12, size().height - 13, false);
        g.setColor(save);
    }

    public Dimension minimumSize() {
        int width = 208;
        int height = 260;
        return new Dimension(width, height);
    }

    public void checkInit() {
        if(!isInitialized())
            init();
    }

    public void buttonClicked(FaceButton faceButton) {
        for(int i = 0; i < mNumFaces; i++)
            if(buttons[i] != faceButton)
                buttons[i].unStick();

    }

    public int getFaceID() {
        int id = 0;
        for(int i = 0; i < mNumFaces; i++) {
            if(!buttons[i].isStuck())
                continue;
            id = buttons[i].getID();
            break;
        }

        return id;
    }

    public Dimension preferredSize() {
        Dimension minSize = minimumSize();
        int width = minSize.width + 10;
        int height = minSize.height + 4;
        return new Dimension(width, height);
    }

    private void init() {
        int centerX = size().width / 2;
        int centerY = size().height / 2;
        int x[] = {
            centerX - 26, centerX - 104, centerX - 52, centerX, centerX + 52, centerX - 104, centerX - 52, centerX, centerX + 52, centerX - 104, 
            centerX - 52, centerX, centerX + 52
        };
        int y[] = {
            centerY - 104, centerY - 52, centerY - 52, centerY - 52, centerY - 52, centerY, centerY, centerY, centerY, centerY + 52, 
            centerY + 52, centerY + 52, centerY + 52
        };
        setLayout(null);
        int expressionOrder[] = {
            8, 9, 5, 7, 2, 1, 10, 12, 3, 0, 
            11, 4, 6
        };
        buttons = new FaceButton[mNumFaces];
        for(int i = 0; i < mNumFaces; i++) {
            Point loc = new Point(x[i] + 1, y[i] + 1);
            Dimension size = new Dimension(50, 50);
            buttons[i] = new FaceButton(mResInfo.getFace(expressionOrder[i], ResourceInfo.YELLOW), expressionOrder[i], this);
            add(buttons[i]);
            buttons[i].move(loc.x, loc.y);
        }

        buttons[0].stick();
        setInitialized(true);
    }

    private void setInitialized(boolean initialized) {
        mInitialized = initialized;
    }
}
