// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.pkt.PPEventUserFace;
import communities.pkt.PPEventUserName;
import communities.pob.Room;
import communities.pob.User;
import java.awt.*;

// Referenced classes of package communities:
//            IPalaceCore, FaceCanvas, NameField

public class FaceControl extends Panel {

    IPalaceCore itsCore;
    FaceCanvas faceCanvas;
    Button okButton;
    Label nameLabel;
    NameField nameField;
    boolean bInitialized;

    public void refreshFaces() {
        if(faceCanvas != null) {
            faceCanvas.getParent().remove(faceCanvas);
            faceCanvas = null;
        }
        faceCanvas = new FaceCanvas(itsCore.getResourceInfo());
        faceCanvas.reshape(2, 2, 226, 224);
        add(faceCanvas);
    }

    public FaceControl(IPalaceCore itsCore) {
        this.itsCore = null;
        faceCanvas = null;
        okButton = null;
        nameLabel = null;
        nameField = null;
        bInitialized = false;
        this.itsCore = itsCore;
        setLayout(null);
        refreshFaces();
        nameField = new NameField(32, 20);
        nameField.reshape(6, 226, 152, 24);
        add(nameField);
        okButton = new Button("Apply");
        okButton.reshape(162, 226, 60, 24);
        add(okButton);
    }

    public void paint(Graphics g) {
        if(!bInitialized) {
            faceCanvas.checkInit();
            nameField.setText(itsCore.getUserName());
            nameField.selectAll();
            nameField.requestFocus();
            int id = itsCore.getUserID();
            User user = itsCore.getRoom().getUser(id);
            if(user != null)
                faceCanvas.depressButton(user.getFaceNbr());
            bInitialized = true;
        }
        super.paint(g);
        Color save = g.getColor();
        Dimension size = size();
        g.setColor(Color.white);
        g.drawRect(1, 1, size.width - 2, size.height - 2);
        g.setColor(Color.gray);
        g.drawRect(0, 0, size.width - 2, size.height - 2);
        g.setColor(save);
    }

    private String cutToLegalLength(String name) {
        if(name.length() <= 20)
            return name;
        else
            return name.substring(0, 20);
    }

    public boolean action(Event e, Object arg) {
        boolean handled = false;
        if(e.target == okButton) {
            int faceNbr = faceCanvas.getFaceID();
            int id = itsCore.getUserID();
            User user = itsCore.getRoom().getUser(id);
            if(faceNbr != user.getFaceNbr()) {
                itsCore.getRoom().setUserFaceNbr(id, faceNbr);
                PPEventUserFace upf = new PPEventUserFace(id, faceNbr);
                itsCore.sendPPEvent(upf);
            }
            String newName = cutToLegalLength(nameField.getText());
            if(newName.compareTo(itsCore.getUserName()) != 0) {
                itsCore.setUserName(newName);
                user.setName(newName);
                PPEventUserName upn = new PPEventUserName(id, newName);
                itsCore.sendPPEvent(upn);
                itsCore.showStatus();
            }
            handled = true;
        } else {
            handled = super.action(e, arg);
        }
        return handled;
    }
}
