// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import java.awt.*;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;
import java.io.PrintStream;

public class PCycleCanvas extends Canvas
    implements Runnable {

    Image normalP;
    Image cycleImage;
    Image offImage;
    MemoryImageSource src;
    Thread runThread;
    int pixels[];
    int cPixels[];
    boolean cycleMode;
    int easterMode;
    int xA[];
    int yA[];
    int zA[];
    int f;
    private static int gSeed;

    private static int random() {
        int hi = gSeed / 0x1f31d;
        int lo = gSeed % 0x1f31d;
        int test = 16807 * lo - 2836 * hi;
        if(test > 0)
            gSeed = test;
        else
            gSeed = test + 0x7fffffff;
        return gSeed;
    }

    double RandPoint3D(int x, int y, int z) {
        int sr = getSRand();
        mySRand(xA[x & 0xff] ^ yA[y & 0xff] ^ zA[z & 0xff]);
        double r = doubleRandom();
        mySRand(sr);
        return r;
    }

    private static int getSRand() {
        return gSeed;
    }

    public void draw(Graphics g) {
        g.setColor(new Color(0xffe0e0e0));
        g.drawLine(0, 0, 33, 0);
        g.drawLine(0, 0, 0, 33);
        g.setColor(new Color(0xff808080));
        g.drawLine(33, 1, 33, 33);
        g.drawLine(1, 33, 33, 33);
        g.setColor(Color.black);
        if(!cycleMode) {
            if(normalP != null)
                g.drawImage(normalP, 1, 1, this);
        } else
        if(cycleImage != null) {
            cycleImage.flush();
            g.drawImage(cycleImage, 1, 1, this);
        }
    }

    public PCycleCanvas(Image normalP) {
        this.normalP = null;
        cycleImage = null;
        offImage = null;
        src = null;
        runThread = null;
        cycleMode = false;
        easterMode = 0;
        f = 1;
        this.normalP = normalP;
        pixels = new int[1024];
        cPixels = new int[1024];
        xA = new int[256];
        yA = new int[256];
        zA = new int[256];
        gSeed = (int)(System.currentTimeMillis() & 0xffffffffL);
        for(int i = 0; i < 256; i++) {
            random();
            xA[i] = gSeed;
            random();
            yA[i] = gSeed;
            random();
            zA[i] = gSeed;
        }

    }

    public void addNotify() {
        super.addNotify();
        if(offImage == null)
            offImage = createImage(34, 34);
        src = new MemoryImageSource(32, 32, pixels, 0, 32);
        cycleImage = createImage(src);
        PixelGrabber pg = new PixelGrabber(normalP, 0, 0, 32, 32, cPixels, 0, 32);
        try {
            pg.grabPixels();
        }
        catch(InterruptedException e) {
            System.err.println("interrupted  waiting  for  pixels!");
            return;
        }
        if(runThread != null)
            runThread.stop();
        runThread = new Thread(this, "PCycleCanvas");
        runThread.setPriority(1);
        try {
            runThread.setDaemon(true);
        }
        catch(Exception e) { }
        runThread.start();
    }

    public void paint(Graphics g) {
        Graphics offImageG = null;
        try {
            offImageG = offImage.getGraphics();
            draw(offImageG);
            offImageG.dispose();
        }
        finally {
            g.drawImage(offImage, 0, 0, this);
        }
    }

    public synchronized boolean setCycleState(boolean cycleFlag) {
        if(runThread != null)
            synchronized(runThread) {
                cycleMode = cycleFlag;
                if(!cycleMode);
                notifyAll();
            }
        return true;
    }

    void computeCycleFrame() {
        int index = 0;
        double fdScroll = (double)f * 0.050000000000000003D;
        double fdColorCycleSpeed = (double)f * 0.029999999999999999D;
        double fdMutate = (double)f * 0.02D;
        double scaleFactor = 127.5D;
        switch(easterMode) {
        case 0: // '\0'
            int y = 0;
            for(int yd = -16; y < 32; yd++) {
                int x = 0;
                for(int xd = -16; x < 32; xd++) {
                    int m = cPixels[index];
                    int v;
                    if((m & 0xff) > 64) {
                        double sina = noise3d((double)x / 32D, (double)y / 32D + fdScroll, fdMutate);
                        double rd = Math.sin(sina * 12D + fdColorCycleSpeed);
                        double gd = Math.sin(sina * 10D - fdColorCycleSpeed);
                        double bd = Math.sin(sina * 8D);
                        int r = (int)((rd + 1.0D) * scaleFactor);
                        int g = (int)((gd + 1.0D) * scaleFactor);
                        int b = (int)((bd + 1.0D) * scaleFactor);
                        r &= 0x7f;
                        g |= 0x80;
                        b |= 0x80;
                        v = 0xff000000 | r << 16 | g << 8 | b;
                    } else {
                        v = cPixels[index];
                    }
                    pixels[index++] = v;
                    x++;
                }

                y++;
            }

            break;
        }
        f++;
    }

    public Dimension minimumSize() {
        return preferredSize();
    }

    public void update(Graphics g) {
        paint(g);
    }

    private static void mySRand(int s) {
        gSeed = s;
        if(gSeed == 0)
            gSeed = 1;
    }

    double noise3d(double x, double y, double z) {
        int ix = (int)x;
        int iy = (int)y;
        int iz = (int)z;
        double dx = x - (double)ix;
        double dy = y - (double)iy;
        double dz = z - (double)iz;
        dx *= dx * (3D - 2D * dx);
        dy *= dy * (3D - 2D * dy);
        dz *= dz * (3D - 2D * dz);
        double j1 = (1.0D - dx) * RandPoint3D(ix, iy, iz) + dx * RandPoint3D(ix + 1, iy, iz);
        double j2 = (1.0D - dx) * RandPoint3D(ix, iy + 1, iz) + dx * RandPoint3D(ix + 1, iy + 1, iz);
        double j3 = (1.0D - dy) * j1 + dy * j2;
        if(dz == 0.0D) {
            return j3;
        } else {
            double k1 = (1.0D - dx) * RandPoint3D(ix, iy, iz + 1) + dx * RandPoint3D(ix + 1, iy, iz + 1);
            double k2 = (1.0D - dx) * RandPoint3D(ix, iy + 1, iz + 1) + dx * RandPoint3D(ix + 1, iy + 1, iz + 1);
            double k3 = (1.0D - dy) * k1 + dy * k2;
            return (1.0D - dz) * j3 + dz * k3;
        }
    }

    public Dimension preferredSize() {
        return new Dimension(34, 34);
    }

    private static double doubleRandom() {
        return (double)random() / 2147483647D;
    }

    public void run() {
        Thread thread = runThread;
        JVM INSTR monitorenter ;
        do {
            while(cycleMode)  {
                if(easterMode == -1)
                    runThread.wait(200L);
                else
                    runThread.wait(50L);
                computeCycleFrame();
                repaint();
            }
            runThread.wait();
            repaint();
        } while(true);
        thread;
        JVM INSTR monitorexit ;
        throw ;
        InterruptedException e;
        e;
        break MISSING_BLOCK_LABEL_86;
        NullPointerException npe;
        npe;
    }

    public synchronized void removeNotify() {
        if(runThread != null)
            synchronized(runThread) {
                runThread.stop();
                runThread = null;
            }
        super.removeNotify();
    }
}
