// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:18 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.pob.GraphicError;
import communities.pob.Hotspot;
import communities.pob.Room2D;
import communities.utl.AppletStatus;
import communities.utl.ResourceInfo;
import java.awt.*;

// Referenced classes of package communities:
//            IPalaceCore, PalaceErrorHandler, IPalaceUI

public class Palace2DCanvas extends Canvas {

    Room2D itsRoom;
    IPalaceCore itsApplet;
    boolean bFakeMouse;
    Hotspot fhs;
    public Rectangle fakeDoorRect;
    int width;
    int height;
    private int frozenCtr;
    private boolean redrawNeeded;
    Image bg;
    Image offScreenImage;
    private GraphicError ge;

    public void setRedrawNeeded(boolean f) {
        redrawNeeded = f;
    }

    public void redraw() {
        redrawNeeded = true;
        if(frozenCtr == 0) {
            redrawNeeded = false;
            repaint(250L);
        }
    }

    public Palace2DCanvas(Room2D itsRoom, IPalaceCore itsApplet) {
        this.itsRoom = null;
        this.itsApplet = null;
        bFakeMouse = false;
        fhs = null;
        fakeDoorRect = null;
        width = 512;
        height = 384;
        frozenCtr = 0;
        redrawNeeded = false;
        bg = null;
        offScreenImage = null;
        ge = null;
        this.itsRoom = itsRoom;
        this.itsApplet = itsApplet;
        if(itsApplet.getResourceInfo().tutorialEnabled) {
            fhs = new Hotspot();
            fhs.type = 1;
            Polygon p = new Polygon();
            p.addPoint(100, 50);
            p.addPoint(100, 300);
            p.addPoint(250, 300);
            p.addPoint(250, 50);
            fhs.polygon = p;
            fakeDoorRect = new Rectangle(100, 50, 150, 250);
        }
    }

    public void addNotify() {
        super.addNotify();
        if(offScreenImage == null) {
            ResourceInfo resInfo = itsApplet.getResourceInfo();
            width = resInfo.roomWindowRect.width;
            height = resInfo.roomWindowRect.height;
            offScreenImage = createImage(width, height);
        }
        if(itsRoom != null)
            itsRoom.addNotify();
    }

    public synchronized void paint(Graphics g) {
        redrawNeeded = false;
        Graphics offScreenG = offScreenImage.getGraphics();
        try {
            if(ge == null)
                itsRoom.draw(offScreenG);
            else
                try {
                    ge.draw(offScreenG, 0, 0, width, height);
                }
                catch(Exception theE) {
                    itsApplet.getErrorHandler().reportError("Problems drawing ge: " + theE.getMessage(), 1);
                }
        }
        finally {
            offScreenG.dispose();
        }
        g.drawImage(offScreenImage, 0, 0, this);
    }

    public Dimension minimumSize() {
        return preferredSize();
    }

    public void freeze(boolean freezeFlag) {
        synchronized(this) {
            if(freezeFlag) {
                frozenCtr++;
            } else {
                frozenCtr--;
                if(frozenCtr <= 0)
                    frozenCtr = 0;
            }
        }
        redrawIfNeeded();
    }

    public void drawRightNow() {
        repaint(1L);
    }

    public void update(Graphics g) {
        paint(g);
    }

    public void resetGraphicError() {
        ge = null;
    }

    public Dimension preferredSize() {
        return new Dimension(width, height);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
        case 505: // Event.MOUSE_EXIT
            itsApplet.setCursor(0);
            itsRoom.setHotspotTarget(null);
            return true;

        case 504: // Event.MOUSE_EVENT
            if(itsApplet.isNavInProgress())
                itsApplet.setCursor(3);
            return true;

        case 501: // Event.MOUSE_DOWN
            if(itsApplet.getAppletStatus().introInProgress && itsApplet.getAppletStatus().introState == 4 && fakeDoorRect.inside(evt.x, evt.y)) {
                itsApplet.setCursor(0);
                itsApplet.getAppletStatus().introState++;
                itsApplet.getUI().showHowToChat();
                return true;
            }
            if(!itsApplet.isNavInProgress()) {
                itsRoom.checkHotspots(evt.x, evt.y, true);
                if(!itsApplet.getAppletStatus().msFlag)
                    itsApplet.setInputFocus();
            }
            return true;

        case 503: // Event.MOUSE_MOVE
            if(itsApplet.getAppletStatus().introInProgress && (itsApplet.getAppletStatus().introState == 3 || itsApplet.getAppletStatus().introState == 4)) {
                if(fakeDoorRect.inside(evt.x, evt.y)) {
                    itsApplet.getRoom().setHotspotTarget(fhs);
                    itsApplet.setCursor(12);
                } else {
                    itsApplet.getRoom().setHotspotTarget(null);
                    itsApplet.setCursor(0);
                }
                return true;
            }
            long startTime = System.currentTimeMillis();
            if(!itsApplet.isNavInProgress() && itsRoom != null)
                if(itsRoom.checkHotspots(evt.x, evt.y, false))
                    itsApplet.setCursor(12);
                else
                    itsApplet.setCursor(0);
            return true;

        case 502: // Event.MOUSE_UP
        default:
            return super.handleEvent(evt);
        }
    }

    public void redrawIfNeeded() {
        if(redrawNeeded)
            redraw();
    }

    public void createGraphicError(String errorText) {
        Font theFont = new Font("TimesRoman", 0, 20);
        ge = new GraphicError(errorText, theFont);
        redraw();
    }
}
