// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:30 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import communities.utl.ResourceInfo;
import java.awt.*;
import java.io.IOException;
import java.io.InputStream;

// Referenced classes of package communities:
//            PalaceErrorHandler, IPalaceUI

public final class PalaceHelp extends Panel
    implements Privileged {

    private TextArea mTextArea;
    private IPalaceUI mUI;
    PalaceErrorHandler mErrorHandler;
    FontMetrics mFontMetrics;
    ResourceInfo mResInfo;
    private int maxLineLen;
    private boolean helpFileInitialized;
    int miHelpType;
    private transient IPalaceSecurity mSecurity;

    public void setSecurity(IPalaceSecurity m) {
        mSecurity = m;
    }

    public PalaceHelp(PalaceErrorHandler errorHandler, ResourceInfo resInfo, IPalaceUI itsUI, int iHelpType) {
        mTextArea = null;
        mUI = null;
        mErrorHandler = null;
        mFontMetrics = null;
        mResInfo = null;
        maxLineLen = 200;
        helpFileInitialized = false;
        miHelpType = 0;
        miHelpType = iHelpType;
        mUI = itsUI;
        mResInfo = resInfo;
        mErrorHandler = errorHandler;
        setLayout(new BorderLayout());
        mTextArea = new TextArea(1, 1);
        mTextArea.setEditable(false);
        mTextArea.setBackground(Color.white);
        Font f = new Font("Helvetica", 0, 12);
        mTextArea.setFont(f);
        mFontMetrics = mTextArea.getFontMetrics(f);
        add("Center", mTextArea);
    }

    public void paint(Graphics g) {
        Color save = g.getColor();
        Dimension size = size();
        g.setColor(Color.white);
        g.drawRect(1, 1, size.width - 2, size.height - 2);
        g.setColor(Color.gray);
        g.drawRect(0, 0, size.width - 2, size.height - 2);
        g.setColor(save);
    }

    protected void WrapBytes(StringBuffer strBuffer) {
        int i = 0;
        int lineLen = 0;
        for(int len = strBuffer.length(); i < len; i++) {
            char c = strBuffer.charAt(i);
            if(c == '\n')
                lineLen = 0;
            else
                lineLen += mFontMetrics.charWidth(c);
            if(lineLen >= maxLineLen) {
                int bookmark = findPrevSpace(strBuffer, i);
                if(bookmark > 0) {
                    strBuffer.setCharAt(bookmark, '\n');
                    lineLen = 0;
                    i = bookmark;
                }
            }
        }

    }

    protected void getHelpFile(ResourceInfo resInfo) {
        java.net.URL helpURL;
        if(miHelpType == 1)
            helpURL = resInfo.getPalPresentsHelpFile();
        else
            helpURL = resInfo.getHelpFile();
        if(helpURL != null) {
            int bytesRead = 0;
            byte buf[] = new byte[4096];
            InputStream is = null;
            StringBuffer strBuffer = new StringBuffer();
            try {
                PalaceHelp$OpenHelpFile g = new PalaceHelp$OpenHelpFile(this, helpURL);
                mSecurity.connectTo(helpURL, g);
                is = g.mInputStream;
                if(is != null) {
                    while((bytesRead = is.read(buf)) != -1)  {
                        String hs = new String(buf, 0, 0, bytesRead);
                        strBuffer.append(hs);
                    }
                    WrapBytes(strBuffer);
                    mTextArea.appendText(strBuffer.toString());
                }
            }
            catch(IOException e) {
                mErrorHandler.reportError("Error reading helpfile: " + e.getMessage(), 1);
            }
            mTextArea.select(0, 1);
        }
    }

    private int findPrevSpace(StringBuffer strBuffer, int start) {
        int i;
        for(i = start; i >= 0 && strBuffer.charAt(i) != ' '; i--);
        return i;
    }

    public Insets insets() {
        return new Insets(3, 3, 3, 3);
    }

    public void reshape(int x, int y, int width, int height) {
        super.reshape(x, y, width, height);
        maxLineLen = width - 38;
        if(!helpFileInitialized) {
            getHelpFile(mResInfo);
            helpFileInitialized = true;
        }
    }
}
