// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:36 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.pob.User;
import communities.utl.ResourceInfo;
import java.awt.*;

// Referenced classes of package communities:
//            CoolLog, IPalaceCore

public class PalaceLog extends Panel {

    private Object mTextArea;
    private int mLogLen;
    private FontMetrics mFontMetrics;
    private Font mLogFont;
    private int maxLineLen;
    private int mLogBuffSize;
    private ResourceInfo mResInfo;
    private IPalaceCore mCore;
    private int mAreaType;

    public PalaceLog(IPalaceCore core, ResourceInfo resInfo) {
        mTextArea = null;
        mLogLen = 0;
        mFontMetrics = null;
        mLogFont = null;
        maxLineLen = 200;
        mLogBuffSize = 600;
        mAreaType = 2;
        mCore = core;
        mResInfo = resInfo;
        setLayout(null);
        switch(mResInfo.logType) {
        case 1: // '\001'
            mAreaType = 1;
            setTypeOld();
            break;

        case 2: // '\002'
            mAreaType = 2;
            mLogBuffSize = mResInfo.logBuffSize;
            setTypeCool();
            break;

        default:
            setTypeCool();
            break;
        }
        mLogFont = mResInfo.logFont;
        mFontMetrics = getFontMetrics(mLogFont);
    }

    public void hide() {
        super.hide();
        switch(mAreaType) {
        case 1: // '\001'
            remove((TextArea)mTextArea);
            break;

        case 2: // '\002'
            remove((CoolLog)mTextArea);
            break;
        }
    }

    public void paint(Graphics g) {
        Color save = g.getColor();
        Dimension size = size();
        g.setColor(Color.white);
        g.drawRect(1, 1, size.width - 2, size.height - 2);
        g.setColor(Color.gray);
        g.drawRect(0, 0, size.width - 2, size.height - 2);
        g.setColor(save);
    }

    public void logText(User u, String msg, boolean privateFlag) {
        String logMsg;
        if(u != null) {
            if(privateFlag)
                logMsg = new String("* " + u.name + " *   " + msg + "\n- - - -\n");
            else
                logMsg = new String(u.name + ":   " + msg + "\n- - - -\n");
        } else {
            logMsg = new String("*** " + msg + "\n- - - -\n");
        }
        switch(mAreaType) {
        case 1: // '\001'
            int lineLen = 0;
            int i = 0;
            int msgLen = logMsg.length();
            char msgChars[] = new char[msgLen];
            logMsg.getChars(0, msgLen, msgChars, 0);
            mLogLen += msgLen;
            if(mLogLen > 16384) {
                String logText = ((TextArea)mTextArea).getText();
                mLogLen = logText.length();
                char logChars[] = new char[mLogLen];
                logText.getChars(0, mLogLen, logChars, 0);
                mLogLen -= 4096;
                String newLogText = new String(logChars, 4095, mLogLen);
                ((TextArea)mTextArea).setText(newLogText);
                ((TextArea)mTextArea).appendText("\n");
                mLogLen++;
            }
            for(; i < msgLen; i++) {
                if(msgChars[i] == '\n')
                    lineLen = 0;
                else
                    lineLen += mFontMetrics.charWidth(msgChars[i]);
                if(lineLen >= maxLineLen) {
                    int bookmark = i;
                    while(msgChars[i] != ' ')  {
                        if(--i <= 0) {
                            i = bookmark;
                            break;
                        }
                        if(msgChars[i] == ' ') {
                            msgChars[i] = '\n';
                            lineLen = 0;
                            break;
                        }
                    }
                }
            }

            String newMsg = new String(msgChars);
            ((TextArea)mTextArea).appendText(newMsg);
            break;

        case 2: // '\002'
            ((CoolLog)mTextArea).appendText(logMsg);
            break;
        }
    }

    private void setTypeOld() {
        mTextArea = new TextArea(1, 1);
        ((TextArea)mTextArea).setEditable(false);
        ((TextArea)mTextArea).setBackground(Color.white);
        add((TextArea)mTextArea);
    }

    private void setTypeCool() {
        mTextArea = new CoolLog(mCore, mLogBuffSize, 40, mResInfo.logFontColor, Color.white, mResInfo.logNameColor, mResInfo.logPrivateColor, mResInfo.logSystemColor, true, false, mLogFont);
        add((CoolLog)mTextArea);
    }

    public void show() {
        switch(mAreaType) {
        case 1: // '\001'
            add((TextArea)mTextArea);
            ((TextArea)mTextArea).show();
            break;

        case 2: // '\002'
            add((CoolLog)mTextArea);
            ((CoolLog)mTextArea).show();
            break;
        }
        super.show();
    }

    public Insets insets() {
        return new Insets(3, 3, 3, 3);
    }

    public void reshape(int x, int y, int width, int height) {
        if(mTextArea != null) {
            int hInset = 2;
            int vInset = 2;
            switch(mAreaType) {
            case 1: // '\001'
                ((TextArea)mTextArea).reshape(3 + hInset, 3 + vInset, width - 6 - vInset * 2, height - 6 - hInset * 2);
                break;

            case 2: // '\002'
                ((CoolLog)mTextArea).reshape(3 + hInset, 3 + vInset, width - 6 - vInset * 2, height - 7 - hInset * 2);
                break;
            }
        }
        super.reshape(x, y, width, height);
        maxLineLen = width - 38;
    }
}
