// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:43 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.plg.ImageButton;
import communities.utl.ButtonInfo;
import communities.utl.ResourceInfo;
import java.awt.*;

// Referenced classes of package communities:
//            ButtonPanel, IPalaceUI, IPalaceCore

public class PalaceNavBar extends ButtonPanel {

    private IPalaceUI mUI;
    private IPalaceCore mCore;
    private int mRows;
    private int mCols;
    int numButtons;
    ButtonInfo buttonInfo[];
    ImageButton imageButtons[];
    int mButtonWidth;
    int mButtonHeight;
    String btnHelpStrings[] = {
        "Back", "Forward"
    };

    public static PalaceNavBar createNavBar(IPalaceUI itsUI, int orientation) {
        PalaceNavBar bar = new PalaceNavBar(itsUI, orientation);
        return bar;
    }

    public PalaceNavBar(IPalaceUI itsUI, int orientation) {
        super(2, itsUI.getCore());
        mUI = itsUI;
        mCore = mUI.getCore();
        buttonInfo = new ButtonInfo[2];
        buttonInfo[0] = new ButtonInfo(mCore.getResourceInfo().getIcon("back-n"), mCore.getResourceInfo().getIcon("back-d"), mCore.getResourceInfo().getIcon("back-e"), null, 1);
        buttonInfo[1] = new ButtonInfo(mCore.getResourceInfo().getIcon("forward-n"), mCore.getResourceInfo().getIcon("forward-d"), mCore.getResourceInfo().getIcon("forward-e"), null, 2);
        numButtons = 2;
        if(orientation == 0) {
            mRows = 1;
            mCols = 2;
        } else {
            mRows = 2;
            mCols = 1;
        }
        setLayout(null);
        imageButtons = new ImageButton[numButtons];
        mButtonWidth = 28;
        mButtonHeight = 28;
        resize(mButtonWidth * mCols + 8, mButtonHeight * mRows + 8);
        int buttonNum = 0;
        for(int r = 0; r < mRows; r++) {
            for(int c = 0; c < mCols; c++) {
                imageButtons[buttonNum] = new ImageButton(buttonInfo[buttonNum].enabledImage, buttonInfo[buttonNum].hilitedImage, buttonInfo[buttonNum].depressedImage, buttonInfo[buttonNum].disabledImage, mButtonWidth, mButtonHeight, 12, 4);
                if(imageButtons[buttonNum] != null) {
                    imageButtons[buttonNum].move(4 + c * mButtonWidth, 4 + r * mButtonHeight);
                    addButton(imageButtons[buttonNum], btnHelpStrings[buttonNum]);
                }
                buttonNum++;
            }

        }

    }

    public void paint(Graphics g) {
        Dimension size = size();
        Color save = g.getColor();
        g.setColor(Color.white);
        g.drawRect(1, 1, size.width - 2, size.height - 2);
        g.setColor(Color.gray);
        g.drawRect(0, 0, size.width - 2, size.height - 2);
        g.setColor(save);
    }

    public ImageButton getButton(int buttonNum) {
        if(buttonNum >= 0 && buttonNum < numButtons)
            return imageButtons[buttonNum];
        else
            return null;
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
        default:
            break;

        case 1001: // Event.ACTION_EVENT
            if(evt.target == imageButtons[0]) {
                mUI.goBack();
                break;
            }
            if(evt.target == imageButtons[1])
                mUI.goForward();
            break;
        }
        return super.handleEvent(evt);
    }
}
