// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:46 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.adm.IAdministrator;
import communities.plg.EventListPanel;
import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import communities.utl.ButtonInfo;
import communities.utl.ResourceInfo;
import java.awt.*;

// Referenced classes of package communities:
//            PalaceLog, PalaceUserList, IPalaceUI, PalaceRoomList, 
//            IPalaceCore, PalaceHelp, FaceControl, PalaceSoundPanel, 
//            AboutPanel, TabPanelButtonBar

public final class PalaceNewTabPanel extends Panel
    implements Privileged {

    private Container mContainer;
    private TabPanelButtonBar mButtonBar;
    public IPalaceCore itsCore;
    public IPalaceUI itsUI;
    public ResourceInfo mResInfo;
    private Dialog itsFrame;
    private PalaceLog mLog;
    private PalaceUserList mUserList;
    private PalaceRoomList mRoomList;
    private PalaceSoundPanel mSoundPanel;
    private FaceControl mFaceCanvas;
    private EventListPanel mEventListPanel;
    private PalaceHelp mHelp;
    private AboutPanel mAbout;
    private int numPanelsEnabled;
    protected static final String iconNames[] = {
        "log", "users", "rooms", "help", "avatar", "events", "sound", "about", "admin", "urls"
    };
    private transient IPalaceSecurity mSecurity;

    protected Container getContainer() {
        return mContainer;
    }

    public TabPanelButtonBar getButtonBar() {
        return mButtonBar;
    }

    private void addTabsAndButtons() {
        ButtonInfo info[] = null;
        if(mResInfo.buttonPanelEnabled)
            info = new ButtonInfo[iconNames.length];
        Component component = null;
        for(int i = 0; i < 10; i++) {
            switch(i) {
            case 0: // '\0'
                if(mResInfo.logPanelEnabled) {
                    mLog = new PalaceLog(itsCore, mResInfo);
                    component = mLog;
                }
                break;

            case 1: // '\001'
                if(mResInfo.userPanelEnabled) {
                    mUserList = new PalaceUserList(itsCore);
                    component = mUserList;
                }
                break;

            case 2: // '\002'
                if(mResInfo.roomPanelEnabled) {
                    mRoomList = new PalaceRoomList(itsUI.getCore());
                    component = mRoomList;
                }
                break;

            case 3: // '\003'
                if(mResInfo.helpPanelEnabled) {
                    mHelp = new PalaceHelp(itsCore.getErrorHandler(), mResInfo, itsUI, 0);
                    mHelp.setSecurity(mSecurity);
                    component = mHelp;
                }
                break;

            case 4: // '\004'
                if(mResInfo.avatarPanelEnabled) {
                    mFaceCanvas = new FaceControl(itsCore);
                    component = mFaceCanvas;
                }
                break;

            case 5: // '\005'
                if(mResInfo.eventsPanelEnabled) {
                    mEventListPanel = new EventListPanel(itsUI);
                    component = mEventListPanel;
                }
                break;

            case 6: // '\006'
                if(mResInfo.soundPanelEnabled) {
                    mSoundPanel = new PalaceSoundPanel(itsUI.getCore(), mResInfo, mSecurity);
                    component = mSoundPanel;
                }
                break;

            case 7: // '\007'
                if(mResInfo.aboutPanelEnabled) {
                    mAbout = new AboutPanel(itsUI);
                    component = mAbout;
                }
                break;

            case 8: // '\b'
                if(mResInfo.adminPanelEnabled && mResInfo.appletMode == 5)
                    component = itsCore.getAdmin().addAdminPanel();
                break;

            case 9: // '\t'
                if(mResInfo.urlPanelEnabled && mResInfo.appletMode == 5)
                    component = itsCore.getAdmin().addURLPanel();
                break;

            default:
                component = null;
                break;
            }
            if(component != null) {
                component.reshape(0, 0, mResInfo.tabPanelRect.width, mResInfo.tabPanelRect.height);
                mContainer.add(String.valueOf(3 + i), component);
                if(mResInfo.buttonPanelEnabled) {
                    int id = 3 + i;
                    java.awt.Image enabledImage = mResInfo.getIcon(iconNames[i] + "-n");
                    java.awt.Image disabledImage = mResInfo.getIcon(iconNames[i] + "-d");
                    java.awt.Image hilitedImage = mResInfo.getIcon(iconNames[i] + "-e");
                    java.awt.Image depressedImage = null;
                    if(!mResInfo.buttonsHilight)
                        depressedImage = mResInfo.getIcon(iconNames[i] + "-p");
                    info[numPanelsEnabled] = new ButtonInfo(enabledImage, disabledImage, hilitedImage, depressedImage, id);
                }
                numPanelsEnabled++;
            }
            component = null;
        }

        if(mResInfo.buttonPanelEnabled) {
            int imageSize = 45;
            int cols = mResInfo.buttonPanelRect.width / imageSize;
            int rows = numPanelsEnabled / cols;
            if(rows * cols < numPanelsEnabled)
                rows++;
            mButtonBar = new TabPanelButtonBar(numPanelsEnabled, info, imageSize, imageSize, rows, cols, this);
        }
    }

    public PalaceRoomList getRoomList() {
        return mRoomList;
    }

    public PalaceLog getLog() {
        return mLog;
    }

    protected synchronized Component getCurrComponent() {
        int index = getCurrComponentIndex();
        if(index != -1)
            return mContainer.getComponent(index);
        else
            return null;
    }

    public PalaceNewTabPanel(IPalaceUI UI, IPalaceCore applet, IPalaceSecurity aSecurity, ResourceInfo resInfo, Dialog parentFrame) {
        mContainer = null;
        mButtonBar = null;
        mResInfo = null;
        itsFrame = null;
        mLog = null;
        mUserList = null;
        mRoomList = null;
        mSoundPanel = null;
        mFaceCanvas = null;
        mEventListPanel = null;
        mHelp = null;
        mAbout = null;
        numPanelsEnabled = 0;
        itsCore = applet;
        mResInfo = resInfo;
        mSecurity = aSecurity;
        itsFrame = parentFrame;
        itsUI = UI;
        setLayout(null);
        mContainer = new Panel();
        mContainer.setLayout(new CardLayout(0, 0));
        mContainer.reshape(0, 0, mResInfo.tabPanelRect.width, mResInfo.tabPanelRect.height);
        add(mContainer);
        addTabsAndButtons();
    }

    public PalaceUserList getUserList() {
        return mUserList;
    }

    public EventListPanel getEventListPanel() {
        return mEventListPanel;
    }

    public void refreshPanels() {
        if(mResInfo.buttonPanelEnabled && mResInfo.logPanelEnabled && itsFrame == null)
            mButtonBar.depress(3);
        if(mFaceCanvas != null)
            mFaceCanvas.refreshFaces();
    }

    protected synchronized int getCurrComponentIndex() {
        int numComponents = mContainer.countComponents();
        for(int i = 0; i < numComponents; i++) {
            Component c = mContainer.getComponent(i);
            if(c.isVisible())
                return i;
        }

        return -1;
    }

    protected void showPanel(int id) {
        Container container = getContainer();
        CardLayout layout = (CardLayout)container.getLayout();
        Component oldComponent = getCurrComponent();
        layout.show(container, String.valueOf(id));
        Component newComponent = getCurrComponent();
        if(newComponent != oldComponent)
            if(id == 5)
                itsCore.handleRoomListRefresh();
            else
            if(id == 4) {
                itsCore.handleUserListRefresh();
                itsCore.handleRoomListRefresh();
            } else
            if(id == 11)
                itsCore.getAdmin().handleAdminButtonClick();
        if(itsFrame != null) {
            itsFrame.move(mResInfo.tabPanelRect.x, mResInfo.tabPanelRect.y);
            itsFrame.show();
            itsFrame.toFront();
            itsFrame.move(mResInfo.tabPanelRect.x, mResInfo.tabPanelRect.y);
        }
    }

}
