// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:54 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.pkt.PPEventXTalk;
import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import communities.utl.ItemLister;
import communities.utl.ResourceInfo;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.List;
import java.awt.Panel;

// Referenced classes of package communities:
//            IPalaceCore

public final class PalaceSoundPanel extends Panel
    implements Privileged {

    private transient IPalaceSecurity mSecurity;
    private List mList;
    private IPalaceCore mCore;
    private Button mPlayButton;
    private ResourceInfo mResInfo;

    public PalaceSoundPanel(IPalaceCore itsCore, ResourceInfo resInfo, IPalaceSecurity itsSecurity) {
        mList = null;
        mCore = null;
        mPlayButton = null;
        mResInfo = null;
        mCore = itsCore;
        mResInfo = resInfo;
        mSecurity = itsSecurity;
        mList = new List(0, false);
        mPlayButton = new Button("Play");
        loadSoundNames();
        setLayout(new BorderLayout());
        mList.setBackground(Color.white);
        add("Center", mList);
        Panel p = new Panel();
        p.setLayout(new FlowLayout(1));
        p.add(mPlayButton);
        add("South", p);
    }

    public void paint(Graphics g) {
        Color save = g.getColor();
        Dimension size = size();
        g.setColor(Color.white);
        g.drawRect(1, 1, size.width - 2, size.height - 2);
        g.setColor(Color.gray);
        g.drawRect(0, 0, size.width - 2, size.height - 2);
        g.setColor(save);
    }

    public synchronized void loadSoundNames() {
        ItemLister lister = new ItemLister(mResInfo.getErrorHandler(), mResInfo.getSoundList());
        lister.setSecurity(mSecurity);
        java.util.Vector soundNameList = lister.getList();
        if(soundNameList != null) {
            mList.clear();
            for(int i = 0; i < soundNameList.size(); i++) {
                String soundName = (String)soundNameList.elementAt(i);
                if(!soundName.equals(""))
                    mList.addItem(soundName);
            }

            mList.select(0);
        } else {
            mList.clear();
            mList.addItem("<no sounds available>");
            mPlayButton.disable();
        }
    }

    public boolean action(Event event, Object arg) {
        boolean handled = false;
        if(event.target == mList) {
            String soundName = (String)arg;
            sendSound(soundName);
            handled = true;
        } else
        if(event.target == mPlayButton) {
            String soundName = mList.getSelectedItem();
            sendSound(soundName);
            handled = true;
        } else {
            handled = super.action(event, arg);
        }
        return handled;
    }

    public Insets insets() {
        return new Insets(3, 3, 3, 3);
    }

    private void sendSound(String soundName) {
        if(soundName != null) {
            PPEventXTalk xTalk = new PPEventXTalk(")" + soundName, mCore.getUserID());
            mCore.sendPPEvent(xTalk);
        }
    }

    public boolean keyDown(Event e, int key) {
        boolean handled;
        if(e.target == mList && (key == 10 || key == 13)) {
            String soundName = mList.getSelectedItem();
            if(soundName != null)
                sendSound(soundName);
            handled = true;
        } else {
            handled = super.keyDown(e, key);
        }
        return handled;
    }
}
