// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:54 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import java.awt.*;

// Referenced classes of package communities:
//            IPalaceCore

public class PalaceUserList extends Panel {

    private Button mGotoButton;
    private Button mRefreshButton;
    private Panel buttonPanel;
    private List mUserList;
    private IPalaceCore mCore;

    public void reshape(int x, int y, int width, int height) {
        if(mUserList != null)
            mUserList.reshape(3, 26, width - 6, height - 86);
        if(buttonPanel != null)
            buttonPanel.reshape(3, height - 40, width - 6, 30);
        super.reshape(x, y, width, height);
    }

    public PalaceUserList(IPalaceCore itsCore) {
        mGotoButton = null;
        mRefreshButton = null;
        buttonPanel = null;
        mUserList = null;
        mCore = null;
        mCore = itsCore;
        setLayout(null);
        Label userListLabel = new Label("User        Location");
        userListLabel.setFont(new Font("Courier", 1, 12));
        userListLabel.reshape(6, 6, 200, 20);
        add(userListLabel);
        mUserList = new List(0, false);
        mUserList.setBackground(new Color(0xffffff));
        mUserList.setFont(new Font("Courier", 0, 12));
        mUserList.reshape(3, 26, 226, 200);
        add(mUserList);
        mGotoButton = new Button("Goto");
        mRefreshButton = new Button("Refresh");
        buttonPanel = new Panel();
        buttonPanel.setLayout(new FlowLayout(1));
        buttonPanel.add(mGotoButton);
        buttonPanel.add(mRefreshButton);
        buttonPanel.reshape(3, 230, 226, 30);
        add(buttonPanel);
    }

    public void paint(Graphics g) {
        Color save = g.getColor();
        Dimension size = size();
        g.setColor(Color.white);
        g.drawRect(1, 1, size.width - 2, size.height - 2);
        g.setColor(Color.gray);
        g.drawRect(0, 0, size.width - 2, size.height - 2);
        g.setColor(save);
    }

    public void select(int index) {
        mUserList.select(index);
    }

    public boolean action(Event e, Object arg) {
        boolean handled = false;
        if(e.target == mGotoButton) {
            mCore.handleUserGoto(mUserList.getSelectedIndex());
            handled = true;
        } else
        if(e.target == mRefreshButton) {
            mCore.handleUserListRefresh();
            handled = true;
        } else
        if(e.target == mUserList) {
            if(mGotoButton.isVisible())
                mCore.handleUserGoto(mUserList.getSelectedIndex());
            handled = true;
        } else {
            handled = super.action(e, arg);
        }
        return handled;
    }

    public void clear() {
        mUserList.clear();
    }

    public void addUser(String user) {
        mUserList.addItem(user);
    }

    public Insets insets() {
        return new Insets(3, 3, 3, 3);
    }

    public boolean keyDown(Event e, int key) {
        boolean handled;
        if(e.target == mUserList && (key == 10 || key == 13)) {
            mCore.handleUserGoto(mUserList.getSelectedIndex());
            handled = true;
        } else {
            handled = super.keyDown(e, key);
        }
        return handled;
    }
}
