// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:59 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.plg.ImageButton;
import communities.utl.ButtonInfo;
import communities.utl.ResourceInfo;
import java.awt.*;

// Referenced classes of package communities:
//            ButtonPanel, IPalaceUI, PalaceNewTabPanel

class TabPanelButtonBar extends ButtonPanel {

    private PalaceNewTabPanel mTabPanel;
    private int mRows;
    private int mCols;
    int numButtons;
    ButtonInfo buttonInfo[];
    ImageButton imageButtons[];
    int mButtonWidth;
    int mButtonHeight;
    String tabHelpStrings[] = {
        "View chat log", "Users on this site", "Rooms at this site", "Help using InstantPalace", "Change your appearance", "Events on this site", "Sounds at this site", "About InstantPalace", "Administrator Mode", "Push an URL"
    };

    public TabPanelButtonBar(int numButtons, ButtonInfo buttonInfo[], int imageWidth, int imageHeight, int rows, int cols, PalaceNewTabPanel tabPanel) {
        super(rows * cols, tabPanel.itsUI.getCore());
        this.numButtons = numButtons;
        mRows = rows;
        mCols = cols;
        mTabPanel = tabPanel;
        setLayout(null);
        this.buttonInfo = buttonInfo;
        imageButtons = new ImageButton[numButtons];
        mButtonWidth = imageWidth;
        mButtonHeight = imageHeight;
        int buttonNum = 0;
        int flags = 6;
        if(mTabPanel.mResInfo.buttonsHilight)
            flags |= 8;
        if(mTabPanel.mResInfo.buttonsShift)
            flags |= 0x10;
        for(int r = 0; r < rows; r++) {
            for(int c = 0; c < cols; c++) {
                imageButtons[buttonNum] = new ImageButton(buttonInfo[buttonNum].enabledImage, buttonInfo[buttonNum].hilitedImage, buttonInfo[buttonNum].depressedImage, buttonInfo[buttonNum].disabledImage, mButtonWidth, mButtonHeight, flags, 0);
                if(imageButtons[buttonNum] != null) {
                    imageButtons[buttonNum].move(4 + c * mButtonWidth, 4 + r * mButtonHeight);
                    int helpIndex = buttonInfo[buttonNum].mID - 3;
                    addButton(imageButtons[buttonNum], tabHelpStrings[helpIndex]);
                }
                if(++buttonNum >= numButtons)
                    break;
            }

        }

    }

    public void paint(Graphics g) {
        Dimension size = size();
        Color save = g.getColor();
        g.setColor(Color.white);
        g.drawRect(1, 1, size.width - 2, size.height - 2);
        g.setColor(Color.gray);
        g.drawRect(0, 0, size.width - 2, size.height - 2);
        g.setColor(save);
    }

    public void depress(int id) {
        for(int i = 0; i < numButtons; i++)
            if(id == buttonInfo[i].getID()) {
                mTabPanel.showPanel(id);
                imageButtons[i].setStuck(true);
            } else {
                imageButtons[i].setStuck(false);
            }

    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
        case 1001: // Event.ACTION_EVENT
            for(int i = 0; i < numButtons; i++)
                if(evt.target == imageButtons[i]) {
                    if((evt.modifiers & 2) != 0 && (evt.modifiers & 1) != 0)
                        mTabPanel.itsUI.setEasterEnabled(true);
                    else
                        mTabPanel.itsUI.setEasterEnabled(false);
                    mTabPanel.showPanel(buttonInfo[i].getID());
                } else {
                    imageButtons[i].setStuck(false);
                }

            break;
        }
        return super.handleEvent(evt);
    }
}
