// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:59 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.adm.Admin;
import communities.adm.IAdministrator;
import communities.pkt.PPEvent;
import communities.pkt.PPEventGotoRoom;
import communities.pkt.PPEventLogoff;
import communities.pkt.PPEventRoomDesc;
import communities.pkt.PPEventRoomListAll;
import communities.pkt.PPEventSuperUser;
import communities.pkt.PPEventUserListAll;
import communities.pkt.PPEventXTalk;
import communities.pkt.PPEventXWhisper;
import communities.plg.IPalacePresents;
import communities.plg.PluginMgr;
import communities.pob.IScriptMgr;
import communities.pob.IptscraeMgr;
import communities.pob.PalaceCommander;
import communities.pob.PalaceCommands;
import communities.pob.PropTable;
import communities.pob.Room;
import communities.pob.Room2D;
import communities.pob.RoomListRec;
import communities.pob.User;
import communities.pob.UserListRec;
import communities.sec.PalaceSecurityManager;
import communities.utl.AppletStatus;
import communities.utl.Connection;
import communities.utl.PalaceSoundManager;
import communities.utl.PalaceURL;
import communities.utl.ResourceInfo;
import java.applet.Applet;
import java.applet.AppletContext;
import java.awt.*;
import java.io.IOException;
import java.io.PrintStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;

// Referenced classes of package communities:
//            PalaceRTException, IPalaceUI, PalaceErrorHandler, Palace2DCanvas, 
//            Tooltip, palaceUI, NullUI, PalaceMsgStrings, 
//            IPalaceCore

public final class instantpal extends Applet
    implements PalaceMsgStrings, PalaceCommands, IPalaceCore {

    IPalaceUI theUI;
    Room2D room;
    AppletStatus appletStatus;
    private boolean running;
    private int processorCount;
    private Thread pendingThread;
    private Runnable connectionProcessor;
    PluginMgr mPluginMgr;
    IPalacePresents mPalacePresents;
    private IAdministrator mAdmin;
    private Frame appletFrame;
    private int currentCursor;
    private boolean bNavInProgress;
    boolean bInitialized;
    Label chatLabel;
    PalaceCommander palaceCommander;
    private IptscraeMgr iptscraeMgr;
    private PropTable propTable;
    Palace2DCanvas canvas;
    Vector listOfAllUsers;
    Vector listOfAllRooms;
    TextField textInput;
    ResourceInfo mResourceInfo;
    Connection mConnection;
    private PalaceSoundManager mSoundManager;
    public Label statusLabel;
    private Tooltip tooltip;
    private String userName;
    private String currRoomImgStr;
    transient PalaceSecurityManager theSecurityManager;
    boolean doFinally;
    int mConnectionTimeout;
    PalaceURL mLastGoodPalaceURL;
    PalaceErrorHandler mErrorHandler;
    long mStartConnection;

    public PluginMgr getPluginMgr() {
        return mPluginMgr;
    }

    public synchronized boolean didConnectToPalace() {
        mConnection = new Connection(mResourceInfo.getPalaceHostURL(), mResourceInfo.getPalaceHTTPURL(), mResourceInfo.getHTTPDelay(), mPluginMgr, this);
        mConnection.setSecurity(theSecurityManager);
        mConnection.open();
        if(!mConnection.isError()) {
            showStatus("Connected to " + mConnection.getHost());
            mLastGoodPalaceURL = mResourceInfo.getPalaceHostURL();
            return true;
        }
        long elapsedSeconds = (System.currentTimeMillis() - mStartConnection) / 1000L;
        if(elapsedSeconds >= (long)mConnectionTimeout) {
            reportError("Sorry, the PalaceServer is unavailable at this time.  Please try again later." + " (" + mResourceInfo.getPalaceHostURL() + ")");
            try {
                Thread.sleep(3000L);
            }
            catch(InterruptedException ie) { }
            mStartConnection = System.currentTimeMillis();
            try {
                mResourceInfo.setPalaceHostURL(mLastGoodPalaceURL);
                mLastGoodPalaceURL = null;
                reportError("Returning to last server." + " (" + mResourceInfo.getPalaceHostURL() + ")");
                Thread.sleep(3000L);
            }
            catch(NullPointerException e) {
                throw new PalaceRTException("Unable to connect to " + mResourceInfo.getPalaceHostURL());
            }
            catch(InterruptedException ie) { }
        } else {
            reportError("Logon to the server failed" + ".  " + ((long)mConnectionTimeout - elapsedSeconds) + " seconds until timeout connecting to " + mResourceInfo.getPalaceHostURL());
            try {
                Thread.sleep(1000L);
            }
            catch(InterruptedException ie) { }
        }
        return false;
    }

    public String getUserName() {
        return userName;
    }

    public void setRoomList(Vector roomList) {
        setListOfAllRooms(roomList);
    }

    public Vector getRoomList() {
        return listOfAllRooms;
    }

    private void sendRoomChange(int roomID) {
        PPEventGotoRoom gt = new PPEventGotoRoom(((Room) (room)).userID, roomID);
        sendPPEvent(gt);
        setNavInProgress(true);
    }

    public void hideUI() {
        myHide(canvas);
        textInput.hide();
        myHide(statusLabel);
        myHide(chatLabel);
    }

    public void gotoRoom(int newRoomID, int currRoomID) {
        sendRoomChange(newRoomID);
        theUI.updateNavControls();
        if(newRoomID != currRoomID)
            stopSounds();
    }

    private void stopSounds() {
        if(mSoundManager != null)
            mSoundManager.stopSounds();
    }

    public PalaceCommander getPalaceCommander() {
        return palaceCommander;
    }

    public void setInputFocus() {
        textInput.requestFocus();
        String text = textInput.getText();
        textInput.select(text.length(), text.length());
    }

    synchronized void closeConnection() {
        mConnection.close();
        Thread aThread = pendingThread;
        if(aThread != null)
            while(aThread == pendingThread)  {
                try {
                    wait(300L);
                }
                catch(InterruptedException e) {
                    break;
                }
                if(mResourceInfo.getDebug() > 0)
                    System.err.println("ip.connectToPalace: using Thread.stop");
                aThread.stop();
            }
    }

    public Room2D getRoom() {
        return room;
    }

    public void gotoNewRoom(int newRoomID) {
        theUI.gotoNewRoom(newRoomID);
        gotoRoom(newRoomID, ((Room) (room)).roomID);
    }

    UserListRec getUserListRec(int idx) {
        try {
            return (UserListRec)listOfAllUsers.elementAt(idx);
        }
        catch(Exception e) {
            return null;
        }
    }

    public int getRoomListCount() {
        if(listOfAllRooms != null)
            return listOfAllRooms.size();
        else
            return 0;
    }

    void reportError(String message) {
        mErrorHandler.reportError(message, 2);
        if(canvas != null) {
            canvas.show();
            canvas.createGraphicError(message);
        }
    }

    public PalaceErrorHandler getErrorHandler() {
        return mErrorHandler;
    }

    public void showStatus() {
        if(mResourceInfo.statusLabelEnabled)
            if(((Room) (room)).chatTargetID == 0) {
                String status = "You are: " + userName + "     People: " + ((Room) (room)).usersInRoom + "/" + ((Room) (room)).totalUsers;
                if(((Room) (room)).name != "")
                    status += "    Room: " + ((Room) (room)).name;
                statusLabel.setText(status);
            } else {
                User user = room.getUser(((Room) (room)).chatTargetID);
                if(user != null) {
                    String status = "You are: " + userName + "     Talking privately to " + user.name;
                    statusLabel.setText(status);
                }
            }
    }

    public void showStatus(String msg) {
        try {
            if(mResourceInfo.statusLabelEnabled)
                statusLabel.setText(msg);
        }
        catch(NullPointerException npe) {
            super.showStatus(msg);
        }
    }

    public Tooltip getTooltip() {
        return tooltip;
    }

    public String buildRoomString(int idx) {
        RoomListRec rlr = getRoomListRec(idx);
        StringBuffer room = new StringBuffer(rlr.toString());
        int numSpaces = 26 - room.length();
        if(numSpaces <= 0)
            numSpaces = 1;
        for(int i = 0; i < numSpaces; i++)
            room.append(' ');

        room.append(rlr.nbrUsers());
        return room.toString();
    }

    public void setCursor(int cursorVal) {
        if(cursorVal == currentCursor) {
            return;
        } else {
            getAppletFrame().setCursor(cursorVal);
            currentCursor = cursorVal;
            return;
        }
    }

    public void setListOfAllRooms(Vector list) {
        listOfAllRooms = list;
        theUI.updateRoomList();
    }

    public void reshape(int x, int y, int width, int height) {
        if(appletStatus != null && appletStatus.lowResMode)
            super.reshape(x, y, 620, 440);
        else
            super.reshape(x, y, width, height);
    }

    public AppletStatus getAppletStatus() {
        return appletStatus;
    }

    public void setNavInProgress(boolean state) {
        bNavInProgress = state;
        if(bNavInProgress)
            setCursor(3);
        else
            setCursor(0);
        theUI.setNavProgress(state);
    }

    public void handleUserGoto(int selected) {
        UserListRec ulr = getUserListRec(selected);
        if(ulr != null) {
            RoomListRec rlr = getRoomRecByID(ulr.roomID());
            if(rlr != null)
                gotoNewRoom(ulr.roomID());
        }
    }

    static void myHide(Component c) {
        if(c != null)
            c.hide();
    }

    public IScriptMgr getScriptMgr() {
        return iptscraeMgr;
    }

    public synchronized void destroy() {
        System.out.println("destroying palace applet...");
        if(running)
            stop();
        if(mPalacePresents != null) {
            mPalacePresents.destroy();
            mPalacePresents = null;
        }
        if(propTable != null) {
            propTable.done();
            propTable = null;
        }
        if(room != null) {
            room.done();
            room = null;
        }
        iptscraeMgr = null;
        appletStatus = null;
        mAdmin = null;
        theUI = null;
        palaceCommander = null;
        mPluginMgr = null;
        mSoundManager = null;
        mResourceInfo = null;
        removeAll();
        theSecurityManager = null;
        bInitialized = false;
    }

    public void NewRoomDesc(PPEvent p, boolean newRoomFlag) {
        PPEventRoomDesc rd = (PPEventRoomDesc)p;
        currRoomImgStr = rd.roomImageName();
        Image im = retrieveImage(currRoomImgStr, true);
        if(im == null)
            System.err.println("im Image is null");
        room.setName(rd.roomName());
        room.setRoomID(rd.roomID());
        room.setBgImage(im);
        room.setHotspots(rd.hotspots());
        room.setLooseProps(rd.looseProps);
        room.setImageOverlays(rd.images);
        if(newRoomFlag) {
            room.clearUsers();
            room.clearStatusMessage();
            setNavInProgress(false);
            theUI.updateNavControls();
            room.chatTargetID = 0;
            palaceCommander.pc_SetWhoTarget(null);
        }
        showStatus();
    }

    public void setUserList(Vector userList) {
        setListOfAllUsers(userList);
    }

    public Vector getUserList() {
        return listOfAllUsers;
    }

    public void handleEventJoin() {
        if(mPalacePresents != null)
            mPalacePresents.JoinEvent();
    }

    public Palace2DCanvas getCanvas() {
        return canvas;
    }

    public Connection getConnection() {
        return mConnection;
    }

    RoomListRec getRoomRecByID(int id) {
        if(listOfAllRooms != null) {
            for(int i = 0; i < listOfAllRooms.size(); i++) {
                RoomListRec rlr = (RoomListRec)listOfAllRooms.elementAt(i);
                if(rlr.roomID() == id)
                    return rlr;
            }

        }
        return null;
    }

    public void sendPPEvent(PPEvent packet) {
        try {
            mConnection.writeEvent(packet);
        }
        catch(NullPointerException npe) {
            mErrorHandler.reportError("Attempt to write to NULL connection.", 1);
        }
    }

    public synchronized void init() {
        System.out.println("initializing palace applet (V" + "2" + "." + "3" + "." + "0" + " Build " + "11" + ")...");
        if(bInitialized)
            destroy();
        mErrorHandler = new PalaceErrorHandler(this);
        PalaceSecurityManager.initialize(this);
        mResourceInfo = new ResourceInfo(this);
        mResourceInfo.setSecurity(theSecurityManager);
        mResourceInfo.init();
        mConnectionTimeout = mResourceInfo.getConnectionTimeout();
        mSoundManager = new PalaceSoundManager(this);
        room = new Room2D(this, 1);
        palaceCommander = new PalaceCommander(this);
        propTable = new PropTable(this);
        if(mResourceInfo.scriptingEnabled)
            iptscraeMgr = new IptscraeMgr(palaceCommander);
        room.setPropTable(propTable);
        room.setPalaceCommander(palaceCommander);
        palaceCommander.setRoom(room);
        appletStatus = new AppletStatus(this);
        if(mResourceInfo.appletMode != 4) {
            tooltip = new Tooltip();
            tooltip.hide();
            add(tooltip);
        }
        currentCursor = 0;
        if(mResourceInfo.appletMode == 5)
            mAdmin = new Admin(this);
        if(mResourceInfo.appletMode != 4 && mResourceInfo.appletMode != 2) {
            palaceUI aUI = new palaceUI(this, this, theSecurityManager);
            theUI = aUI;
        } else {
            theUI = new NullUI(this);
        }
        initControls();
        show();
    }

    public boolean handleEvent(Event evt) {
        try {
            switch(evt.id) {
            default:
                break;

            case 501: // Event.MOUSE_DOWN
                if(theUI.handleEvent(evt))
                    return true;
                break;

            case 401: // Event.KEY_PRESS
                if(evt.target != textInput || evt.key != 10)
                    break;
                if(!bNavInProgress) {
                    String s = textInput.getText();
                    if(s.charAt(0) == '/') {
                        if(mResourceInfo.getDebug() > 0)
                            palaceCommander.pc_ExecuteScript(s.substring(1));
                    } else
                    if(s.charAt(0) == '~') {
                        processMacro(s.substring(1));
                    } else {
                        palaceCommander.pc_SetChatString(s);
                        palaceCommander.triggerHotspotEvents(12);
                        s = palaceCommander.pc_GetChatString();
                        if(((Room) (room)).chatTargetID != 0) {
                            PPEventXWhisper xw = new PPEventXWhisper(s, ((Room) (room)).userID, ((Room) (room)).chatTargetID);
                            sendPPEvent(xw);
                        } else {
                            PPEventXTalk xt = new PPEventXTalk(s, ((Room) (room)).userID);
                            sendPPEvent(xt);
                        }
                    }
                }
                textInput.setText("");
                if(chatLabel != null) {
                    remove(chatLabel);
                    if(mPalacePresents != null)
                        mPalacePresents.reshapeTextInput();
                    else
                        textInput.reshape(mResourceInfo.textInputRect.x, mResourceInfo.textInputRect.y, mResourceInfo.textInputRect.width, mResourceInfo.textInputRect.height);
                    chatLabel = null;
                }
                return true;

            case 1001: // Event.ACTION_EVENT
                if(theUI.handleEvent(evt))
                    return true;
                break;
            }
        }
        catch(Throwable t) {
            mErrorHandler.reportError("Uncaught exception handling AWT event: " + t.getMessage(), 1);
        }
        return super.handleEvent(evt);
    }

    public Label getStatusLabel() {
        return statusLabel;
    }

    public synchronized void stop() {
        running = false;
        System.out.println("stopping palace applet...");
        if(iptscraeMgr != null)
            iptscraeMgr.stop();
        stopSounds();
        PPEventLogoff ubye = new PPEventLogoff(((Room) (room)).userID);
        sendPPEvent(ubye);
        try {
            Thread.sleep(1000L);
        }
        catch(InterruptedException e) { }
        mConnection.close();
        room.ClearRoomDesc();
        theUI.stop();
        while(processorCount > 0) 
            try {
                wait(500L);
                if(pendingThread != null) {
                    if(mResourceInfo.getDebug() > 0)
                        System.err.println("ip.stop: using Thread.stop");
                    pendingThread.stop();
                }
            }
            catch(InterruptedException e) {
                return;
            }
    }

    RoomListRec getRoomListRec(int idx) {
        try {
            return (RoomListRec)listOfAllRooms.elementAt(idx);
        }
        catch(Exception e) {
            return null;
        }
    }

    public void handleRoomListRefresh() {
        PPEventRoomListAll rla = new PPEventRoomListAll(((Room) (room)).userID);
        sendPPEvent(rla);
    }

    public TextField getTextInput() {
        return textInput;
    }

    synchronized void palaceEventsDone() {
        if(mResourceInfo.getDebug() > 0)
            System.err.println("ip.palaceEventsDone");
        processorCount--;
        if(mResourceInfo.getDebug() > 0)
            System.err.println("processorCount: " + processorCount);
        if(running && connectionProcessor != null)
            startProcessorThread(false);
        notifyAll();
    }

    public String buildUserString(int idx) {
        UserListRec usr = getUserListRec(idx);
        StringBuffer name = new StringBuffer(usr.toString());
        int numSpaces = 12 - name.length();
        if(numSpaces <= 0)
            numSpaces = 1;
        for(int i = 0; i < numSpaces; i++)
            name.append(' ');

        RoomListRec rlr = getRoomRecByID(usr.roomID());
        if(rlr != null)
            name.append(rlr.toString());
        else
            name.append("(Private)");
        return name.toString();
    }

    public boolean isNavInProgress() {
        return bNavInProgress;
    }

    public void gotoURL(String urlstr, String targetname) {
        if(urlstr == null || urlstr.length() == 0)
            return;
        try {
            PalaceURL url = new PalaceURL(urlstr);
            if(mResourceInfo.getDebug() > 0)
                System.err.println("ip.gotoURL(" + urlstr + ") [" + url + "]");
            gotoURL(url, targetname);
        }
        catch(MalformedURLException mue) {
            mErrorHandler.reportError("gotoURL: bad url - " + urlstr, 1);
        }
    }

    public synchronized void connectToPalace() {
        if(mResourceInfo.getDebug() > 0)
            System.err.println("ip.connectToPalace");
        connectionProcessor = null;
        closeConnection();
        connectionProcessor = new instantpal$ChatProcessor(this);
        startProcessorThread(true);
    }

    public synchronized void gotoURL(PalaceURL aURL, String targetname) {
        if(aURL.isPalaceProtocol()) {
            palaceCommander.unsupportedSelectEvent();
        } else {
            System.err.println("gotoURL - " + aURL);
            getAppletContext().showDocument(aURL.getURL(), targetname);
        }
    }

    public synchronized void runIntro() {
        if(userName == null);
        connectionProcessor = null;
        closeConnection();
        if(mResourceInfo.bRunIntro) {
            System.err.println("runIntro: userName = " + userName);
            appletStatus.introInProgress = true;
            setNavInProgress(false);
            hideUI();
            theUI.runIntro();
        } else {
            System.err.println("runIntro: [no intro] userName = " + userName);
            appletStatus.introInProgress = false;
            if(userName == null)
                userName = mResourceInfo.defaultName;
            theUI.showUI();
            myShow(statusLabel);
            myShow(canvas);
            myShow(chatLabel);
            textInput.show();
            connectToPalace();
        }
    }

    public synchronized void start() {
        running = true;
        System.out.println("starting palace applet...");
        bNavInProgress = true;
        if(mPalacePresents != null && mPalacePresents.isStageShowing()) {
            System.err.println("cleaning up stage");
            mPalacePresents.shutDown();
            mPalacePresents.clearEventList();
            mPalacePresents.HideJoinButton();
        }
        if(connectionProcessor == null)
            connectionProcessor = new instantpal$IntroProcessor(this);
        startProcessorThread(true);
    }

    public PalaceSoundManager getSoundManager() {
        return mSoundManager;
    }

    public void synchronizeExternalBrowser(String urlstr) {
        String s = "`displayurl " + urlstr;
        if(((Room) (room)).chatTargetID != 0) {
            PPEventXWhisper xw = new PPEventXWhisper(s, ((Room) (room)).userID, ((Room) (room)).chatTargetID);
            sendPPEvent(xw);
        } else {
            PPEventXTalk xt = new PPEventXTalk(s, ((Room) (room)).userID);
            sendPPEvent(xt);
        }
    }

    public Frame getAppletFrame() {
        if(appletFrame == null) {
            for(Component c = this; c != null; c = c.getParent())
                if(c instanceof Frame)
                    appletFrame = (Frame)c;

        }
        return appletFrame;
    }

    public Image retrieveImage(String imageName, boolean isRoomImage) {
        imageName = imageName.toLowerCase();
        try {
            URL theURL = new URL(mResourceInfo.getPicFolder() + imageName.toLowerCase());
            String imageNameDot = mResourceInfo.getPicFolder() + imageName.toLowerCase().substring(0, imageName.length() - 3);
            instantpal$ImageGetter g = new instantpal$ImageGetter(this, imageNameDot);
            theSecurityManager.connectTo(null, g);
            return g.mImage;
        }
        catch(MalformedURLException mue) { }
        catch(SecurityException e) { }
        System.err.println("room image URL is null");
        return null;
    }

    public IPalacePresents getPalacePresents() {
        return mPalacePresents;
    }

    public void handleRoomGoto(int selected) {
        RoomListRec rlr = getRoomListRec(selected);
        if(rlr != null)
            gotoNewRoom(rlr.roomID());
    }

    public IAdministrator getAdmin() {
        return mAdmin;
    }

    synchronized void startProcessorThread(boolean restartTimer) {
        Thread thread = new Thread(connectionProcessor, connectionProcessor.getClass().getName());
        if(restartTimer)
            mStartConnection = System.currentTimeMillis();
        thread.start();
        processorCount++;
        if(mResourceInfo.getDebug() > 0)
            System.err.println("processorCount: " + processorCount);
    }

    public IPalaceUI getUI() {
        return theUI;
    }

    public Insets insets() {
        return new Insets(2, 2, 2, 2);
    }

    public PropTable getPropTable() {
        return propTable;
    }

    public int getUserListCount() {
        if(listOfAllUsers != null)
            return listOfAllUsers.size();
        else
            return 0;
    }

    public PPEvent readPPEvent() throws IOException {
        pendingThread = Thread.currentThread();
        PPEvent retval;
        try {
            retval = mConnection.readEvent();
        }
        finally {
            pendingThread = null;
        }
        return retval;
    }

    public void paint(Graphics g) {
        super.paint(g);
        if(mResourceInfo.bDrawAppletBorder) {
            g.setColor(Color.lightGray);
            g.draw3DRect(0, 0, size().width - 1, size().height - 1, false);
        }
    }

    public instantpal() {
        processorCount = 0;
        mPluginMgr = null;
        mPalacePresents = null;
        mAdmin = null;
        appletFrame = null;
        bNavInProgress = false;
        textInput = null;
        mResourceInfo = null;
        mConnection = null;
        mSoundManager = null;
        statusLabel = null;
        tooltip = null;
        userName = null;
        currRoomImgStr = "";
        doFinally = true;
        mConnectionTimeout = 6;
        mLastGoodPalaceURL = null;
        mErrorHandler = null;
        mStartConnection = 0L;
    }

    public ResourceInfo getResourceInfo() {
        return mResourceInfo;
    }

    public void handleEventInfo() {
        if(mPalacePresents != null)
            mPalacePresents.EventInfo();
    }

    private void processMacro(String macro) {
        String cmd = new String(macro.substring(0, 4));
        if(cmd.compareTo("susr") == 0) {
            int idx = macro.lastIndexOf(' ');
            if(idx != -1) {
                String password = new String(macro.substring(idx + 1));
                PPEventSuperUser su = new PPEventSuperUser(password, ((Room) (room)).userID);
                sendPPEvent(su);
            }
        }
    }

    public int getUserID() {
        return ((Room) (room)).userID;
    }

    public Label getChatLabel() {
        return chatLabel;
    }

    public void logText(User u, String msg, boolean privateFlag) {
        theUI.logText(u, msg, privateFlag);
    }

    static void myShow(Component c) {
        if(c != null)
            c.show();
    }

    public void setPalaceSecurity(PalaceSecurityManager m) {
        if(theSecurityManager == null)
            theSecurityManager = m;
    }

    public void handleUserListRefresh() {
        PPEventUserListAll ula = new PPEventUserListAll(((Room) (room)).userID);
        sendPPEvent(ula);
    }

    public void setListOfAllUsers(Vector list) {
        listOfAllUsers = list;
        theUI.updateUserList();
        if(mPalacePresents != null)
            mPalacePresents.updateUserList();
    }

    public Applet getJavaApplet() {
        return this;
    }

    public void showUI() {
        myShow(canvas);
        textInput.show();
        myShow(statusLabel);
        myShow(chatLabel);
    }

    protected void initControls() {
        setLayout(null);
        setBackground(mResourceInfo.bkgColor);
        if(mResourceInfo.roomWindowEnabled) {
            canvas = room.getCanvas();
            canvas.reshape(mResourceInfo.roomWindowRect.x, mResourceInfo.roomWindowRect.y, mResourceInfo.roomWindowRect.width, mResourceInfo.roomWindowRect.height);
            add(canvas);
            canvas.hide();
        }
        textInput = new TextField(60);
        textInput.setFont(mResourceInfo.textInputFont);
        textInput.reshape(mResourceInfo.textInputRect.x, mResourceInfo.textInputRect.y, mResourceInfo.textInputRect.width, mResourceInfo.textInputRect.height);
        textInput.setBackground(Color.white);
        add(textInput);
        textInput.hide();
        textInput.addNotify();
        int textHeight = textInput.preferredSize().height;
        if(mResourceInfo.textInputRect.height < textHeight)
            mResourceInfo.textInputRect.height = textHeight;
        if(mResourceInfo.textInputRect.width > 280) {
            chatLabel = new Label("Type here to chat ->");
            chatLabel.setFont(new Font("Dialog", 1, 12));
            chatLabel.reshape(mResourceInfo.textInputRect.x, mResourceInfo.textInputRect.y, 158, 22);
            textInput.reshape(mResourceInfo.textInputRect.x + 158, mResourceInfo.textInputRect.y, mResourceInfo.textInputRect.width - 158, mResourceInfo.textInputRect.height);
            add(chatLabel);
            chatLabel.hide();
        }
        if(mResourceInfo.statusLabelEnabled) {
            statusLabel = new Label("Loading");
            statusLabel.setFont(mResourceInfo.statusLabelFont);
            statusLabel.reshape(mResourceInfo.statusLabelRect.x, mResourceInfo.statusLabelRect.y, mResourceInfo.statusLabelRect.width, mResourceInfo.statusLabelRect.height);
            add(statusLabel);
            statusLabel.hide();
        }
        if(appletStatus.lowResMode)
            resize(620, 440);
    }

    public void setUserName(String name) {
        userName = name;
    }
}
