// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:17:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.plg.EventListPanel;
import communities.plg.ImageButton;
import communities.pob.Room;
import communities.pob.User;
import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import communities.utl.AppletStatus;
import communities.utl.ImagePane;
import communities.utl.NavHistory;
import communities.utl.PalaceURL;
import communities.utl.ResourceInfo;
import java.applet.Applet;
import java.awt.*;
import java.net.MalformedURLException;
import java.net.URL;

// Referenced classes of package communities:
//            PalaceNewTabPanel, PalaceUserList, IPalaceCore, PalaceIntro, 
//            PCycleCanvas, PalaceErrorHandler, PalaceNavBar, PalaceRoomList, 
//            PalaceLog, TabFrame, IPalaceUI, AboutPanel

public final class palaceUI
    implements IPalaceUI, Privileged {

    Applet itsApplet;
    private IPalaceCore itsCore;
    private PalaceNavBar mNavBar;
    private NavHistory mNavHistory;
    private PalaceNewTabPanel tabPanel;
    private PalaceLog mLog;
    private PalaceUserList mUserList;
    private PalaceRoomList mRoomList;
    private AboutPanel aboutPanel;
    private ImagePane adCanvas;
    private Panel controls;
    private TabFrame tabPanelFrame;
    private PCycleCanvas homeCanvas;
    private Button uGotoButton;
    private Button uRefreshButton;
    private Button rGotoButton;
    private Button rRefreshButton;
    private Button helpButton;
    private Button joinButton;
    private FontMetrics logFontMetrics;
    private int logMaxLineLen;
    private int logLen;
    private URL backButtonURL;
    private URL forwardButtonURL;
    Image adImage;
    Image homeImage;
    private ResourceInfo mResourceInfo;
    private PalaceErrorHandler mErrorHandler;
    private boolean easterEnabled;
    private PalaceIntro intro;
    static final char tile2face[] = {
        '\005', '\001', '\004', '\006', '\b', '\002', '\007', '\t', '\0', '\003', 
        '\n', '\f', '\013', '\0', '\0', '\0'
    };
    private transient IPalaceSecurity mSecurity;

    public void stop() {
        mNavHistory = null;
        if(tabPanelFrame != null)
            tabPanelFrame.hide();
    }

    public void updateUserList() {
        PalaceUserList userList = tabPanel.getUserList();
        userList.clear();
        for(int i = 0; i < itsCore.getUserListCount(); i++)
            userList.addUser(itsCore.buildUserString(i));

        userList.select(0);
    }

    public List getEventList() {
        if(tabPanel != null) {
            if(tabPanel.getEventListPanel() != null)
                return tabPanel.getEventListPanel().m_EventList;
            else
                return null;
        } else {
            return null;
        }
    }

    public void removeIntro() {
        if(intro != null)
            itsApplet.remove(intro);
    }

    public int getAvatar() {
        if(intro != null && itsCore.getResourceInfo().chooseAvatarEnabled)
            return intro.faceNbr;
        else
            return itsCore.getResourceInfo().defaultAvatar;
    }

    public void handleHelpButton() {
        itsCore.gotoURL(new PalaceURL(mResourceInfo.joinURL), "_blank");
    }

    public void handleJoinButton() {
        handleHelpButton();
    }

    public void gotoNewRoom(int id) {
        if(mNavHistory != null)
            mNavHistory.gotoNewRoom(id);
    }

    public void showHowToChat() {
        if(intro != null)
            intro.showHowToChat();
    }

    public void setEasterEnabled(boolean f) {
        easterEnabled = f;
    }

    public int getFaceColor() {
        if(itsCore.getResourceInfo().chooseAvatarEnabled)
            return 3;
        else
            return itsCore.getResourceInfo().defaultFaceColor;
    }

    public void runIntro() {
        if(mResourceInfo.bRunIntro) {
            intro = new PalaceIntro(itsCore, this);
            if(mResourceInfo.roomWindowEnabled && (mResourceInfo.roomWindowRect.width < 512 || mResourceInfo.roomWindowRect.height < 384))
                mResourceInfo.tutorialEnabled = false;
            int w = 512;
            int h = 430;
            if(itsApplet.size().width < 512)
                w = itsApplet.size().width;
            if(itsApplet.size().height < 430)
                h = itsApplet.size().height;
            intro.reshape(2, 2, w, h);
            itsApplet.add(intro);
            intro.run();
        }
    }

    public void goForward() {
        if(mNavHistory != null) {
            int currRoomID = mNavHistory.getCurrRoomID();
            int newRoomID = mNavHistory.goForward();
            if(newRoomID != -1)
                itsCore.gotoRoom(newRoomID, currRoomID);
        }
    }

    public Image getHomeImage() {
        return homeImage;
    }

    public void hideTabs() {
        myHide(tabPanel);
        if(mResourceInfo.buttonPanelEnabled) {
            TabPanelButtonBar bar = tabPanel.getButtonBar();
            myHide(bar);
        }
    }

    public void stopCycling() {
        if(homeCanvas != null)
            homeCanvas.setCycleState(false);
    }

    public void startCycling() {
        if(homeCanvas != null)
            homeCanvas.setCycleState(true);
    }

    public IPalaceCore getCore() {
        return itsCore;
    }

    protected void getNetworkResources() {
        URL imageURL = null;
        try {
            imageURL = new URL(mResourceInfo.getAppletDataFolder() + "resource/");
        }
        catch(MalformedURLException mfu) {
            itsCore.getErrorHandler().reportError("Exception with URL:" + mfu.toString(), 1);
        }
        if(imageURL != null) {
            palaceUI$ResourceGetter getter = new palaceUI$ResourceGetter(this, imageURL);
            try {
                mSecurity.connectTo(imageURL, getter);
            }
            catch(SecurityException e) { }
        }
        if(adImage == null)
            mErrorHandler.reportError("InstantPalace::init:no ad at url " + imageURL, 1);
        if(homeImage == null)
            mErrorHandler.reportError("InstantPalace::init:no home logo at url " + imageURL, 1);
        try {
            backButtonURL = new URL(mResourceInfo.getAppletDataFolder() + "resource/left.gif");
            forwardButtonURL = new URL(mResourceInfo.getAppletDataFolder() + "resource/right.gif");
        }
        catch(MalformedURLException mfu) {
            mErrorHandler.reportError("Exception with URL:" + mfu.toString(), 1);
        }
    }

    public void disableNavControls() {
        if(mNavBar != null) {
            ImageButton backButton = mNavBar.getButton(0);
            ImageButton forwardButton = mNavBar.getButton(1);
            backButton.disable();
            forwardButton.disable();
        }
    }

    public palaceUI(Applet itsApplet, IPalaceCore itsCore, IPalaceSecurity itsSecurity) {
        mNavBar = null;
        mNavHistory = null;
        tabPanel = null;
        mLog = null;
        mUserList = null;
        mRoomList = null;
        aboutPanel = null;
        adCanvas = null;
        controls = null;
        tabPanelFrame = null;
        homeCanvas = null;
        uGotoButton = null;
        uRefreshButton = null;
        rGotoButton = null;
        rRefreshButton = null;
        helpButton = null;
        joinButton = null;
        logFontMetrics = null;
        logMaxLineLen = 0;
        logLen = 0;
        backButtonURL = null;
        forwardButtonURL = null;
        adImage = null;
        homeImage = null;
        easterEnabled = false;
        this.itsCore = itsCore;
        this.itsApplet = itsApplet;
        mErrorHandler = itsCore.getErrorHandler();
        mSecurity = itsSecurity;
        mResourceInfo = itsCore.getResourceInfo();
        getNetworkResources();
        initControls();
    }

    void myHide(Component c) {
        if(c != null)
            c.hide();
    }

    public Dialog getTabPanelFrame() {
        return tabPanelFrame;
    }

    public void goBack() {
        if(mNavHistory != null) {
            int currRoomID = mNavHistory.getCurrRoomID();
            int newRoomID = mNavHistory.goBack();
            if(newRoomID != -1)
                itsCore.gotoRoom(newRoomID, currRoomID);
        }
    }

    public void updateRoomList() {
        PalaceRoomList roomList = tabPanel.getRoomList();
        roomList.clear();
        for(int i = 0; i < itsCore.getRoomListCount(); i++)
            roomList.addRoom(itsCore.buildRoomString(i));

        roomList.select(0);
    }

    public void updateNavControls() {
        if(mNavBar != null) {
            ImageButton backButton = mNavBar.getButton(0);
            ImageButton forwardButton = mNavBar.getButton(1);
            if(mNavHistory != null) {
                if(mNavHistory.isBackAvailable())
                    backButton.enable();
                else
                    backButton.disable();
                if(mNavHistory.isForwardAvailable())
                    forwardButton.enable();
                else
                    forwardButton.disable();
            } else {
                mNavHistory = new NavHistory(((Room) (itsCore.getRoom())).roomID);
                backButton.disable();
                forwardButton.disable();
            }
        }
    }

    public void setNavProgress(boolean state) {
        if(state)
            startCycling();
    }

    public void logText(User u, String msg, boolean privateFlag) {
        if(mResourceInfo.logPanelEnabled && tabPanel != null)
            tabPanel.getLog().logText(u, msg, privateFlag);
    }

    void myShow(Component c) {
        if(c != null)
            c.show();
    }

    public void showTabs() {
        myShow(tabPanel);
        if(mResourceInfo.buttonPanelEnabled) {
            TabPanelButtonBar bar = tabPanel.getButtonBar();
            myShow(bar);
        }
        tabPanel.refreshPanels();
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
        default:
            break;

        case 501: // Event.MOUSE_DOWN
            if(evt.target == adCanvas) {
                itsCore.gotoURL(new PalaceURL(mResourceInfo.adURL), "_blank");
                return true;
            }
            if(evt.target == homeCanvas) {
                itsCore.gotoURL(new PalaceURL(mResourceInfo.homeURL), "_blank");
                return true;
            }
            break;

        case 1001: // Event.ACTION_EVENT
            if(evt.target == joinButton) {
                handleJoinButton();
                return true;
            }
            break;
        }
        return false;
    }

    public void selectEvent(int index) {
        if(tabPanel != null && tabPanel.getEventListPanel() != null)
            tabPanel.getEventListPanel().select(index);
    }

    public void showUI() {
        myShow(adCanvas);
        myShow(controls);
        showTabs();
    }

    public boolean isEasterEnabled() {
        return easterEnabled;
    }

    protected void initControls() {
        if(itsCore.getAppletStatus().lowResMode) {
            mResourceInfo.tabPanelFloats = true;
            mResourceInfo.tabPanelRect.x = 270;
            mResourceInfo.tabPanelRect.y = 160;
            mResourceInfo.navBarRect.x = 574;
            mResourceInfo.navBarRect.y = 5;
            mResourceInfo.navBarRect.width = 36;
            mResourceInfo.navBarRect.height = 100;
            mResourceInfo.buttonPanelRect.x = 516;
            mResourceInfo.buttonPanelRect.y = 4;
            mResourceInfo.buttonPanelRect.width = 53;
            mResourceInfo.buttonPanelRect.height = 368;
            mResourceInfo.adEnabled = false;
        }
        if(mResourceInfo.tabPanelEnabled) {
            if(!mResourceInfo.tabPanelFloats) {
                tabPanel = new PalaceNewTabPanel(this, itsCore, mSecurity, mResourceInfo, null);
                tabPanel.reshape(mResourceInfo.tabPanelRect.x, mResourceInfo.tabPanelRect.y, mResourceInfo.tabPanelRect.width, mResourceInfo.tabPanelRect.height);
                tabPanel.hide();
                itsApplet.add(tabPanel);
            } else {
                tabPanelFrame = new TabFrame(itsCore.getAppletFrame(), "InstantPalace");
                tabPanel = new PalaceNewTabPanel(this, itsCore, mSecurity, mResourceInfo, tabPanelFrame);
                tabPanelFrame.reshape(mResourceInfo.tabPanelRect.x, mResourceInfo.tabPanelRect.y, mResourceInfo.tabPanelRect.width + 8, mResourceInfo.tabPanelRect.height + 48);
                tabPanel.reshape(4, 22, mResourceInfo.tabPanelRect.width, mResourceInfo.tabPanelRect.height);
                tabPanelFrame.add(tabPanel);
            }
            if(mResourceInfo.buttonPanelEnabled) {
                TabPanelButtonBar bar = tabPanel.getButtonBar();
                bar.reshape(mResourceInfo.buttonPanelRect.x, mResourceInfo.buttonPanelRect.y, mResourceInfo.buttonPanelRect.width, mResourceInfo.buttonPanelRect.height);
                bar.hide();
                bar.setBackground(mResourceInfo.bkgColor);
                itsApplet.add(bar);
            }
        }
        if(mResourceInfo.navBarEnabled) {
            homeCanvas = new PCycleCanvas(homeImage);
            controls = new Panel();
            controls.setLayout(new BorderLayout(2, 0));
            Panel h = new Panel();
            h.setLayout(new FlowLayout(1, 0, 0));
            h.add(homeCanvas);
            if(mResourceInfo.navBarRect.width > mResourceInfo.navBarRect.height) {
                mNavBar = PalaceNavBar.createNavBar(this, 0);
                controls.add("West", h);
                controls.add("East", mNavBar);
            } else {
                mNavBar = PalaceNavBar.createNavBar(this, 1);
                controls.add("North", h);
                controls.add("South", mNavBar);
            }
            controls.reshape(mResourceInfo.navBarRect.x, mResourceInfo.navBarRect.y, mResourceInfo.navBarRect.width, mResourceInfo.navBarRect.height);
            itsApplet.add(controls);
            controls.hide();
        }
        if(mResourceInfo.adEnabled) {
            adCanvas = new ImagePane(adImage, 234, 60);
            adCanvas.reshape(mResourceInfo.adRect.x, mResourceInfo.adRect.y, mResourceInfo.adRect.width, mResourceInfo.adRect.height);
            itsApplet.add(adCanvas);
            adCanvas.hide();
        }
    }

}
