// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.FilterOutputStream;
import java.io.IOException;

// Referenced classes of package communities.pkt:
//            PalaceEventTypes

public class PPEvent
    implements PalaceEventTypes {

    public int event;
    public int size;
    public int refNum;

    public static String eventToString(long event) {
        String s = new String();
        s = "0x" + Long.toString(event, 16) + " " + (char)(int)(event >> 24 & 255L) + (char)(int)(event >> 16 & 255L) + (char)(int)(event >> 8 & 255L) + (char)(int)(event & 255L);
        return s;
    }

    public PPEvent() {
        event = 0;
        size = 0;
        refNum = 0;
    }

    public void read(NetDataInputStream netdatainputstream) throws IOException {
    }

    public int type() {
        return event;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        ndos.writeInt(event);
        ndos.writeInt(size);
        ndos.writeInt(refNum);
        ndos.flush();
    }

    public void readSizeAndRefnum(NetDataInputStream ndis, int event) throws IOException {
        this.event = event;
        size = ndis.readInt();
        refNum = ndis.readInt();
        ndis.bytesRead();
    }

    public int refNum() {
        return refNum;
    }

    public void readRemainder(NetDataInputStream ndis) throws IOException {
        int br = ndis.bytesRead();
        if(br > size) {
            String s = "Packet read error for " + eventToString(event) + ".pkt size=" + size + " read=" + br;
            throw new Error(s);
        }
        if(br < size) {
            byte bs[] = new byte[size - br];
            ndis.readFully(bs);
        }
    }

    public void flush(NetDataOutputStream ndos) throws IOException {
        ndos.flush();
    }

    public void writeNoFlush(NetDataOutputStream ndos) throws IOException {
        ndos.writeInt(event);
        ndos.writeInt(size);
        ndos.writeInt(refNum);
    }

    public int length() {
        return size;
    }
}
