// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.pob.*;
import communities.utl.NetDataInputStream;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Vector;

// Referenced classes of package communities.pkt:
//            PPEvent

public class PPEventRoomDesc extends PPEvent {

    int roomFlags;
    int faceID;
    int roomID;
    String roomName;
    String imageName;
    int nbrHotspots;
    int hotspotOffset;
    int nbrImages;
    int imageOffset;
    int nbrDrawCmds;
    int firstDrawCmd;
    int nbrPeople;
    int nbrLProps;
    int firstLProp;
    Vector hotspots;
    public Hashtable images;
    public Vector looseProps;

    public int roomID() {
        return roomID;
    }

    public PPEventRoomDesc() {
        roomFlags = 0;
        faceID = 0;
        roomID = 0;
        roomName = "";
        imageName = "";
        nbrHotspots = 0;
        hotspotOffset = 0;
        nbrImages = 0;
        imageOffset = 0;
        nbrDrawCmds = 0;
        firstDrawCmd = 0;
        nbrPeople = 0;
        nbrLProps = 0;
        firstLProp = 0;
        hotspots = null;
        images = null;
        looseProps = null;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        roomFlags = ndis.readInt();
        faceID = ndis.readInt();
        roomID = ndis.readShort();
        int roomNameOffset = ndis.readShort();
        int imageNameOffset = ndis.readShort();
        int artistNameOffset = ndis.readShort();
        int passwordOffset = ndis.readShort();
        nbrHotspots = ndis.readShort();
        hotspotOffset = ndis.readShort();
        nbrImages = ndis.readShort();
        imageOffset = ndis.readShort();
        nbrDrawCmds = ndis.readShort();
        firstDrawCmd = ndis.readShort();
        nbrPeople = ndis.readShort();
        nbrLProps = ndis.readShort();
        firstLProp = ndis.readShort();
        ndis.readShort();
        int lenVars = ndis.readShort();
        byte varsBytes[] = new byte[lenVars];
        ndis.readFully(varsBytes);
        int padding = super.size - lenVars - 40;
        for(int i = 0; i < padding; i++)
            ndis.readByte();

        roomName = getString(varsBytes, roomNameOffset);
        imageName = getString(varsBytes, imageNameOffset);
        hotspots = new Vector();
        for(int i = 0; i < nbrHotspots; i++) {
            Hotspot hs = new Hotspot();
            hs.fromBytes(ndis.isBigEndian(), varsBytes, hotspotOffset);
            hotspotOffset += Hotspot.size();
            hotspots.addElement(hs);
        }

        images = new Hashtable();
        for(int i = 0; i < nbrImages; i++) {
            ImageOverlay img = new ImageOverlay();
            img.fromBytes(ndis.isBigEndian(), varsBytes, imageOffset);
            imageOffset += ImageOverlay.size();
            images.put(new Integer(img.picID), img);
        }

        looseProps = new Vector();
        int ofst = firstLProp;
        for(int i = 0; i < nbrLProps; i++) {
            LooseProp lp = new LooseProp();
            lp.fromBytes(ndis.isBigEndian(), varsBytes, ofst);
            looseProps.addElement(lp);
            ofst = lp.nextOfst;
        }

    }

    protected String getString(byte bs[], int start) {
        int count = bs[start++];
        String s = new String(bs, 0, start, count);
        return s;
    }

    public String roomImageName() {
        return imageName;
    }

    public Vector hotspots() {
        return hotspots;
    }

    public String roomName() {
        return roomName;
    }
}
