// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.IPalaceCore;
import communities.PalaceErrorHandler;
import communities.plg.PPEventBlowThru;
import communities.plg.PluginMgr;
import communities.utl.Connection;
import communities.utl.NetDataInputStream;
import java.io.IOException;
import java.util.Hashtable;

// Referenced classes of package communities.pkt:
//            PPEventGotoRoom, PPEventLogoff, PPEventRoomDesc, PPEventServerInfo, 
//            PPEventExtendedInfo, PPEventTalk, PPEventUserList, PPEventUserlog, 
//            PPEventUserMove, PPEventUserFace, PPEventUserColor, PPEventUserStatus, 
//            PPEventUserDesc, PPEventUserName, PPEventUserNew, PPEventXTalk, 
//            PPEventUserListAll, PPEventRoomListAll, PPEventAssetQuery, PPEventAssetSend, 
//            PPEventPropNew, PPEventPropMove, PPEventPropDel, PPEventUserProp, 
//            PPEventDoorLock, PPEventSpotState, PPEventGeneric, PPEvent, 
//            PalaceEventTypes

public class PalacePacketGrabber
    implements PalaceEventTypes {

    private Connection itsConn;
    private PluginMgr itsPlugMgr;
    private Hashtable inPackets;
    private PalaceErrorHandler mErrorHandler;

    public PalacePacketGrabber(Connection itsConn, PluginMgr plugMgr) {
        this.itsConn = null;
        itsPlugMgr = null;
        inPackets = null;
        mErrorHandler = null;
        this.itsConn = itsConn;
        itsPlugMgr = plugMgr;
        mErrorHandler = plugMgr.getPalaceApplet().getErrorHandler();
        inPackets = new Hashtable();
    }

    public PPEvent getIncomingPacket(NetDataInputStream ndis) throws IOException {
        int event = ndis.readInt();
        switch(event) {
        default:
            break;

        case 1919251312: 
            itsConn.setBigEndian(true);
            break;

        case 1886610802: 
            itsConn.setBigEndian(false);
            break;

        case 1920559476: 
            if(!itsConn.isEndianSet())
                itsConn.setBigEndian(false);
            event = 0x74697972;
            break;

        case 1953069426: 
            if(!itsConn.isEndianSet())
                itsConn.setBigEndian(true);
            break;
        }
        PPEvent p = (PPEvent)inPackets.get(new Integer(event));
        if(p == null) {
            switch(event) {
            case 1851881042: 
                p = new PPEventGotoRoom();
                break;

            case 1652122912: 
                p = new PPEventLogoff();
                break;

            case 1919905645: 
            case 1934782317: 
                p = new PPEventRoomDesc();
                break;

            case 1936289382: 
                p = new PPEventServerInfo();
                break;

            case 1934192230: 
                p = new PPEventExtendedInfo();
                break;

            case 1952541803: 
            case 2003331443: 
                p = new PPEventTalk();
                break;

            case 1919971955: 
                p = new PPEventUserList();
                break;

            case 1819240224: 
                p = new PPEventUserlog();
                break;

            case 1967943523: 
                p = new PPEventUserMove();
                break;

            case 1970500166: 
                p = new PPEventUserFace();
                break;

            case 1970500163: 
                p = new PPEventUserColor();
                break;

            case 1968403553: 
                p = new PPEventUserStatus();
                break;

            case 1970500164: 
                p = new PPEventUserDesc();
                break;

            case 1970500174: 
                p = new PPEventUserName();
                break;

            case 1852863091: 
                p = new PPEventUserNew();
                break;

            case 2020895851: 
            case 2021091699: 
                p = new PPEventXTalk();
                break;

            case 1967944564: 
                p = new PPEventUserListAll();
                break;

            case 1917612916: 
                p = new PPEventRoomListAll();
                break;

            case 1900114804: 
                p = new PPEventAssetQuery();
                break;

            case 1933669236: 
                p = new PPEventAssetSend();
                break;

            case 1850765936: 
                p = new PPEventPropNew();
                break;

            case 1833988720: 
                p = new PPEventPropMove();
                break;

            case 1682993776: 
                p = new PPEventPropDel();
                break;

            case 1970500176: 
                p = new PPEventUserProp();
                break;

            case 1819239275: 
            case 1970170991: 
                p = new PPEventDoorLock();
                break;

            case 1934849121: 
                p = new PPEventSpotState();
                break;

            case 1651273591: 
                p = new PPEventBlowThru();
                break;

            default:
                p = new PPEventGeneric();
                break;
            }
            inPackets.put(new Integer(event), p);
        }
        p.readSizeAndRefnum(ndis, event);
        p.read(ndis);
        if(event == 0x74697972) {
            int connId = p.refNum();
            itsConn.setConnID(connId);
        }
        if(event == 0x626c6f77) {
            PPEvent pp = null;
            if(itsPlugMgr != null)
                pp = itsPlugMgr.getIncomingData((PPEventBlowThru)p, ndis);
            if(pp != null) {
                p = pp;
            } else {
                PPEventBlowThru pb = (PPEventBlowThru)p;
                pb.readBlowThruData(ndis);
            }
        }
        try {
            p.readRemainder(ndis);
        }
        catch(IOException e) {
            mErrorHandler.reportError("error - extra pkt data", 1);
        }
        return p;
    }
}
