// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import java.awt.List;

// Referenced classes of package communities.plg:
//            EventListRec

public class EventList {

    public java.util.Vector m_EventVector;
    public EventListRec m_lastEventAttended;
    private List mUIList;
    int numEvents;

    public EventListRec getSelectedEvent() {
        if(mUIList == null)
            return null;
        String eventName = mUIList.getSelectedItem();
        EventListRec evtListRec = null;
        if(eventName != null)
            evtListRec = findEvent(eventName);
        return evtListRec;
    }

    public boolean visualNotifyEventsAvail() {
        boolean ret = false;
        for(java.util.Enumeration evtEnum = m_EventVector.elements(); evtEnum.hasMoreElements();) {
            EventListRec currEvt = (EventListRec)evtEnum.nextElement();
            if(currEvt.m_visualNotify) {
                ret = true;
                break;
            }
        }

        return ret;
    }

    public EventList(List UIList) {
        m_EventVector = null;
        m_lastEventAttended = null;
        mUIList = null;
        numEvents = 0;
        m_EventVector = new java.util.Vector();
        mUIList = UIList;
    }

    public void setLastAttendedEvent(int stageID) {
        m_lastEventAttended = findEvent(stageID);
    }

    public void add(String eventName, String eventInfoURL, int stageID, boolean visualNotify) {
        EventListRec evtListRec = new EventListRec(eventName, eventInfoURL, stageID, visualNotify);
        if(evtListRec != null && findEvent(stageID) == null) {
            if(numEvents == 0 && mUIList != null)
                mUIList.delItem(0);
            numEvents++;
            m_EventVector.addElement(evtListRec);
            if(mUIList != null)
                mUIList.addItem(evtListRec.m_eventName);
        }
    }

    public int findEventInList(String eventName) {
        if(mUIList != null) {
            for(int i = 0; i < mUIList.countItems(); i++)
                try {
                    String itemString = mUIList.getItem(i);
                    if(itemString == eventName)
                        return i;
                }
                catch(java.util.NoSuchElementException ne) { }

        }
        return -1;
    }

    public int getEventCount() {
        return m_EventVector.size();
    }

    public void clear() {
        if(mUIList != null) {
            mUIList.clear();
            mUIList.addItem("<none>");
        }
        m_EventVector.removeAllElements();
        numEvents = 0;
    }

    public EventListRec getDefaultEvent() {
        EventListRec evtListRec = null;
        evtListRec = getSelectedEvent();
        if(evtListRec == null || !evtListRec.m_visualNotify)
            evtListRec = findFirstVisualNotifyEvent();
        return evtListRec;
    }

    public EventListRec findEvent(int StageID) {
        for(java.util.Enumeration e = m_EventVector.elements(); e.hasMoreElements();)
            try {
                EventListRec evtListRec = (EventListRec)e.nextElement();
                if(evtListRec.m_stageID == StageID)
                    return evtListRec;
            }
            catch(java.util.NoSuchElementException ne) { }

        return null;
    }

    public EventListRec findEvent(String eventName) {
        for(java.util.Enumeration e = m_EventVector.elements(); e.hasMoreElements();)
            try {
                EventListRec evtListRec = (EventListRec)e.nextElement();
                if(evtListRec.m_eventName.compareTo(eventName) == 0)
                    return evtListRec;
            }
            catch(java.util.NoSuchElementException ne) { }

        return null;
    }

    public EventListRec findFirstVisualNotifyEvent() {
        EventListRec ret = null;
        for(java.util.Enumeration evtEnum = m_EventVector.elements(); evtEnum.hasMoreElements();) {
            EventListRec currEvt = (EventListRec)evtEnum.nextElement();
            if(currEvt.m_visualNotify) {
                ret = currEvt;
                break;
            }
        }

        return ret;
    }

    public void remove(int StageID) {
        EventListRec evtListRec = findEvent(StageID);
        if(evtListRec != null) {
            if(mUIList != null) {
                int item = findEventInList(evtListRec.m_eventName);
                if(item != -1) {
                    mUIList.delItem(item);
                    m_EventVector.removeElement(evtListRec);
                    numEvents--;
                }
                if(numEvents == 0)
                    mUIList.addItem("<none>");
            }
            if(m_lastEventAttended == evtListRec)
                m_lastEventAttended = null;
        }
    }
}
