// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.utl.ImagePane;
import java.awt.*;

public class ImageButton extends ImagePane {

    private Image m_imgNormal;
    private Image m_imgHilited;
    private Image m_imgDepressed;
    private Image m_imgDisabled;
    private int m_flags;
    int mMargin;
    private boolean mMouseDown;
    private boolean mInside;
    private boolean mStuck;
    private Font buttonFont;

    public boolean mouseEnter(Event evt, int x, int y) {
        setInside(true);
        return false;
    }

    public boolean mouseExit(Event evt, int x, int y) {
        setInside(false);
        return false;
    }

    public ImageButton(Image image, Image imgDepressed, Image imgDisabled, int width, int height, int Flags) {
        this(image, null, imgDepressed, imgDisabled, width, height, Flags, 0);
    }

    public ImageButton(Image image, Image imgHilited, Image imgDepressed, Image imgDisabled, int width, int height, int Flags, 
            int margin) {
        super(image, width, height);
        m_imgNormal = null;
        m_imgHilited = null;
        m_imgDepressed = null;
        m_imgDisabled = null;
        m_flags = 0;
        mMouseDown = false;
        mInside = false;
        mStuck = false;
        buttonFont = null;
        resize(width, height);
        m_imgNormal = image;
        m_imgHilited = imgHilited;
        m_imgDepressed = imgDepressed;
        m_imgDisabled = imgDisabled;
        m_flags = Flags;
        mMargin = margin;
        buttonFont = new Font("Helvetica", 0, 12);
        setFont(buttonFont);
    }

    public void paint(Graphics g) {
        Image img;
        int offset;
        if((m_flags & 1) != 0) {
            img = m_imgDisabled != null ? m_imgDisabled : m_imgNormal;
            offset = mMargin;
        } else
        if(mMouseDown || (m_flags & 2) != 0 && mStuck) {
            img = m_imgDepressed != null ? m_imgDepressed : m_imgHilited;
            if((m_flags & 0x10) != 0)
                offset = mMargin + 1;
            else
                offset = mMargin;
        } else
        if(mInside) {
            img = m_imgHilited != null ? m_imgHilited : m_imgNormal;
            offset = mMargin;
        } else {
            img = m_imgNormal;
            offset = mMargin;
        }
        if(img != null)
            g.drawImage(img, offset, offset, this);
        if((mInside || mStuck) && (m_flags & 8) != 0)
            drawHighlight(g);
    }

    public boolean mouseUp(Event evt, int x, int y) {
        setMouseDown(false);
        if(inside(x, y) && (m_flags & 1) == 0) {
            if((m_flags & 2) != 0)
                mStuck = !mStuck;
            Event actEvt = new Event(this, 1001, evt);
            deliverEvent(actEvt);
        }
        return false;
    }

    public void setFlag(int flag) {
        m_flags |= flag;
        repaint();
    }

    public void removeFlag(int flag) {
        m_flags &= ~flag;
        repaint();
    }

    private synchronized void setInside(boolean inside) {
        mInside = inside;
        repaint();
    }

    public void setBkMode(boolean bBkMode) {
        if(bBkMode)
            setFlag(4);
        else
            removeFlag(4);
    }

    public void disable() {
        setFlag(1);
    }

    public void enable() {
        removeFlag(1);
    }

    public boolean mouseDown(Event evt, int x, int y) {
        setMouseDown(true);
        return false;
    }

    private void drawHighlight(Graphics g) {
        if(g != null && (m_flags & 1) == 0)
            if(mMouseDown || mStuck) {
                Color save = g.getColor();
                g.setColor(Color.lightGray);
                g.draw3DRect(0, 0, minimumSize().width - 1, minimumSize().height - 1, false);
                g.setColor(save);
            } else
            if(mInside) {
                Color save = g.getColor();
                g.setColor(Color.lightGray);
                g.draw3DRect(0, 0, minimumSize().width - 1, minimumSize().height - 1, true);
                g.setColor(save);
            }
    }

    public Dimension preferredSize() {
        Dimension imgDim = super.preferredSize();
        return imgDim;
    }

    public void setImage(Image image, Image imgDepressed, Image imgDisabled) {
        m_imgNormal = image;
        m_imgDepressed = imgDepressed;
        m_imgDisabled = imgDisabled;
        repaint();
    }

    public void setStuck(boolean stick) {
        mStuck = stick;
        setFlag(2);
    }

    private void setMouseDown(boolean down) {
        mMouseDown = down;
        repaint();
    }
}
