// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.pkt.PPEvent;
import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

public class PPEventBlowThru extends PPEvent {

    protected int m_BlowThruID;
    protected int m_flags;
    protected int m_noofUsers;
    protected int m_UserArray[];
    protected int m_TargetBlowThruID;
    boolean bigEndian;

    public PPEventBlowThru() {
        m_BlowThruID = 0;
        m_flags = 0;
        m_noofUsers = 0;
        m_UserArray = null;
        m_TargetBlowThruID = 0;
        bigEndian = false;
    }

    public PPEventBlowThru(PPEvent ppEvent) {
        m_BlowThruID = 0;
        m_flags = 0;
        m_noofUsers = 0;
        m_UserArray = null;
        m_TargetBlowThruID = 0;
        bigEndian = false;
        super.event = ppEvent.event;
        super.size = ppEvent.size;
        super.refNum = ppEvent.refNum;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        if(ndis.isBigEndian()) {
            ndis.setBigEndian(false);
            m_BlowThruID = ndis.readInt();
            ndis.setBigEndian(true);
        } else {
            m_BlowThruID = ndis.readInt();
        }
    }

    public void setBlowThruHeader(int flags, int noofUsers, int UserArray[], int TargetBlowThruID) {
        m_flags = flags;
        m_noofUsers = noofUsers;
        m_UserArray = new int[UserArray.length];
        for(int i = 0; i < UserArray.length; i++)
            m_UserArray[i] = UserArray[i];

        m_TargetBlowThruID = TargetBlowThruID;
        super.event = 0x626c6f77;
    }

    public int getBlowThruID() {
        return m_BlowThruID;
    }

    public void readBlowThruData(NetDataInputStream ndis) throws IOException {
        byte BlowThruData[] = new byte[super.size - 4];
        ndis.readFully(BlowThruData, 0, super.size - 4);
        BlowThruData = null;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.writeNoFlush(ndos);
        ndos.writeInt(m_flags);
        ndos.writeInt(m_noofUsers);
        for(int i = 0; i < m_UserArray.length; i++)
            ndos.writeInt(m_UserArray[i]);

        if(ndos.isBigEndian()) {
            ndos.setBigEndian(false);
            bigEndian = true;
        }
        ndos.writeInt(m_TargetBlowThruID);
    }

    public void flush(NetDataOutputStream ndos) throws IOException {
        super.flush(ndos);
        if(bigEndian)
            ndos.setBigEndian(true);
    }

    public void writeNoFlush(NetDataOutputStream ndos) throws IOException {
        if(ndos.isBigEndian()) {
            ndos.setBigEndian(false);
            bigEndian = true;
        }
        ndos.writeInt(m_flags);
        ndos.writeInt(m_noofUsers);
        for(int i = 0; i < m_UserArray.length; i++)
            ndos.writeInt(m_UserArray[i]);

        ndos.writeInt(m_TargetBlowThruID);
    }
}
