// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.*;
import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import communities.utl.ButtonInfo;
import communities.utl.ResourceInfo;
import java.awt.*;

// Referenced classes of package communities.plg:
//            PPTabPanelButtonBar

public final class PalPresentNewTabPanel extends Panel
    implements Privileged {

    private Container mContainer;
    public PPTabPanelButtonBar mButtonBar;
    public IPalaceCore mCore;
    public IPalaceUI mUI;
    public ResourceInfo mResInfo;
    private Dialog itsFrame;
    private PalaceLog m_PalPresentLog;
    private PalaceUserList m_PPUserList;
    private PalaceHelp m_PalPresentHelp;
    private AboutPanel m_About;
    private int numPanelsEnabled;
    protected static final String iconNames[] = {
        "log", "users", "help", "about"
    };
    private transient IPalaceSecurity mSecurity;

    protected Container getContainer() {
        return mContainer;
    }

    public PPTabPanelButtonBar getButtonBar() {
        return mButtonBar;
    }

    private void addTabsAndButtons() {
        ButtonInfo info[] = null;
        if(mResInfo.buttonPanelEnabled)
            info = new ButtonInfo[iconNames.length];
        Component component = null;
        for(int i = 0; i < 4; i++) {
            switch(i) {
            case 0: // '\0'
                if(mResInfo.logPanelEnabled) {
                    m_PalPresentLog = new PalaceLog(mCore, mResInfo);
                    component = m_PalPresentLog;
                }
                break;

            case 1: // '\001'
                if(mResInfo.userPanelEnabled) {
                    m_PPUserList = new PalaceUserList(mCore);
                    component = m_PPUserList;
                }
                break;

            case 2: // '\002'
                if(mResInfo.roomPanelEnabled) {
                    m_PalPresentHelp = new PalaceHelp(mCore.getErrorHandler(), mResInfo, mUI, 1);
                    component = m_PalPresentHelp;
                    m_PalPresentHelp.setSecurity(mSecurity);
                }
                break;

            case 3: // '\003'
                if(mResInfo.aboutPanelEnabled) {
                    m_About = new AboutPanel(mUI);
                    component = m_About;
                }
                break;

            default:
                component = null;
                break;
            }
            if(component != null) {
                component.reshape(0, 0, mResInfo.tabPanelRect.width, mResInfo.tabPanelRect.height);
                mContainer.add(String.valueOf(3 + i), component);
                if(mResInfo.buttonPanelEnabled) {
                    int id = 3 + i;
                    java.awt.Image enabledImage = mResInfo.getIcon(iconNames[i] + "-n");
                    java.awt.Image disabledImage = mResInfo.getIcon(iconNames[i] + "-d");
                    java.awt.Image hilitedImage = mResInfo.getIcon(iconNames[i] + "-e");
                    java.awt.Image depressedImage = null;
                    if(!mResInfo.buttonsHilight)
                        depressedImage = mResInfo.getIcon(iconNames[i] + "-p");
                    info[numPanelsEnabled] = new ButtonInfo(enabledImage, disabledImage, hilitedImage, depressedImage, id);
                }
                numPanelsEnabled++;
            }
            component = null;
        }

        if(mResInfo.buttonPanelEnabled) {
            int imageSize = 45;
            int cols = mResInfo.buttonPanelRect.width / imageSize;
            int rows = numPanelsEnabled / cols;
            if(rows * cols < numPanelsEnabled)
                rows++;
            mButtonBar = new PPTabPanelButtonBar(numPanelsEnabled, info, imageSize, imageSize, rows, cols, this);
        }
    }

    public PalaceLog getLog() {
        return m_PalPresentLog;
    }

    protected synchronized Component getCurrComponent() {
        int index = getCurrComponentIndex();
        if(index != -1)
            return mContainer.getComponent(index);
        else
            return null;
    }

    public PalPresentNewTabPanel(IPalaceUI UI, IPalaceCore aCore, IPalaceSecurity aSecurity, ResourceInfo resInfo, Dialog parentFrame) {
        mContainer = null;
        mButtonBar = null;
        mResInfo = null;
        itsFrame = null;
        m_PalPresentLog = null;
        m_PPUserList = null;
        m_PalPresentHelp = null;
        m_About = null;
        numPanelsEnabled = 0;
        mCore = aCore;
        mUI = UI;
        mSecurity = aSecurity;
        mResInfo = resInfo;
        itsFrame = parentFrame;
        setLayout(null);
        mContainer = new Panel();
        mContainer.setLayout(new CardLayout(0, 0));
        mContainer.reshape(0, 0, mResInfo.tabPanelRect.width, mResInfo.tabPanelRect.height);
        add(mContainer);
        addTabsAndButtons();
    }

    public PalaceUserList getUserList() {
        return m_PPUserList;
    }

    protected synchronized int getCurrComponentIndex() {
        int numComponents = mContainer.countComponents();
        for(int i = 0; i < numComponents; i++) {
            Component c = mContainer.getComponent(i);
            if(c.isVisible())
                return i;
        }

        return -1;
    }

    public Container getMContainer() {
        return mContainer;
    }

    public boolean mouseDown(Event e, int x, int y) {
        return true;
    }

    protected void showPanel(int id) {
        Container container = getContainer();
        CardLayout layout = (CardLayout)container.getLayout();
        Component oldComponent = getCurrComponent();
        layout.show(container, String.valueOf(id));
        Component newComponent = getCurrComponent();
        if(newComponent != oldComponent && id == 4) {
            mCore.handleRoomListRefresh();
            mCore.handleUserListRefresh();
        }
        if(itsFrame != null) {
            itsFrame.move(mResInfo.tabPanelRect.x, mResInfo.tabPanelRect.y);
            itsFrame.show();
            itsFrame.toFront();
            itsFrame.move(mResInfo.tabPanelRect.x, mResInfo.tabPanelRect.y);
        }
    }

}
