// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.pob.GraphicError;
import communities.pob.Room2D;
import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import communities.utl.ResourceInfo;
import java.awt.*;
import java.io.PrintStream;
import java.net.MalformedURLException;
import java.net.URL;

// Referenced classes of package communities.plg:
//            MyLabel, PalPresentsEventGrabber, StageDesc

class StagePanel extends Panel
    implements Privileged {

    private boolean m_roomSizeSet;
    private int m_roomPntCtr;
    private boolean m_userQues;
    PalPresentsEventGrabber m_pProtocol;
    ResourceInfo resInfo;
    Room2D m_StageRoom;
    MyLabel m_EventNameLabel;
    Image m_bgimage;
    Image m_stageImage;
    private int m_stgRmX;
    private int m_stgRmY;
    private int m_stgRmW;
    private int m_stgRmH;
    boolean m_Init;
    private transient IPalaceSecurity mSecurity;

    public void setSecurity(IPalaceSecurity m) {
        mSecurity = m;
    }

    public StagePanel(PalPresentsEventGrabber pProtocol, ResourceInfo resInfo) {
        m_roomSizeSet = false;
        m_roomPntCtr = 0;
        m_userQues = true;
        m_pProtocol = null;
        this.resInfo = null;
        m_StageRoom = null;
        m_EventNameLabel = null;
        m_bgimage = null;
        m_stageImage = null;
        m_stgRmX = 128;
        m_stgRmY = 96;
        m_stgRmW = 256;
        m_stgRmH = 192;
        m_Init = false;
        m_pProtocol = pProtocol;
        this.resInfo = resInfo;
    }

    public void paint(Graphics g) {
        if(!m_roomSizeSet) {
            java.awt.image.ImageObserver roomImOb = m_StageRoom.getCanvas();
            Image roomIm = m_StageRoom.getBgImage();
            int roomImWidth = 0;
            int roomImHeight = 0;
            if(roomIm != null) {
                roomImWidth = roomIm.getWidth(roomImOb);
                roomImHeight = roomIm.getHeight(roomImOb);
            }
            if(roomImWidth > 0 || roomImHeight > 0) {
                reshapeStgRoom(0, 0, roomImWidth, roomImHeight);
                m_roomSizeSet = true;
            } else
            if(m_roomPntCtr <= 5) {
                m_roomPntCtr++;
                repaint(1000L);
            } else {
                int defSmallWid = 256;
                int defSmallHeight = 192;
                reshapeStgRoom(0, 0, defSmallWid, defSmallHeight);
                m_roomSizeSet = true;
                GraphicError ge = new GraphicError("The stage image was not found, please contact the event moderator.");
                Graphics cg = m_StageRoom.getCanvas().getGraphics();
                try {
                    ge.draw(cg, 0, 0, defSmallWid, defSmallHeight);
                }
                catch(Exception e) {
                    System.out.println("Couldn't find stage image or display and error --asid");
                }
                finally {
                    cg.dispose();
                }
                repaint(10L);
            }
        }
        if(m_bgimage != null) {
            g.drawImage(m_bgimage, 0, 0, this);
        } else {
            g.setColor(Color.black);
            g.fillRect(0, 0, resInfo.roomWindowRect.width, resInfo.roomWindowRect.height);
        }
    }

    public void StageDesc(StageDesc stageDesc) {
        m_EventNameLabel.setText(stageDesc.m_StageName);
        String picFolder = m_pProtocol.getPicFolder();
        if(picFolder != null) {
            try {
                URL aURL = new URL(picFolder + stageDesc.m_BackgroundName.toLowerCase());
                StagePanel$ImageGetter getter = new StagePanel$ImageGetter(this, aURL);
                mSecurity.connectTo(aURL, getter);
                m_stageImage = getter.mImage;
            }
            catch(MalformedURLException mfu) { }
            catch(SecurityException e) { }
            if(m_stageImage != null)
                m_StageRoom.setBgImage(m_stageImage);
        }
        m_roomSizeSet = false;
        repaint();
    }

    public void setShape() {
        m_StageRoom.getCanvas().reshape(m_stgRmX, m_stgRmY, m_stgRmW, m_stgRmH);
        if(m_stgRmW != resInfo.roomWindowRect.width || m_stgRmH != resInfo.roomWindowRect.height)
            m_EventNameLabel.reshape(m_stgRmX, m_stgRmY - 28, m_stgRmW, 22);
        else
            m_EventNameLabel.hide();
    }

    protected void reshapeStgRoom(int x, int y, int width, int height) {
        if(x == 0)
            m_stgRmX = (resInfo.roomWindowRect.width - width) / 2;
        else
            m_stgRmX = x;
        if(y == 0)
            m_stgRmY = (resInfo.roomWindowRect.height - height) / 2;
        else
            m_stgRmY = y;
        m_stgRmW = width;
        m_stgRmH = height;
        java.awt.Canvas roomCan = m_StageRoom.getCanvas();
        roomCan.reshape(m_stgRmX, m_stgRmY, m_stgRmW, m_stgRmH);
        if(m_stgRmW != resInfo.roomWindowRect.width || m_stgRmH != resInfo.roomWindowRect.height)
            m_EventNameLabel.reshape(m_stgRmX, m_stgRmY - 28, m_stgRmW, 22);
        else
            m_EventNameLabel.hide();
    }

    public void Init(Room2D StageRoom) {
        if(m_Init)
            return;
        m_StageRoom = StageRoom;
        add(m_StageRoom.getCanvas());
        String appdataFolder = m_pProtocol.getAppletDataFolder();
        if(appdataFolder != null) {
            String bgImageName = "ppbkgd.gif";
            appdataFolder += "resource/";
            try {
                URL aURL = new URL(appdataFolder + bgImageName.toLowerCase());
                StagePanel$ImageGetter getter = new StagePanel$ImageGetter(this, aURL);
                mSecurity.connectTo(aURL, getter);
                m_bgimage = getter.mImage;
            }
            catch(MalformedURLException mfu) { }
            catch(SecurityException e) { }
        }
        m_EventNameLabel = new MyLabel("");
        m_EventNameLabel.setFont(new Font("Helvetica", 0, 14));
        m_EventNameLabel.setBackground(Color.black);
        m_EventNameLabel.setForeground(Color.yellow);
        m_EventNameLabel.setAlignment(1);
        add(m_EventNameLabel);
        m_Init = true;
    }
}
