// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import java.awt.*;
import java.util.StringTokenizer;

public class GraphicError {

    private String errorText;
    private Font useFont;
    private Color bgColor;
    private Color fgColor;

    public void draw(Graphics g, int x, int y, int areaWidth, int areaHeight) throws Exception {
        int topMargin = areaHeight / 4;
        int leftMargin = areaWidth / 8;
        int rightMargin = areaWidth / 8;
        if(g == null)
            throw new Exception("the graphics context is null");
        g.setColor(bgColor);
        g.fillRect(x, y, areaWidth, areaHeight);
        g.setColor(fgColor);
        g.setFont(useFont);
        FontMetrics fm = g.getFontMetrics(useFont);
        errorText.trim();
        errorText += " ";
        StringTokenizer st = new StringTokenizer(errorText, " ", true);
        int maxWidth = areaWidth - rightMargin;
        int yCursor = y + topMargin + fm.getMaxAscent();
        int xCursor = x + leftMargin;
        int vertIncrement = fm.getMaxAscent() + fm.getMaxDescent();
        String drawStr = st.nextToken();
        while(st.hasMoreTokens())  {
            g.drawString(drawStr, xCursor, yCursor);
            String prevStr = new String(drawStr);
            drawStr = st.nextToken();
            int nextStrWidth = fm.stringWidth(drawStr);
            if(xCursor + fm.charWidth(' ') + nextStrWidth >= maxWidth + x) {
                xCursor = x + leftMargin;
                yCursor += vertIncrement;
            } else {
                xCursor += fm.stringWidth(prevStr);
            }
        }
    }

    public GraphicError(String error) {
        this(error, new Font("Dialog", 0, 12));
    }

    public GraphicError(String error, Font useThisFont) {
        this(error, useThisFont, Color.black, Color.yellow);
    }

    public GraphicError(String error, Font useThisFont, Color background, Color foreground) {
        errorText = null;
        useFont = null;
        bgColor = null;
        fgColor = null;
        useFont = useThisFont;
        bgColor = background;
        fgColor = foreground;
        errorText = error;
    }
}
