// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.utl.NetDataInputStream;
import java.awt.*;
import java.io.*;
import java.util.Vector;

// Referenced classes of package communities.pob:
//            HEventHandlerRec, HStateRec, PalaceCommands, Room2D

public class Hotspot
    implements PalaceCommands {

    public int type;
    public int dest;
    public int id;
    public int flags;
    public int state;
    public int nbrStates;
    public Polygon polygon;
    public String hsName;
    HStateRec stateRecs[];
    Vector eventHandlerRecs;
    public int ory;
    public int orx;
    public int scriptEventMask;
    public int nbrScripts;
    byte gSPBuf[];
    int gSPIdx;
    boolean ungetFlag;
    String gToken;

    void initScriptParser(byte buffer[], int offset) {
        gSPBuf = buffer;
        gSPIdx = offset;
    }

    void parseSpotEventHandler() {
        String script = "";
        if(!getScriptToken())
            return;
        int eventType = getEventType(gToken);
        if(eventType == 27)
            System.out.println("Invalid Event Handler: ON " + gToken);
        getScriptToken();
        int braceCnt = 1;
        for(boolean doneParse = false; !doneParse && getScriptToken();)
            switch(gToken.charAt(0)) {
            case 40: // '('
            case 41: // ')'
                break;

            case 125: // '}'
                if(--braceCnt == 0)
                    doneParse = true;
                else
                    script = script + "} ";
                break;

            case 123: // '{'
                braceCnt++;
                script = script + "{ ";
                break;

            default:
                script = script + gToken + " ";
                break;
            }

        HEventHandlerRec ehp = new HEventHandlerRec(eventType, script);
        eventHandlerRecs.addElement(ehp);
        nbrScripts++;
        scriptEventMask |= 1 << eventType;
    }

    public void setState(int spotState) {
        state = spotState;
    }

    public void drawOutline(Graphics g) {
        g.setColor(Color.black);
        if(polygon != null)
            g.drawPolygon(polygon);
    }

    public void draw(Graphics g, Room2D itsRoom) {
        if(stateRecs != null && (flags & 0x14) == 0) {
            int s = state;
            if(s >= 0 && s < nbrStates)
                stateRecs[s].draw(g, orx, ory, itsRoom);
        }
        if((flags & 0x10) > 0)
            drawOutline(g);
        if((flags & 8) > 0 && hsName != null) {
            FontMetrics fm = g.getFontMetrics();
            int textW = fm.stringWidth(hsName);
            int textH = fm.getAscent() + fm.getDescent();
            int x = orx - textW / 2;
            int y = ory;
            g.setColor(Color.white);
            g.fillRect(x, y - fm.getAscent(), textW, textH);
            g.setColor(Color.black);
            g.drawString(hsName, x, y);
        }
    }

    public Hotspot() {
        type = 0;
        dest = 0;
        id = 0;
        flags = 0;
        state = 0;
        nbrStates = 0;
        polygon = null;
        hsName = null;
        stateRecs = null;
        ory = 0;
        orx = 0;
        scriptEventMask = 0;
        nbrScripts = 0;
        ungetFlag = false;
        gToken = "";
        eventHandlerRecs = new Vector();
        polygon = new Polygon();
    }

    public void xorOutline(Graphics g) {
        g.setXORMode(Color.white);
        drawOutline(g);
        g.setPaintMode();
    }

    protected String getString(byte bs[], int start) {
        int count = bs[start++];
        String s = new String(bs, 0, start, count);
        return s;
    }

    public void fromBytes(boolean bigEndian, byte bs[], int off) throws IOException {
        ByteArrayInputStream bis = new ByteArrayInputStream(bs, off, size());
        NetDataInputStream ndis = new NetDataInputStream(bis);
        ndis.setBigEndian(bigEndian);
        scriptEventMask = ndis.readInt();
        flags = ndis.readInt();
        ndis.readInt();
        ndis.readInt();
        ory = ndis.readShort();
        orx = ndis.readShort();
        id = ndis.readShort();
        dest = ndis.readShort();
        int ptCnt = ndis.readShort();
        int ptsOffset = ndis.readShort();
        type = ndis.readShort();
        ndis.readShort();
        nbrScripts = ndis.readShort();
        ndis.readShort();
        state = ndis.readShort();
        nbrStates = ndis.readShort();
        int stateRecOfst = ndis.readShort();
        int nameOffset = ndis.readShort();
        int scriptTextOffset = ndis.readShort();
        ndis.readShort();
        if(nameOffset > 0)
            hsName = getString(bs, nameOffset);
        if(nbrStates > 0) {
            stateRecs = new HStateRec[nbrStates];
            for(int i = 0; i < nbrStates; i++) {
                HStateRec hs = new HStateRec();
                hs.fromBytes(bigEndian, bs, stateRecOfst);
                stateRecOfst += HStateRec.size();
                stateRecs[i] = hs;
            }

        }
        loadScripts(bs, scriptTextOffset);
        bis = new ByteArrayInputStream(bs, ptsOffset, ptCnt * 4);
        ndis = new NetDataInputStream(bis);
        ndis.setBigEndian(bigEndian);
        int startX = 0;
        int startY = 0;
        for(int i = 0; i < ptCnt; i++) {
            int y = ndis.readShort();
            int x = ndis.readShort();
            if(i == 0) {
                startX = x;
                startY = y;
            }
            polygon.addPoint(x + orx, y + ory);
        }

        polygon.addPoint(startX + orx, startY + ory);
    }

    public static int size() {
        return 48;
    }

    int getEventType(String token) {
        if(token.equals("SELECT"))
            return 0;
        if(token.equals("ALARM"))
            return 6;
        if(token.equals("INCHAT"))
            return 8;
        if(token.equals("ENTER"))
            return 10;
        if(token.equals("LEAVE"))
            return 11;
        if(token.equals("OUTCHAT"))
            return 12;
        return !token.equals("SIGNON") ? 27 : 13;
    }

    boolean getScriptToken() {
        if(ungetFlag) {
            ungetFlag = false;
            return true;
        }
        while(gSPBuf[gSPIdx] != 0)  {
            if(gSPBuf[gSPIdx] == 0)
                return false;
            if(myIsSpace((char)gSPBuf[gSPIdx]))
                gSPIdx++;
            else
            if(gSPBuf[gSPIdx] == 35 || gSPBuf[gSPIdx] == 59) {
                for(; gSPBuf[gSPIdx] != 0 && gSPBuf[gSPIdx] != 13 && gSPBuf[gSPIdx] != 10; gSPIdx++);
            } else {
                if(Character.isLetterOrDigit((char)gSPBuf[gSPIdx]) || gSPBuf[gSPIdx] == 95 || gSPBuf[gSPIdx] == 46 || gSPBuf[gSPIdx] == 45 && Character.isDigit((char)gSPBuf[gSPIdx + 1])) {
                    int tokenStart = gSPIdx;
                    int tokenLength = 0;
                    if(gSPBuf[gSPIdx] == 45) {
                        tokenLength = 1;
                        gSPIdx++;
                    }
                    for(; Character.isLetterOrDigit((char)gSPBuf[gSPIdx]) || gSPBuf[gSPIdx] == 95 || gSPBuf[gSPIdx] == 46; gSPIdx++)
                        tokenLength++;

                    gToken = new String(gSPBuf, 0, tokenStart, tokenLength);
                    return true;
                }
                if(gSPBuf[gSPIdx] == 34) {
                    int tokenStart = gSPIdx;
                    int tokenLength = 1;
                    for(gSPIdx++; gSPBuf[gSPIdx] != 0 && gSPBuf[gSPIdx] != 34;)
                        if(gSPBuf[gSPIdx] == 92) {
                            tokenLength++;
                            gSPIdx++;
                            if(gSPBuf[gSPIdx] != 0) {
                                tokenLength++;
                                gSPIdx++;
                            }
                        } else {
                            tokenLength++;
                            gSPIdx++;
                        }

                    if(gSPBuf[gSPIdx] == 34) {
                        tokenLength++;
                        gSPIdx++;
                    }
                    gToken = new String(gSPBuf, 0, tokenStart, tokenLength);
                    return true;
                }
                if("{}[]()".indexOf(gSPBuf[gSPIdx]) != -1) {
                    int tokenStart = gSPIdx;
                    int tokenLength = 1;
                    gSPIdx++;
                    gToken = new String(gSPBuf, 0, tokenStart, tokenLength);
                    return true;
                }
                if(Character.isDefined((char)gSPBuf[gSPIdx])) {
                    int tokenStart = gSPIdx;
                    int tokenLength = 0;
                    for(; gSPBuf[gSPIdx] != 0 && Character.isDefined((char)gSPBuf[gSPIdx]) && !myIsSpace((char)gSPBuf[gSPIdx]) && !Character.isLetterOrDigit((char)gSPBuf[gSPIdx]); gSPIdx++)
                        tokenLength++;

                    gToken = new String(gSPBuf, 0, tokenStart, tokenLength);
                    return true;
                }
                System.out.println("Script Error");
            }
        }
        return false;
    }

    void loadScripts(byte bs[], int scriptTextOffset) {
        nbrScripts = 0;
        scriptEventMask = 0;
        if(scriptTextOffset > 0) {
            initScriptParser(bs, scriptTextOffset);
            while(getScriptToken()) 
                if(gToken.equals("ON"))
                    parseSpotEventHandler();
        }
    }

    boolean myIsSpace(char c) {
        return c == ' ' || c == '\t' || c == '\n' || c == '\f' || c == '\r';
    }

    String getEventHandler(int eventType) {
        if(nbrScripts > 0 && (scriptEventMask & 1 << eventType) != 0) {
            for(int i = 0; i < nbrScripts; i++) {
                HEventHandlerRec ehr = (HEventHandlerRec)eventHandlerRecs.elementAt(i);
                if(ehr.eventType == eventType)
                    return ehr.script;
            }

        }
        return null;
    }
}
