// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import com.oroinc.text.regex.*;
import communities.PalaceErrorHandler;
import java.util.*;

// Referenced classes of package communities.pob:
//            PalaceCommander, IptscraeException, IptAtom, IptGVariable, 
//            IptVariable, IptFrame, IScriptMgr, PalaceCommands

public class IptscraeMgr
    implements IScriptMgr, PalaceCommands {

    Stack pStack;
    Stack tsp;
    Vector strTable;
    Vector aryTable;
    Hashtable vList;
    Hashtable gList;
    char tbuf[];
    String scriptStr;
    int so;
    int si;
    boolean scriptRunning;
    int abortScriptCode;
    Perl5Compiler grepCompiler;
    Perl5Matcher grepMatcher;
    Pattern grepPattern;
    String grepInput;
    PalaceCommander pc;
    PalaceErrorHandler mErrorHandler;

    void sf_NETGOTO() throws IptscraeException {
        if(pc.pc_GotoURL(popString()) != 0)
            forceAbort("script contains bad URL");
    }

    void sf_SHELLCMD() throws IptscraeException {
        pc.pc_LaunchApp(popString());
    }

    void sf_EXEC() throws IptscraeException {
        IptAtom a1 = popValue();
        if(a1.type == 3)
            callSubroutine(a1.value);
    }

    void parseAtomList() throws IptscraeException {
        int nest = 0;
        boolean qFlag = false;
        int dp = 0;
        if(sc() == '{')
            so++;
        while(sc() != 0 && (sc() != '}' || nest > 0))  {
            if(qFlag) {
                if(sc() == '\\') {
                    tbuf[dp++] = sc();
                    so++;
                } else
                if(sc() == '"')
                    qFlag = false;
            } else {
                switch(sc()) {
                case 34: // '"'
                    qFlag = true;
                    break;

                case 123: // '{'
                    nest++;
                    break;

                case 125: // '}'
                    nest--;
                    break;
                }
            }
            tbuf[dp++] = sc();
            so++;
        }
        if(sc() == '}')
            so++;
        int index = addToStringTable(new String(tbuf, 0, dp));
        pushAtom(3, index);
    }

    void sf_DEF() throws IptscraeException {
        IptAtom s1 = popAtom();
        IptVariable v = getVariable(s1);
        IptAtom t = popAtom();
        assignVariable(v, t);
    }

    void sf_ITOA() throws IptscraeException {
        pushString(Integer.toString(popInt()));
    }

    void newGlobal(IptVariable var) throws IptscraeException {
        Object data;
        switch(var.type) {
        case 3: // '\003'
        case 4: // '\004'
            data = getString(var.value);
            break;

        case 6: // '\006'
            data = arrayToGlobal(var.name, var.value);
            break;

        case 5: // '\005'
        default:
            data = null;
            break;
        }
        IptGVariable gv = new IptGVariable(var.name, var.type, var.value, var.flags, data);
        gList.put(((IptVariable) (gv)).name, gv);
    }

    void updateGlobal(IptVariable var) throws IptscraeException {
        IptGVariable gv = (IptGVariable)gList.get(var.name);
        if(gv != null) {
            gv.type = var.type;
            gv.value = var.value;
            gv.flags = var.flags;
            if(var.type == 3 || var.type == 4)
                gv.data = getString(var.value);
            else
            if(var.type == 6)
                gv.data = arrayToGlobal(var.name, var.value);
            else
                gv.data = null;
        } else {
            newGlobal(var);
        }
    }

    void sf_OR() throws IptscraeException {
        pushInt(popInt() <= 0 && popInt() <= 0 ? 0 : 1);
    }

    IptVariable getVariable(IptAtom a1) throws IptscraeException {
        if(a1.type != 2)
            invalidArg();
        return getVariable(getString(a1.value));
    }

    IptVariable getVariable(String sym) throws IptscraeException {
        IptVariable iv = (IptVariable)vList.get(sym);
        if(iv == null && (iv = newVariable(sym)) == null)
            forceAbort("Internal Error");
        return iv;
    }

    void sf_WHOCHAT() throws IptscraeException {
        pushInt(pc.pc_GetWhoChat());
    }

    void sf_MIDILOOP() throws IptscraeException {
        String name = popString();
        int loopNbr = popInt();
        pc.pc_MidiLoop(loopNbr, name);
    }

    void sf_SELECT() throws IptscraeException {
        pc.pc_SelectHotspot(popInt());
    }

    void sf_NBRDOORS() throws IptscraeException {
        pushInt(pc.pc_GetNbrDoors());
    }

    void sf_ISGUEST() throws IptscraeException {
        pushInt(pc.pc_IsGuest() ? 1 : 0);
    }

    void forceAbort(String msg) throws IptscraeException {
        abortScriptCode = 5;
        throw new IptscraeException(msg);
    }

    void pushAtom(int type, int value) throws IptscraeException {
        pushAtom(new IptAtom(type, value));
    }

    void pushAtom(IptAtom atom) throws IptscraeException {
        pStack.push(atom);
    }

    IptAtom popAtom() throws IptscraeException {
        if(pStack.size() > 0) {
            return (IptAtom)pStack.pop();
        } else {
            forceAbort("Missing argument");
            return null;
        }
    }

    void sf_DIMROOM() throws IptscraeException {
        int dimLevel = popInt();
        pc.pc_DimRoom(dimLevel);
    }

    int popInt() throws IptscraeException {
        IptAtom a = popValue();
        if(a.type == 1) {
            return a.value;
        } else {
            invalidArg();
            return 0;
        }
    }

    void sf_POSY() throws IptscraeException {
        pushInt(pc.pc_GetPosY());
    }

    void sf_TICKS() throws IptscraeException {
        pushInt((int)((System.currentTimeMillis() / 17L) % 0x4f1a00L));
    }

    void sf_ISWIZARD() throws IptscraeException {
        pushInt(pc.pc_IsWizard() ? 1 : 0);
    }

    void sf_SETPOS() throws IptscraeException {
        int y = popInt();
        int x = popInt();
        pc.pc_MoveUserAbs(x, y);
    }

    void sf_TOPPROP() throws IptscraeException {
        pushInt(pc.pc_GetTopProp());
    }

    void sf_DROPPROP() throws IptscraeException {
        int y = popInt();
        int x = popInt();
        pc.pc_DropProp(x, y);
    }

    void sf_REMOVEPROP() throws IptscraeException {
        IptAtom a = popValue();
        if(a.type == 1)
            pc.pc_DoffProp(a.value);
        else
            pc.pc_DoffProp(getString(a.value));
    }

    void sf_CLEARPROPS() throws IptscraeException {
        pc.pc_Naked();
    }

    void sf_USERPROP() throws IptscraeException {
        pushInt(pc.pc_GetUserProp(popInt()));
    }

    void sf_MOUSEPOS() throws IptscraeException {
        pushInt(pc.pc_GetMouseX());
        pushInt(pc.pc_GetMouseY());
    }

    void sf_MOVE() throws IptscraeException {
        int yDelta = popInt();
        int xDelta = popInt();
        pc.pc_MoveUserRel(xDelta, yDelta);
    }

    void sf_GETSPOTSTATE() throws IptscraeException {
        pushInt(pc.pc_GetSpotState(popInt()));
    }

    void sf_SAY() throws IptscraeException {
        IptAtom atom = popValue();
        if(atom.type == 4 || atom.type == 3)
            pc.pc_Chat(getString(atom.value));
        else
            pc.pc_Chat(Integer.toString(atom.value));
    }

    int runMessageScript(String msg) {
        int index = addToStringTable(msg);
        int retVal = 0;
        try {
            if(!scriptRunning) {
                si = index;
                so = 0;
                scriptStr = getString(index);
                scriptRunning = true;
                abortScriptCode = 0;
                runScript();
                if(abortScriptCode >= 4)
                    pc.pc_ClearAlarms();
                scriptRunning = false;
                if(pStack.size() > 0) {
                    IptAtom atom = popValue();
                    if(atom.type == 1)
                        retVal = atom.value;
                }
                initInterpreter();
            } else {
                callSubroutine(index);
            }
        }
        catch(IptscraeException ie) {
            pc.pc_ClearAlarms();
            scriptRunning = false;
            completeAbort(ie.getMessage());
            initInterpreter();
        }
        return retVal;
    }

    void runScript() throws IptscraeException {
        if(abortScriptCode != 0)
            return;
        char sc;
        while((sc = sc()) != 0 && abortScriptCode == 0) 
            if(sc == ' ' || sc == '\t' || sc == '\r' || sc == '\n' || sc == ';')
                so++;
            else
            if(sc == '#')
                while((sc = sc()) != 0 && sc != '\r' && sc != '\n') 
                    so++;
            else
            if(sc == '{')
                parseAtomList();
            else
            if(sc == '"') {
                parseStringLiteral();
            } else {
                if(sc == '}')
                    return;
                if(sc == '[') {
                    so++;
                    pushAtom(5, 0);
                } else
                if(sc == ']') {
                    so++;
                    pushAtom(6, popArrayDef());
                } else
                if(sc == '!') {
                    if(sc(1) == '=') {
                        IptAtom a2 = popAtom();
                        IptAtom a1 = popAtom();
                        binaryOp('a', a1, a2);
                        so++;
                        so++;
                    } else {
                        IptAtom a1 = popAtom();
                        unaryOp('!', a1);
                        so++;
                    }
                } else
                if(sc == '=') {
                    if(sc(1) == '=') {
                        IptAtom a2 = popAtom();
                        IptAtom a1 = popAtom();
                        binaryOp('=', a1, a2);
                        so++;
                        so++;
                    } else {
                        IptAtom a2 = popAtom();
                        IptAtom a1 = popAtom();
                        IptVariable v = getVariable(a2);
                        assignVariable(v, a1);
                        so++;
                    }
                } else
                if(sc == '+') {
                    if(sc(1) == '+') {
                        IptAtom a1 = popAtom();
                        unaryAssignment('+', a1);
                        so++;
                        so++;
                    } else
                    if(sc(1) == '=') {
                        IptAtom a2 = popAtom();
                        IptAtom a1 = popAtom();
                        binaryAssignment('+', a1, a2);
                        so++;
                        so++;
                    } else {
                        IptAtom a2 = popAtom();
                        IptAtom a1 = popAtom();
                        binaryOp('+', a1, a2);
                        so++;
                    }
                } else
                if(sc == '-' && (sc(1) < '0' || sc(1) > '9')) {
                    if(sc(1) == '-') {
                        IptAtom a1 = popAtom();
                        unaryAssignment('-', a1);
                        so++;
                        so++;
                    } else
                    if(sc(1) == '=') {
                        IptAtom a2 = popAtom();
                        IptAtom a1 = popAtom();
                        binaryAssignment('-', a1, a2);
                        so++;
                        so++;
                    } else {
                        IptAtom a2 = popAtom();
                        IptAtom a1 = popAtom();
                        binaryOp('-', a1, a2);
                        so++;
                    }
                } else
                if(sc == '<') {
                    char oper = '<';
                    if(sc(1) == '>') {
                        oper = 'a';
                        so++;
                    } else
                    if(sc(1) == '=') {
                        oper = 'b';
                        so++;
                    }
                    IptAtom a2 = popAtom();
                    IptAtom a1 = popAtom();
                    binaryOp(oper, a1, a2);
                    so++;
                } else
                if(sc == '>') {
                    char oper = '>';
                    if(sc(1) == '=') {
                        oper = 'c';
                        so++;
                    }
                    IptAtom a2 = popAtom();
                    IptAtom a1 = popAtom();
                    binaryOp(oper, a1, a2);
                    so++;
                } else
                if(sc == '*' || sc == '/' || sc == '&' || sc == '%') {
                    char oper = sc;
                    IptAtom a2 = popAtom();
                    IptAtom a1 = popAtom();
                    if(sc(1) == '=') {
                        binaryAssignment(oper, a1, a2);
                        so++;
                    } else {
                        binaryOp(oper, a1, a2);
                    }
                    so++;
                } else
                if(sc == '-' || sc >= '0' && sc <= '9')
                    parseNumber();
                else
                if(sc == '_' || sc >= 'a' && sc <= 'z' || sc >= 'A' && sc <= 'Z')
                    parseSymbol();
                else
                    forceAbort("Unexpected character: '" + (new Character(sc)).toString() + "'");
            }
    }

    void sf_PUT() throws IptscraeException {
        int idx = popInt();
        IptAtom a = popAtom();
        Vector ary = null;
        IptAtom atom = popValue();
        boolean isGlobal = false;
        IptGVariable gv = null;
        switch(a.type) {
        case 6: // '\006'
            ary = getArray(a.value);
            break;

        case 2: // '\002'
            IptVariable vt = getVariable(a);
            if(vt != null)
                if((vt.flags & 1) > 0) {
                    gv = (IptGVariable)gList.get(vt.name);
                    if(gv != null) {
                        ary = (Vector)gv.data;
                        isGlobal = true;
                    }
                } else {
                    ary = getArray(vt.value);
                }
            break;
        }
        if(ary == null)
            invalidArg();
        if(idx >= 0 && idx < ary.size())
            if(isGlobal)
                ary.setElementAt(atomToGVariable(idx + "_" + ((IptVariable) (gv)).name, atom), idx);
            else
                ary.setElementAt(atom, idx);
    }

    void sf_DOORIDX() throws IptscraeException {
        pushInt(pc.pc_GetDoorIdx(popInt()));
    }

    void sf_FOREACH() throws IptscraeException {
        Vector ary = popArray();
        IptAtom atomList = popValue();
        if(atomList.type != 3)
            return;
        for(int i = 0; i < ary.size() && abortScriptCode == 0; i++) {
            pushAtom(((IptAtom)ary.elementAt(i)).cloneAtom());
            callSubroutine(atomList.value);
        }

        if(abortScriptCode == 1)
            abortScriptCode = 0;
    }

    void sf_DELAY() throws IptscraeException {
        pc.pc_Delay(popInt());
    }

    public void stop() {
        pc.pc_ClearAlarms();
        scriptRunning = false;
        completeAbort("application stopped");
        initInterpreter();
    }

    void sf_SETSPOTSTATELOCAL() throws IptscraeException {
        int id = popInt();
        int state = popInt();
        pc.pc_SetSpotStateLocal(id, state);
    }

    void sf_GET() throws IptscraeException {
        int idx = popInt();
        IptAtom a = popAtom();
        Vector ary = null;
        boolean isGlobal = false;
        switch(a.type) {
        case 6: // '\006'
            ary = getArray(a.value);
            break;

        case 2: // '\002'
            IptVariable vt = getVariable(a);
            if(vt != null)
                if((vt.flags & 1) > 0) {
                    IptGVariable gv = (IptGVariable)gList.get(vt.name);
                    if(gv != null) {
                        ary = (Vector)gv.data;
                        isGlobal = true;
                    }
                } else {
                    ary = getArray(vt.value);
                }
            break;
        }
        if(ary == null)
            invalidArg();
        if(idx >= 0 && idx < ary.size()) {
            if(isGlobal)
                pushAtom(gVariableToAtom((IptGVariable)ary.elementAt(idx)));
            else
                pushAtom(((IptAtom)ary.elementAt(idx)).cloneAtom());
        } else {
            pushInt(0);
        }
    }

    void sf_WHOTARGET() throws IptscraeException {
        pushInt(pc.pc_GetWhoTarget());
    }

    void sf_BREAK() {
        abortScriptCode = 1;
    }

    void sf_BEEP() throws IptscraeException {
        pc.pc_Beep();
    }

    void sf_SPOTDEST() throws IptscraeException {
        pushInt(pc.pc_GetSpotDest(popInt()));
    }

    void sf_LAUNCHAPP() throws IptscraeException {
        pc.pc_LaunchApp(popString());
    }

    void sf_MACRO() throws IptscraeException {
        pc.pc_DoMacro(popInt());
    }

    void sf_IF() throws IptscraeException {
        int expResult = popInt();
        IptAtom s1 = popAtom();
        if(expResult != 0) {
            atomToValue(s1);
            if(s1.type == 3)
                callSubroutine(s1.value);
        }
    }

    void sf_SETCOLOR() throws IptscraeException {
        pc.pc_ChangeColor(popInt());
    }

    void sf_SPOTNAME() throws IptscraeException {
        pushString(pc.pc_GetSpotName(popInt()));
    }

    void sf_WHONAME() throws IptscraeException {
        pushString(pc.pc_GetUserName(popInt()));
    }

    void sf_USERNAME() throws IptscraeException {
        pushString(pc.pc_GetUserName());
    }

    void sf_STRTOATOM() throws IptscraeException {
        pushAtom(3, addToStringTable(popString()));
    }

    void sf_RANDOM() throws IptscraeException {
        pushInt((int)(Math.random() * (double)popInt()));
    }

    void sf_DUP() throws IptscraeException {
        if(pStack.size() > 0) {
            IptAtom p1 = (IptAtom)pStack.peek();
            pushAtom(p1.cloneAtom());
        }
    }

    void retrieveGlobal(IptVariable var) {
        IptGVariable gv = (IptGVariable)gList.get(var.name);
        if(gv != null) {
            var.type = ((IptVariable) (gv)).type;
            var.value = ((IptVariable) (gv)).value;
            var.flags = ((IptVariable) (gv)).flags;
            switch(var.type) {
            case 3: // '\003'
            case 4: // '\004'
                var.value = addToStringTable((String)gv.data);
                break;

            case 6: // '\006'
                var.value = globalToArray((Vector)gv.data);
                break;
            }
        }
    }

    Vector arrayToGlobal(String arrayName, int aIdx) throws IptscraeException {
        Vector lAry = getArray(aIdx);
        Vector gAry = new Vector();
        for(int i = 0; i < lAry.size(); i++) {
            IptAtom atom = (IptAtom)lAry.elementAt(i);
            String vName = i + "_" + arrayName;
            gAry.addElement(atomToGVariable(vName, atom));
        }

        return gAry;
    }

    void sf_LAUNCHEVENT() throws IptscraeException {
        pc.pc_LaunchEvent(popString());
    }

    void sf_LOADJAVA() throws IptscraeException {
        pc.pc_LoadJava(popString());
    }

    void sf_IFELSE() throws IptscraeException {
        int expResult = popInt();
        IptAtom se1 = popAtom();
        IptAtom s1 = popAtom();
        if(expResult != 0) {
            atomToValue(s1);
            if(s1.type == 3)
                callSubroutine(s1.value);
        } else {
            atomToValue(se1);
            if(se1.type == 3)
                callSubroutine(se1.value);
        }
    }

    int popArrayDef() throws IptscraeException {
        Vector ary = new Vector();
        IptAtom a;
        do {
            a = popValue();
            if(a.type != 5)
                ary.insertElementAt(a, 0);
        } while(pStack.size() > 0 && a.type != 5);
        return addToArrayTable(ary);
    }

    void sf_NBRROOMUSERS() throws IptscraeException {
        pushInt(pc.pc_GetNbrRoomUsers());
    }

    public IptscraeMgr(PalaceCommander pc) {
        pStack = new Stack();
        tsp = new Stack();
        strTable = new Vector();
        aryTable = new Vector();
        vList = new Hashtable();
        gList = new Hashtable();
        tbuf = new char[4086];
        scriptStr = "";
        so = 0;
        si = 0;
        scriptRunning = false;
        abortScriptCode = 0;
        grepCompiler = new Perl5Compiler();
        grepMatcher = new Perl5Matcher();
        grepPattern = null;
        grepInput = "";
        this.pc = null;
        this.pc = pc;
        pc.setScriptManager(this);
        initInterpreter();
    }

    void sf_DATETIME() throws IptscraeException {
        pushInt((int)(System.currentTimeMillis() / 1000L));
    }

    void completeAbort(String msg) {
        if(mErrorHandler != null)
            mErrorHandler.reportError("Aborting script: " + msg, 0);
        abortScriptCode = 5;
    }

    void sf_SUBSTR() throws IptscraeException {
        String frag = popString().toUpperCase();
        String whole = popString().toUpperCase();
        pushInt(whole.indexOf(frag) == -1 ? 0 : 1);
    }

    IptAtom gVariableToAtom(IptGVariable gVar) {
        int type = ((IptVariable) (gVar)).type;
        int val = ((IptVariable) (gVar)).value;
        switch(((IptVariable) (gVar)).type) {
        case 3: // '\003'
        case 4: // '\004'
            val = addToStringTable((String)gVar.data);
            break;

        case 6: // '\006'
            val = globalToArray((Vector)gVar.data);
            break;
        }
        return new IptAtom(type, val);
    }

    void sf_WHOME() throws IptscraeException {
        pushInt(pc.pc_GetUserID());
    }

    void sf_LOCK() throws IptscraeException {
        int id = popInt();
        pc.pc_Lock(id);
    }

    void sf_MIDISTOP() throws IptscraeException {
        pc.pc_MidiStop();
    }

    void sf_GOTOROOM() throws IptscraeException {
        int dest = popInt();
        pc.pc_GotoRoom(dest);
    }

    void sf_INSPOT() throws IptscraeException {
        pushInt(pc.pc_InSpot(popInt()) ? 1 : 0);
    }

    void sf_GLOBALMSG() throws IptscraeException {
        pc.pc_GlobalMsg(popString());
    }

    void sf_ROOMMSG() throws IptscraeException {
        pc.pc_RoomMsg(popString());
    }

    void sf_SUSRMSG() throws IptscraeException {
        pc.pc_SusrMsg(popString());
    }

    void sf_LOCALMSG() throws IptscraeException {
        pc.pc_LocalMsg(popString());
    }

    void sf_DONPROP() throws IptscraeException {
        IptAtom a = popValue();
        if(a.type == 1)
            pc.pc_DonProp(a.value);
        else
            pc.pc_DonProp(getString(a.value));
    }

    void sf_SETPROPS() throws IptscraeException {
        Vector ary = popArray();
        pc.pc_SetProps(ary);
    }

    void sf_HASPROP() throws IptscraeException {
        IptAtom a = popValue();
        if(a.type == 1)
            pushInt(pc.pc_HasProp(a.value) ? 1 : 0);
        else
        if(a.type == 4)
            pushInt(pc.pc_HasProp(getString(a.value)) ? 1 : 0);
        else
            pushInt(0);
    }

    void sf_ROOMNAME() throws IptscraeException {
        pushString(pc.pc_GetRoomName());
    }

    void sf_ISLOCKED() throws IptscraeException {
        pushInt(pc.pc_IsLocked(popInt()) ? 1 : 0);
    }

    void sf_SETSPOTSTATE() throws IptscraeException {
        int id = popInt();
        int state = popInt();
        pc.pc_SetSpotState(id, state);
    }

    void sf_MIDIPLAY() throws IptscraeException {
        pc.pc_MidiPlay(popString());
    }

    void sf_DOFFPROP() throws IptscraeException {
        pc.pc_DoffProp();
    }

    void sf_ISGOD() throws IptscraeException {
        pushInt(pc.pc_IsGod() ? 1 : 0);
    }

    void parseStringLiteral() throws IptscraeException {
        int dp = 0;
        if(sc() == '"')
            so++;
        while(sc() != 0 && sc() != '"') 
            if(sc() == '\\') {
                so++;
                if(sc() == 'x') {
                    char c = '\0';
                    so++;
                    c = (char)(sc() < '0' || sc() > '9' ? sc() < 'a' || sc() > 'f' ? sc() < 'A' || sc() > 'F' ? 0 : (10 + sc()) - 65 : (10 + sc()) - 97 : sc() - 48);
                    c <<= '\004';
                    so++;
                    c |= sc() < '0' || sc() > '9' ? ((char) (sc() < 'a' || sc() > 'f' ? ((char) (sc() < 'A' || sc() > 'F' ? '\0' : ((char) ((10 + sc()) - 65)))) : ((char) ((10 + sc()) - 97)))) : ((char) (sc() - 48));
                    so++;
                    tbuf[dp++] = c;
                } else {
                    tbuf[dp++] = sc();
                    so++;
                }
            } else {
                tbuf[dp++] = sc();
                so++;
            }
        if(sc() == '"')
            so++;
        pushString(new String(tbuf, 0, dp));
    }

    void sf_UPPERCASE() throws IptscraeException {
        pushString(popString().toUpperCase());
    }

    void sf_GREPSUB() throws IptscraeException {
        String replaceStr = popString();
        String result = "";
        if(grepPattern != null)
            result = Util.substitute(grepMatcher, grepPattern, replaceStr, grepInput, -1, 0);
        pushString(result);
    }

    void sf_LENGTH() throws IptscraeException {
        IptAtom a = popAtom();
        Vector ary = null;
        boolean isGlobal = false;
        switch(a.type) {
        case 6: // '\006'
            ary = getArray(a.value);
            break;

        case 2: // '\002'
            IptVariable vt = getVariable(a);
            if(vt != null)
                if((vt.flags & 1) > 0) {
                    IptGVariable gv = (IptGVariable)gList.get(vt.name);
                    if(gv != null) {
                        ary = (Vector)gv.data;
                        isGlobal = true;
                    }
                } else {
                    ary = getArray(vt.value);
                }
            break;
        }
        if(ary == null)
            invalidArg();
        pushInt(ary.size());
    }

    int globalToArray(Vector gAry) {
        Vector lAry = new Vector();
        for(int i = 0; i < gAry.size(); i++) {
            IptGVariable gvar = (IptGVariable)gAry.elementAt(i);
            IptAtom atom = gVariableToAtom(gvar);
            lAry.addElement(atom);
        }

        return addToArrayTable(lAry);
    }

    IptAtom atomToValue(IptAtom atom) throws IptscraeException {
        if(atom.type == 2) {
            IptVariable vt = getVariable(atom);
            if(vt != null) {
                if((vt.flags & 1) > 0)
                    retrieveGlobal(vt);
                else
                if((vt.flags & 2) > 0)
                    retrieveExternStringGlobalByName(vt);
                atom.type = vt.type;
                atom.value = vt.value;
            }
        }
        return atom;
    }

    IptAtom popValue() throws IptscraeException {
        return atomToValue(popAtom());
    }

    void pushInt(int v) throws IptscraeException {
        pushAtom(1, v);
    }

    void initInterpreter() {
        scriptRunning = false;
        tsp.removeAllElements();
        pStack.removeAllElements();
        vList.clear();
        strTable.removeAllElements();
        aryTable.removeAllElements();
    }

    void sf_NBRUSERPROPS() throws IptscraeException {
        pushInt(pc.pc_GetNbrUserProps());
    }

    void retrieveExternStringGlobalByName(IptVariable var) {
        if(var.name.equals("CHATSTR"))
            retrieveExternStringGlobal(var, 0);
    }

    char sc() {
        return sc(0);
    }

    char sc(int offset) {
        if(so + offset < 0 || so + offset >= scriptStr.length())
            return '\0';
        else
            return scriptStr.charAt(so + offset);
    }

    String popAtomList() throws IptscraeException {
        IptAtom a = popValue();
        if(a.type == 3) {
            return getString(a.value);
        } else {
            invalidArg();
            return null;
        }
    }

    void sf_STATUSMSG() throws IptscraeException {
        String statStr = popString();
        pc.pc_StatusMsg(statStr);
    }

    void sf_SOUND() throws IptscraeException {
        pc.pc_PlaySound(popString());
    }

    void sf_POSX() throws IptscraeException {
        pushInt(pc.pc_GetPosX());
    }

    void parseNumber() throws IptscraeException {
        int n = 0;
        boolean negFlag = false;
        if(sc() == '-') {
            negFlag = true;
            so++;
        }
        while(sc() >= '0' && sc() <= '9')  {
            n *= 10;
            n += sc() - 48;
            so++;
        }
        if(negFlag)
            n = -n;
        pushInt(n);
    }

    void parseSymbol() throws IptscraeException {
        int dp = 0;
        char sc;
        while((sc = sc()) >= 'a' && sc <= 'z' || sc >= 'A' && sc <= 'Z' || sc >= '0' && sc <= '9' || sc == '_')  {
            so++;
            if(Character.isLowerCase(sc))
                sc = Character.toUpperCase(sc);
            tbuf[dp++] = sc;
        }
        String token = new String(tbuf, 0, dp);
        if(token.equals("NOT"))
            sf_NOT();
        else
        if(token.equals("AND"))
            sf_AND();
        else
        if(token.equals("OR"))
            sf_OR();
        else
        if(token.equals("EXEC"))
            sf_EXEC();
        else
        if(token.equals("IF"))
            sf_IF();
        else
        if(token.equals("IFELSE"))
            sf_IFELSE();
        else
        if(token.equals("WHILE"))
            sf_WHILE();
        else
        if(token.equals("GLOBAL"))
            sf_GLOBAL();
        else
        if(token.equals("DEF"))
            sf_DEF();
        else
        if(token.equals("RETURN"))
            sf_RETURN();
        else
        if(token.equals("BREAK"))
            sf_BREAK();
        else
        if(token.equals("DUP"))
            sf_DUP();
        else
        if(token.equals("SWAP"))
            sf_SWAP();
        else
        if(token.equals("POP"))
            sf_POP();
        else
        if(token.equals("STRTOATOM"))
            sf_STRTOATOM();
        else
        if(token.equals("SUBSTR"))
            sf_SUBSTR();
        else
        if(token.equals("ITOA"))
            sf_ITOA();
        else
        if(token.equals("ATOI"))
            sf_ATOI();
        else
        if(token.equals("UPPERCASE"))
            sf_UPPERCASE();
        else
        if(token.equals("LOWERCASE"))
            sf_LOWERCASE();
        else
        if(token.equals("DELAY"))
            sf_DELAY();
        else
        if(token.equals("RANDOM"))
            sf_RANDOM();
        else
        if(token.equals("RND"))
            sf_RANDOM();
        else
        if(token.equals("GREPSTR"))
            sf_GREPSTR();
        else
        if(token.equals("GREPSUB"))
            sf_GREPSUB();
        else
        if(token.equals("BEEP"))
            sf_BEEP();
        else
        if(token.equals("DATETIME"))
            sf_DATETIME();
        else
        if(token.equals("TICKS"))
            sf_TICKS();
        else
        if(token.equals("SETALARM"))
            sf_SETALARM();
        else
        if(token.equals("ALARMEXEC"))
            sf_ALARMEXEC();
        else
        if(token.equals("GET"))
            sf_GET();
        else
        if(token.equals("PUT"))
            sf_PUT();
        else
        if(token.equals("ARRAY"))
            sf_ARRAY();
        else
        if(token.equals("FOREACH"))
            sf_FOREACH();
        else
        if(token.equals("LENGTH"))
            sf_LENGTH();
        else
        if(token.equals("LOGMSG"))
            sf_LOGMSG();
        else
        if(token.equals("GOTOROOM"))
            sf_GOTOROOM();
        else
        if(token.equals("LOCK"))
            sf_LOCK();
        else
        if(token.equals("SETPICLOC"))
            sf_SETPICLOC();
        else
        if(token.equals("SETLOC"))
            sf_SETLOC();
        else
        if(token.equals("SETSPOTSTATE"))
            sf_SETSPOTSTATE();
        else
        if(token.equals("SETSPOTSTATELOCAL"))
            sf_SETSPOTSTATELOCAL();
        else
        if(token.equals("GETSPOTSTATE"))
            sf_GETSPOTSTATE();
        else
        if(token.equals("ADDLOOSEPROP"))
            sf_ADDLOOSEPROP();
        else
        if(token.equals("TOPPROP"))
            sf_TOPPROP();
        else
        if(token.equals("DROPPROP"))
            sf_DROPPROP();
        else
        if(token.equals("DOFFPROP"))
            sf_DOFFPROP();
        else
        if(token.equals("DONPROP"))
            sf_DONPROP();
        else
        if(token.equals("REMOVEPROP"))
            sf_REMOVEPROP();
        else
        if(token.equals("CLEARPROPS"))
            sf_CLEARPROPS();
        else
        if(token.equals("NAKED"))
            sf_CLEARPROPS();
        else
        if(token.equals("CLEARLOOSEPROPS"))
            sf_CLEARLOOSEPROPS();
        else
        if(token.equals("SETCOLOR"))
            sf_SETCOLOR();
        else
        if(token.equals("SETFACE"))
            sf_SETFACE();
        else
        if(token.equals("UNLOCK"))
            sf_UNLOCK();
        else
        if(token.equals("ISLOCKED"))
            sf_ISLOCKED();
        else
        if(token.equals("GLOBALMSG"))
            sf_GLOBALMSG();
        else
        if(token.equals("SAY"))
            sf_SAY();
        else
        if(token.equals("ROOMMSG"))
            sf_ROOMMSG();
        else
        if(token.equals("SUSRMSG"))
            sf_SUSRMSG();
        else
        if(token.equals("LOCALMSG"))
            sf_LOCALMSG();
        else
        if(token.equals("DEST"))
            sf_DEST();
        else
        if(token.equals("ME"))
            sf_ME();
        else
        if(token.equals("ID"))
            sf_ME();
        else
        if(token.equals("LAUNCHAPP"))
            sf_LAUNCHAPP();
        else
        if(token.equals("SHELLCMD"))
            sf_SHELLCMD();
        else
        if(token.equals("KILLUSER"))
            sf_KILLUSER();
        else
        if(token.equals("NETGOTO"))
            sf_NETGOTO();
        else
        if(token.equals("GOTOURL"))
            sf_NETGOTO();
        else
        if(token.equals("MACRO"))
            sf_MACRO();
        else
        if(token.equals("MOVE"))
            sf_MOVE();
        else
        if(token.equals("SETPOS"))
            sf_SETPOS();
        else
        if(token.equals("INSPOT"))
            sf_INSPOT();
        else
        if(token.equals("SHOWLOOSEPROPS"))
            sf_SHOWLOOSEPROPS();
        else
        if(token.equals("SERVERNAME"))
            sf_SERVERNAME();
        else
        if(token.equals("USERNAME"))
            sf_USERNAME();
        else
        if(token.equals("SETPROPS"))
            sf_SETPROPS();
        else
        if(token.equals("SELECT"))
            sf_SELECT();
        else
        if(token.equals("NBRSPOTS"))
            sf_NBRSPOTS();
        else
        if(token.equals("NBRDOORS"))
            sf_NBRDOORS();
        else
        if(token.equals("DOORIDX"))
            sf_DOORIDX();
        else
        if(token.equals("SPOTIDX"))
            sf_SPOTIDX();
        else
        if(token.equals("WHOCHAT"))
            sf_WHOCHAT();
        else
        if(token.equals("WHOME"))
            sf_WHOME();
        else
        if(token.equals("POSX"))
            sf_POSX();
        else
        if(token.equals("POSY"))
            sf_POSY();
        else
        if(token.equals("PRIVATEMSG"))
            sf_PRIVATEMSG();
        else
        if(token.equals("STATUSMSG"))
            sf_STATUSMSG();
        else
        if(token.equals("SPOTDEST"))
            sf_SPOTDEST();
        else
        if(token.equals("ISGUEST"))
            sf_ISGUEST();
        else
        if(token.equals("ISWIZARD"))
            sf_ISWIZARD();
        else
        if(token.equals("ISGOD"))
            sf_ISGOD();
        else
        if(token.equals("DIMROOM"))
            sf_DIMROOM();
        else
        if(token.equals("SPOTNAME"))
            sf_SPOTNAME();
        else
        if(token.equals("SOUND"))
            sf_SOUND();
        else
        if(token.equals("MIDIPLAY"))
            sf_MIDIPLAY();
        else
        if(token.equals("MIDILOOP"))
            sf_MIDILOOP();
        else
        if(token.equals("MIDISTOP"))
            sf_MIDISTOP();
        else
        if(token.equals("HASPROP"))
            sf_HASPROP();
        else
        if(token.equals("NBRUSERPROPS"))
            sf_NBRUSERPROPS();
        else
        if(token.equals("USERPROP"))
            sf_USERPROP();
        else
        if(token.equals("USERID"))
            sf_USERID();
        else
        if(token.equals("WHOPOS"))
            sf_WHOPOS();
        else
        if(token.equals("NBRROOMUSERS"))
            sf_NBRROOMUSERS();
        else
        if(token.equals("ROOMUSER"))
            sf_ROOMUSER();
        else
        if(token.equals("MOUSEPOS"))
            sf_MOUSEPOS();
        else
        if(token.equals("SAYAT"))
            sf_SAYAT();
        else
        if(token.equals("WHONAME"))
            sf_WHONAME();
        else
        if(token.equals("WHOTARGET"))
            sf_WHOTARGET();
        else
        if(token.equals("ROOMNAME"))
            sf_ROOMNAME();
        else
        if(token.equals("ROOMID"))
            sf_ROOMID();
        else
        if(token.equals("LAUNCHPPA"))
            sf_LAUNCHPPA();
        else
        if(token.equals("LOADJAVA"))
            sf_LOADJAVA();
        else
        if(token.equals("TALKPPA"))
            sf_TALKPPA();
        else
        if(token.equals("LAUNCHEVENT"))
            sf_LAUNCHEVENT();
        else
            pushAtom(2, addToStringTable(token));
    }

    void sf_SETPICLOC() throws IptscraeException {
        int id = popInt();
        int y = popInt();
        int x = popInt();
        pc.pc_SetPicOffset(id, x, y);
    }

    void sf_KILLUSER() throws IptscraeException {
        int userID = popInt();
        pc.pc_KillUser(userID);
    }

    void sf_SPOTIDX() throws IptscraeException {
        pushInt(pc.pc_GetSpotIdx(popInt()));
    }

    void updateExternStringGlobal(IptVariable var) {
        if(var.name.equals("CHATSTR"))
            pc.pc_SetChatString(getString(var.value));
        else
            return;
    }

    void assignVariable(IptVariable var, IptAtom atom) throws IptscraeException {
        atomToValue(atom);
        var.type = atom.type;
        var.value = atom.value;
        if((var.flags & 1) > 0)
            updateGlobal(var);
        else
        if((var.flags & 2) > 0)
            updateExternStringGlobal(var);
    }

    IptGVariable atomToGVariable(String vName, IptAtom atom) throws IptscraeException {
        int flags = 0;
        Object data;
        switch(atom.type) {
        case 3: // '\003'
        case 4: // '\004'
            data = getString(atom.value);
            break;

        case 6: // '\006'
            data = arrayToGlobal(vName, atom.value);
            break;

        case 5: // '\005'
        default:
            data = null;
            break;
        }
        return new IptGVariable(vName, atom.type, atom.value, flags, data);
    }

    int addToStringTable(String s) {
        int size = strTable.size();
        int n;
        for(n = 0; n < size; n++) {
            String ts = (String)strTable.elementAt(n);
            if(ts.equals(s))
                return n;
        }

        strTable.addElement(s);
        return n;
    }

    int addToArrayTable(Vector v) {
        int n = aryTable.size();
        aryTable.addElement(v);
        return n;
    }

    void binaryOp(char opType, IptAtom a1, IptAtom a2) throws IptscraeException {
        int result = 0;
        int resultType = 1;
        atomToValue(a1);
        atomToValue(a2);
        switch(opType) {
        default:
            break;

        case 61: // '='
            if(a1.type == 1 && a2.type == 1) {
                result = a1.value != a2.value ? 0 : 1;
                break;
            }
            if(a1.type == 4 && a2.type == 4)
                result = getString(a1.value).equalsIgnoreCase(getString(a2.value)) ? 1 : 0;
            else
                result = 0;
            break;

        case 43: // '+'
            if(a1.type == 1 && a2.type == 1) {
                result = a1.value + a2.value;
                break;
            }
            if(a1.type == 4 && a2.type == 4) {
                result = addToStringTable(getString(a1.value) + getString(a2.value));
                resultType = 4;
            } else {
                result = 0;
            }
            break;

        case 45: // '-'
            result = a1.value - a2.value;
            break;

        case 42: // '*'
            result = a1.value * a2.value;
            break;

        case 47: // '/'
            result = a2.value != 0 ? a1.value / a2.value : 0;
            break;

        case 37: // '%'
            result = a2.value != 0 ? a1.value % a2.value : 0;
            break;

        case 60: // '<'
            result = a1.value >= a2.value ? 0 : 1;
            break;

        case 62: // '>'
            result = a1.value <= a2.value ? 0 : 1;
            break;

        case 98: // 'b'
            result = a1.value > a2.value ? 0 : 1;
            break;

        case 99: // 'c'
            result = a1.value < a2.value ? 0 : 1;
            break;

        case 97: // 'a'
            result = a1.value == a2.value ? 0 : 1;
            break;

        case 38: // '&'
            if(a1.type == 4 && a2.type == 4) {
                result = addToStringTable(getString(a1.value) + getString(a2.value));
                resultType = 4;
            } else {
                result = 0;
            }
            break;
        }
        pushAtom(resultType, result);
    }

    void unaryOp(char opType, IptAtom a1) throws IptscraeException {
        int result = 0;
        int resultType = 1;
        atomToValue(a1);
        switch(opType) {
        case 33: // '!'
            result = a1.value <= 0 ? 1 : 0;
            break;
        }
        pushAtom(resultType, result);
    }

    void globalizeVariable(IptVariable var) {
        var.flags |= 1;
    }

    void assignVariable(IptVariable var, int type, int value) throws IptscraeException {
        assignVariable(var, new IptAtom(type, value));
    }

    void sf_POP() throws IptscraeException {
        popAtom();
    }

    void sf_NBRSPOTS() throws IptscraeException {
        pushInt(pc.pc_GetNbrSpots());
    }

    void unaryAssignment(char opType, IptAtom a1) throws IptscraeException {
        IptAtom v1 = new IptAtom(a1.type, a1.value);
        atomToValue(v1);
        IptVariable v = getVariable(a1);
        switch(opType) {
        case 43: // '+'
            assignVariable(v, v1.type, v1.value + 1);
            break;

        case 45: // '-'
            assignVariable(v, v1.type, v1.value - 1);
            break;
        }
    }

    void binaryAssignment(char opType, IptAtom n1, IptAtom a1) throws IptscraeException {
        atomToValue(n1);
        IptAtom v1 = new IptAtom(a1.type, a1.value);
        atomToValue(v1);
        IptVariable v = getVariable(a1);
        switch(opType) {
        case 43: // '+'
            assignVariable(v, v1.type, v1.value + n1.value);
            break;

        case 45: // '-'
            assignVariable(v, v1.type, v1.value - n1.value);
            break;

        case 42: // '*'
            assignVariable(v, v1.type, v1.value * n1.value);
            break;

        case 47: // '/'
            assignVariable(v, v1.type, n1.value != 0 ? v1.value / n1.value : 0);
            break;

        case 37: // '%'
            assignVariable(v, v1.type, n1.value != 0 ? v1.value % n1.value : 0);
            break;

        case 38: // '&'
            assignVariable(v, 4, addToStringTable(getString(v1.value) + getString(n1.value)));
            break;
        }
    }

    void pushString(String s) throws IptscraeException {
        pushAtom(4, addToStringTable(s));
    }

    String popString() throws IptscraeException {
        IptAtom a = popValue();
        if(a.type == 4) {
            return getString(a.value);
        } else {
            invalidArg();
            return null;
        }
    }

    String getString(int index) {
        if(index >= 0 && index < strTable.size())
            return (String)strTable.elementAt(index);
        else
            return "";
    }

    void sf_GLOBAL() throws IptscraeException {
        IptAtom s1 = popAtom();
        IptVariable v = getVariable(s1);
        globalizeVariable(v);
    }

    void sf_UNLOCK() throws IptscraeException {
        int id = popInt();
        pc.pc_Unlock(id);
    }

    void sf_SAYAT() throws IptscraeException {
        int y = popInt();
        int x = popInt();
        String chatStr = popString();
        pc.pc_Chat("@" + x + "," + y + " " + chatStr);
    }

    Vector popArray() throws IptscraeException {
        IptAtom a = popValue();
        if(a.type == 6) {
            return getArray(a.value);
        } else {
            invalidArg();
            return null;
        }
    }

    Vector getArray(int index) throws IptscraeException {
        if(index >= 0 && index < aryTable.size()) {
            return (Vector)aryTable.elementAt(index);
        } else {
            forceAbort("Internal Error: Bad Array Reference");
            return null;
        }
    }

    void sf_SETFACE() throws IptscraeException {
        pc.pc_ChangeFace(popInt());
    }

    void callSubroutine(int index) throws IptscraeException {
        if(abortScriptCode != 0)
            return;
        if(tsp.size() >= 16)
            return;
        tsp.push(new IptFrame(si, so));
        si = index;
        so = 0;
        scriptStr = getString(index);
        runScript();
        IptFrame iFrame = (IptFrame)tsp.pop();
        so = iFrame.offset;
        si = iFrame.index;
        scriptStr = getString(si);
        if(abortScriptCode == 2)
            abortScriptCode = 0;
    }

    void sf_LOGMSG() throws IptscraeException {
        IptAtom atom = popValue();
        if(atom.type == 4 || atom.type == 3)
            pc.pc_LogMessage(getString(atom.value));
        else
            pc.pc_LogMessage(Integer.toString(atom.value));
    }

    void sf_PRIVATEMSG() throws IptscraeException {
        int whoID = popInt();
        String chatStr = popString();
        pc.pc_PrivateMsg(whoID, chatStr);
    }

    void sf_ADDLOOSEPROP() throws IptscraeException {
        int y = popInt();
        int x = popInt();
        int id = 0;
        IptAtom p = popValue();
        if(p.type == 1)
            id = p.value;
        else
        if(p.type == 4)
            id = pc.pc_GetPropIDByName(getString(p.value));
        if(id != 0)
            pc.pc_AddLooseProp(id, x, y);
    }

    void sf_CLEARLOOSEPROPS() throws IptscraeException {
        pc.pc_DelLooseProp(-1);
    }

    void sf_SHOWLOOSEPROPS() throws IptscraeException {
        pc.pc_ShowLooseProps();
    }

    void sf_WHOPOS() throws IptscraeException {
        IptAtom a = popValue();
        int x = 0;
        int y = 0;
        int id = 0;
        if(a.type == 4)
            id = pc.pc_GetUserByName(getString(a.value));
        else
        if(a.type == 1)
            id = a.value;
        if(id != 0) {
            x = pc.pc_GetPosX(a.value);
            y = pc.pc_GetPosY(a.value);
        }
        pushInt(x);
        pushInt(y);
    }

    void sf_ROOMID() throws IptscraeException {
        pushInt(pc.pc_GetRoomID());
    }

    void sf_SWAP() throws IptscraeException {
        IptAtom p2 = popAtom();
        IptAtom p1 = popAtom();
        pushAtom(p2);
        pushAtom(p1);
    }

    void sf_LAUNCHPPA() throws IptscraeException {
        pc.pc_LaunchPPA(popString());
    }

    void sf_TALKPPA() throws IptscraeException {
        pc.pc_TalkPPA(popString());
    }

    void sf_ME() throws IptscraeException {
        pushInt(pc.pc_GetCurSpotID());
    }

    void sf_ALARMEXEC() throws IptscraeException {
        int futureTime = popInt();
        String aList = popAtomList();
        pc.pc_SetScriptAlarm(aList, pc.pc_GetCurSpotID(), futureTime);
    }

    IptVariable newVariable(String sym) {
        IptVariable vp = new IptVariable(sym, 1, 0, 0);
        if(sym.equals("CHATSTR")) {
            vp.flags |= 2;
            retrieveExternStringGlobal(vp, 0);
        }
        vList.put(sym, vp);
        return vp;
    }

    public int doScript(String script) {
        return runMessageScript(script);
    }

    void sf_USERID() throws IptscraeException {
        pushInt(pc.pc_GetUserID());
    }

    void sf_SETLOC() throws IptscraeException {
        int id = popInt();
        int y = popInt();
        int x = popInt();
        pc.pc_SetLoc(id, x, y);
    }

    void sf_ROOMUSER() throws IptscraeException {
        pushInt(pc.pc_GetRoomUser(popInt()));
    }

    void retrieveExternStringGlobal(IptVariable var, int index) {
        String s = "";
        if(index == 0)
            s = pc.pc_GetChatString();
        var.value = addToStringTable(s);
        var.type = 4;
    }

    void sf_NOT() throws IptscraeException {
        pushInt(popInt() <= 0 ? 1 : 0);
    }

    void sf_DEST() throws IptscraeException {
        pushInt(pc.pc_GetSpotDest());
    }

    void invalidArg() throws IptscraeException {
        forceAbort("Invalid argument");
    }

    void sf_GREPSTR() throws IptscraeException {
        String pat = popString();
        grepInput = popString();
        try {
            grepPattern = grepCompiler.compile(pat);
        }
        catch(MalformedPatternException e) {
            grepPattern = null;
            forceAbort("Bad GREPSTR Pattern");
        }
        pushInt(grepMatcher.contains(grepInput, grepPattern) ? 1 : 0);
    }

    void sf_LOWERCASE() throws IptscraeException {
        pushString(popString().toLowerCase());
    }

    void sf_WHILE() throws IptscraeException {
        IptAtom e1 = popValue();
        IptAtom s1 = popValue();
        int expResult;
        do {
            if(e1.type == 3) {
                callSubroutine(e1.value);
                expResult = popInt();
            } else {
                expResult = e1.value;
            }
            if(expResult != 0 && s1.type == 3)
                callSubroutine(s1.value);
        } while(expResult != 0 && abortScriptCode == 0);
        if(abortScriptCode == 1)
            abortScriptCode = 0;
    }

    void sf_ATOI() throws IptscraeException {
        int v;
        try {
            v = Integer.parseInt(popString());
        }
        catch(NumberFormatException nfe) {
            v = 0;
        }
        pushInt(v);
    }

    void sf_SETALARM() throws IptscraeException {
        int spotID = popInt();
        int futureTime = popInt();
        if(spotID == 0)
            spotID = pc.pc_GetCurSpotID();
        pc.pc_SetSpotAlarm(spotID, futureTime);
    }

    void sf_RETURN() {
        abortScriptCode = 2;
    }

    void sf_SERVERNAME() throws IptscraeException {
        pushString(pc.pc_GetServerName());
    }

    void sf_AND() throws IptscraeException {
        pushInt(popInt() <= 0 || popInt() <= 0 ? 0 : 1);
    }

    void sf_ARRAY() throws IptscraeException {
        int idx = popInt();
        if(idx >= 0) {
            Vector ary = new Vector(idx);
            for(int n = 0; n < idx; n++) {
                ary.addElement(new IptAtom(1, 0));
                pushAtom(6, addToArrayTable(ary));
            }

        } else {
            pushAtom(1, 0);
        }
    }
}
