// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.utl.NetDataInputStream;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.io.ByteArrayInputStream;
import java.io.IOException;

// Referenced classes of package communities.pob:
//            PropTable, PalaceProp, Room, Room2D, 
//            DrawableObject

public class LooseProp
    implements DrawableObject {

    public int nextOfst;
    public int id;
    public int crc;
    public int flags;
    public int y;
    public int x;
    PalaceProp itsProp;
    Room2D itsRoom;

    public void draw(Object obj) {
        Graphics g = (Graphics)obj;
        if(itsProp == null)
            itsProp = ((Room) (itsRoom)).propTable.PropReference(id, crc);
        if(itsProp != null) {
            int x;
            int y;
            synchronized(this) {
                x = this.x;
                y = this.y;
            }
            synchronized(itsProp) {
                x -= itsProp.hOffset;
                y -= itsProp.vOffset;
            }
            itsProp.DrawProp(g, itsRoom, x, y);
        }
    }

    public LooseProp() {
        nextOfst = 0;
        id = 0;
        crc = 0;
        flags = 0;
        y = 0;
        x = 0;
        itsProp = null;
        itsRoom = null;
    }

    public LooseProp(Room2D itsRoom, int id, int crc, int x, int y) {
        nextOfst = 0;
        this.id = 0;
        this.crc = 0;
        flags = 0;
        this.y = 0;
        this.x = 0;
        itsProp = null;
        this.itsRoom = null;
        this.id = id;
        this.crc = crc;
        this.x = x;
        this.y = y;
        setRoom(itsRoom);
    }

    public void moveProp(int x, int y) {
        synchronized(this) {
            this.x = x;
            this.y = y;
        }
        update(getBounds());
    }

    public void fromBytes(boolean bigEndian, byte bs[], int off) throws IOException {
        ByteArrayInputStream bis = new ByteArrayInputStream(bs, off, size());
        NetDataInputStream ndis = new NetDataInputStream(bis);
        ndis.setBigEndian(bigEndian);
        nextOfst = ndis.readShort();
        ndis.readShort();
        id = ndis.readInt();
        crc = ndis.readInt();
        flags = ndis.readInt();
        ndis.readInt();
        y = ndis.readShort();
        x = ndis.readShort();
    }

    public static int size() {
        return 24;
    }

    public boolean checkReception() {
        if(itsProp.justReceived) {
            itsProp.DecodeProp(itsRoom);
            return true;
        } else {
            return false;
        }
    }

    public void setRoom(Room2D itsRoom) {
        this.itsRoom = itsRoom;
        if(itsProp == null)
            itsProp = ((Room) (itsRoom)).propTable.PropReference(id, crc);
    }

    public void update(Rectangle r) {
        if(itsRoom != null)
            itsRoom.update(r);
    }

    public boolean ptInside(int mx, int my) {
        if(itsProp == null)
            return false;
        else
            return itsProp.ptInside(mx, my, x, y);
    }

    public Rectangle getBounds() {
        if(itsProp != null)
            return new Rectangle(x - itsProp.hOffset, y - itsProp.vOffset, 44, 44);
        else
            return new Rectangle(x, y, 0, 0);
    }
}
