// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.*;
import communities.pkt.*;
import communities.plg.IPalacePresents;
import communities.utl.*;
import java.awt.Polygon;
import java.io.PrintStream;
import java.util.Enumeration;
import java.util.Vector;

// Referenced classes of package communities.pob:
//            Room, Hotspot, User, Room2D, 
//            IScriptMgr, ScriptAlarm, UserRec, PalaceCommands

public class PalaceCommander
    implements PalaceMsgStrings, PalaceCommands {

    IPalaceCore theCore;
    Room2D room;
    IScriptMgr scriptMgr;
    User curWhoChat;
    User curWhoTarget;
    Hotspot curSpot;
    String curChatString;
    int curEventType;
    Vector alarmList;

    public boolean pc_InSpot(int id) {
        Hotspot hs = room.getHotspot(id);
        User usr = room.getUser(((Room) (room)).userID);
        if(hs != null && usr != null)
            return hs.polygon.inside(usr.x, usr.y);
        else
            return false;
    }

    public void pc_AddLooseProp(int id, int x, int y) {
        unsupportedSelectEvent();
    }

    public void pc_DelLooseProp(int i) {
    }

    public int pc_GetMouseY() {
        return 0;
    }

    public int pc_GetCurSpotID() {
        Hotspot spot = curSpot;
        if(spot != null)
            return spot.id;
        else
            return 0;
    }

    public void pc_DimRoom(int i) {
    }

    public void pc_MoveUserAbs(int x, int y) {
        room.moveSelf(x, y);
    }

    public boolean pc_IsLocked(int id) {
        Hotspot hs = room.getHotspot(id);
        if(hs != null)
            return hs.state != 0;
        else
            return false;
    }

    public void pc_MidiLoop(int i, String s) {
    }

    public String pc_GetUserName() {
        return pc_GetUserName(0);
    }

    public String pc_GetUserName(int id) {
        if(id == 0)
            id = ((Room) (room)).userID;
        User usr = room.getUser(id);
        if(usr != null)
            return usr.name;
        else
            return "";
    }

    public int pc_GetUserByName(String name) {
        User usr = room.getUserByName(name);
        if(usr != null)
            return usr.id;
        else
            return 0;
    }

    public int pc_GetSpotDest() {
        return pc_GetSpotDest(0);
    }

    public int pc_GetSpotDest(int id) {
        Hotspot hs;
        if(id == 0)
            hs = curSpot;
        else
            hs = room.getHotspot(id);
        if(hs != null)
            return hs.dest;
        else
            return 0;
    }

    public int pc_ExecuteScript(String script) {
        if(scriptMgr != null)
            return doScriptWithSync(script);
        else
            return -1;
    }

    public void setRoom(Room2D room) {
        this.room = room;
    }

    public void pc_GlobalMsg(String s1) {
    }

    public void pc_GotoRoom(int dest) {
        theCore.gotoNewRoom(dest);
    }

    public void triggerHotspotEvent(Hotspot hs, int eventType) {
        curEventType = eventType;
        String script = hs.getEventHandler(eventType);
        if(script != null)
            pc_DoSpotScript(hs, script);
        else
        if(eventType == 0)
            switch(hs.type) {
            default:
                break;

            case 1: // '\001'
                if(hs.dest != 0)
                    theCore.gotoNewRoom(hs.dest);
                break;

            case 2: // '\002'
            case 3: // '\003'
                if(hs.state == 1) {
                    room.statusMessage("Sorry", "Sorry, the Door is locked");
                    break;
                }
                if(hs.dest != 0)
                    theCore.gotoNewRoom(hs.dest);
                break;

            case 4: // '\004'
                Hotspot destDoor = room.getHotspot(hs.dest);
                if(destDoor == null)
                    break;
                if(destDoor.state == 1)
                    pc_Unlock(hs.dest);
                else
                    pc_Lock(hs.dest);
                break;
            }
    }

    public void unsupportedSelectEvent() {
        if(curEventType == 0)
            room.statusMessage("Members Only", "Sorry, that action is unsupported for InstantPalace.");
    }

    public int pc_GetMouseX() {
        return 0;
    }

    public void pc_ChangeColor(int cNbr) {
        room.setUserColorNbr(((Room) (room)).userID, cNbr);
        PPEventUserColor upc = new PPEventUserColor(((Room) (room)).userID, cNbr);
        theCore.sendPPEvent(upc);
    }

    public void pc_LaunchApp(String s) {
    }

    public int pc_GetUserID() {
        return ((Room) (room)).userID;
    }

    public int pc_GetNbrSpots() {
        return ((Room) (room)).hotspots.size();
    }

    public void pc_Beep() {
    }

    public int pc_GetNbrRoomUsers() {
        return ((Room) (room)).users.size();
    }

    public void pc_SetProps(Vector ary) {
        unsupportedSelectEvent();
    }

    public void pc_SetChatString(String cString) {
        curChatString = cString;
    }

    public void pc_DoMacro(int i) {
    }

    public void setScriptManager(IScriptMgr scriptMgr) {
        this.scriptMgr = scriptMgr;
    }

    public void pc_KillUser(int i) {
    }

    public void pc_SetLoc(int i, int j, int k) {
    }

    public void pc_SelectHotspot(int id) {
        Hotspot hs = room.getHotspot(id);
        if(hs != null) {
            String script = hs.getEventHandler(0);
            if(script != null) {
                Hotspot oldSpot = curSpot;
                scriptMgr.doScript(script);
                curSpot = oldSpot;
            }
        }
    }

    public void pc_Chat(String msg) {
        PPEventXTalk xt = new PPEventXTalk(msg, ((Room) (room)).userID);
        theCore.sendPPEvent(xt);
    }

    public String pc_GetChatString() {
        return curChatString;
    }

    public int pc_GetWhoChat() {
        if(curWhoChat != null)
            return curWhoChat.id;
        else
            return 0;
    }

    public void pc_DoffProp() {
    }

    public void pc_DoffProp(int i) {
    }

    public void pc_DoffProp(String s) {
    }

    public boolean pc_IsWizard() {
        return false;
    }

    public String pc_GetSpotName(int id) {
        Hotspot hs = room.getHotspot(id);
        if(hs != null)
            return hs.hsName;
        else
            return "";
    }

    public void pc_LogMessage(String msg) {
        IPalaceUI ui = theCore.getUI();
        if(ui != null)
            ui.logText(null, msg, false);
    }

    public void pc_SetWhoTarget(User whoTarget) {
        curWhoTarget = whoTarget;
    }

    public void pc_Naked() {
    }

    public void pc_RoomMsg(String msg) {
        PPEventTalk rtlk = new PPEventTalk(msg, ((Room) (room)).userID);
        rtlk.setToRoomMessage();
        theCore.sendPPEvent(rtlk);
    }

    public void pc_TalkPPA(String s) {
    }

    public int pc_GetSpotIdx(int idx) {
        Hotspot hs = room.getHotspotByIndex(idx);
        if(hs != null)
            return hs.id;
        else
            return 0;
    }

    public void pc_SetSpotAlarm(int spotID, int futureTime) {
        ScriptAlarm sAlarm = new ScriptAlarm(spotID, futureTime, this);
        alarmList.addElement(sAlarm);
    }

    public void pc_SetScriptAlarm(String script, int spotID, int futureTime) {
        if(theCore.getResourceInfo().getDebug() > 0)
            System.out.println("Setting Alarm for Script in " + futureTime + " ticks");
        ScriptAlarm sAlarm = new ScriptAlarm(script, spotID, futureTime, this);
        alarmList.addElement(sAlarm);
    }

    public void pc_Lock(int id) {
        PPEventDoorLock ulock = new PPEventDoorLock(((Room) (room)).userID, ((Room) (room)).roomID, id, true);
        theCore.sendPPEvent(ulock);
    }

    public boolean pc_IsGod() {
        return false;
    }

    public UserRec pc_GetUserRec(int id) {
        UserRec usrRec = null;
        if(room == null)
            return null;
        if(id == 0)
            id = ((Room) (room)).userID;
        User usr = room.getUser(id);
        if(usr != null)
            usrRec = new UserRec(usr.id, usr.x, usr.y, usr.roomId, usr.faceNbr, usr.colorNbr, usr.awayFlag, usr.openToMsgs, usr.numberProps, usr.propIDs, usr.propCRCs, usr.name);
        return usrRec;
    }

    public int pc_GetNbrDoors() {
        int sum = 0;
        for(Enumeration e = ((Room) (room)).hotspots.elements(); e.hasMoreElements();) {
            Hotspot hs = (Hotspot)e.nextElement();
            if(hs.type == 1 || hs.type == 2 || hs.type == 3)
                sum++;
        }

        return sum;
    }

    public void pc_LaunchEvent(String eventName) {
        if(theCore.getPalacePresents() == null)
            return;
        String errorText = "Unable to join the event: " + eventName;
        if(eventName == null || eventName.length() < 1) {
            pc_LogMessage(errorText);
            return;
        } else {
            theCore.getPalacePresents().JoinEvent(eventName);
            return;
        }
    }

    public void pc_SetSpotStateLocal(int spotID, int state) {
        room.setSpotState(((Room) (room)).roomID, spotID, state);
    }

    public int pc_GetNbrUserProps() {
        return 0;
    }

    public void pc_MidiStop() {
    }

    public int pc_GetRoomID() {
        return ((Room) (room)).roomID;
    }

    public int pc_GetPosY() {
        return pc_GetPosY(((Room) (room)).userID);
    }

    public int pc_GetPosY(int id) {
        User usr = room.getUser(id);
        if(usr != null)
            return usr.y;
        else
            return 0;
    }

    public void pc_ClearAlarms() {
        for(int i = 0; i < alarmList.size(); i++) {
            ScriptAlarm alarm = (ScriptAlarm)alarmList.elementAt(i);
            alarm.abort();
        }

        alarmList.removeAllElements();
    }

    public int pc_GetRoomUser(int idx) {
        if(idx >= 0 && idx < ((Room) (room)).users.size())
            return ((User)((Room) (room)).users.elementAt(idx)).id;
        else
            return 0;
    }

    public void pc_DonProp(int propID) {
        unsupportedSelectEvent();
    }

    public void pc_ChangeFace(int faceNumber) {
        room.setUserFaceNbr(((Room) (room)).userID, faceNumber);
        PPEventUserFace upf = new PPEventUserFace(((Room) (room)).userID, faceNumber);
        theCore.sendPPEvent(upf);
    }

    public void pc_DonProp(String propName) {
        unsupportedSelectEvent();
    }

    public void pc_DropProp(int i, int j) {
    }

    public boolean pc_HasProp(int propID) {
        return false;
    }

    public boolean pc_HasProp(String propName) {
        return false;
    }

    public int pc_GetUserProp(int idx) {
        return 0;
    }

    public void pc_SetSpotState(int id, int state) {
        PPEventSpotState ss = new PPEventSpotState(((Room) (room)).userID, ((Room) (room)).roomID, id, state);
        theCore.sendPPEvent(ss);
    }

    public void pc_Delay(int i) {
    }

    public void pc_LoadJava(String s) {
    }

    public int pc_GetPosX() {
        return pc_GetPosX(((Room) (room)).userID);
    }

    public int pc_GetPosX(int id) {
        User usr = room.getUser(id);
        if(usr != null)
            return usr.x;
        else
            return 0;
    }

    public int pc_GetTopProp() {
        return 0;
    }

    public String pc_GetRoomName() {
        return ((Room) (room)).name;
    }

    public boolean pc_IsGuest() {
        return true;
    }

    public int pc_GetPropIDByName(String propName) {
        return 0;
    }

    public int pc_GetDoorIdx(int idx) {
        int sum = 0;
        for(int n = 0; n < ((Room) (room)).hotspots.size(); n++) {
            Hotspot hs = (Hotspot)((Room) (room)).hotspots.elementAt(n);
            if(hs.type == 1 || hs.type == 2 || hs.type == 3) {
                if(sum == idx)
                    return hs.id;
                sum++;
            }
        }

        return 0;
    }

    public void triggerHotspotEvents(int eventType) {
        if(room != null && ((Room) (room)).hotspots != null) {
            Hotspot hs;
            for(Enumeration e = ((Room) (room)).hotspots.elements(); e.hasMoreElements(); triggerHotspotEvent(hs, eventType))
                hs = (Hotspot)e.nextElement();

        }
    }

    public void pc_SusrMsg(String s1) {
    }

    public void pc_LocalMsg(String msg) {
        IPalaceUI ui = theCore.getUI();
        if(ui != null)
            ui.logText(null, msg, false);
        room.roomSpeech(msg, false);
    }

    public void pc_StatusMsg(String msg) {
        IPalaceUI ui = theCore.getUI();
        if(ui != null)
            ui.logText(null, msg, false);
        room.statusMessage(msg);
    }

    public int pc_GetWhoTarget() {
        if(curWhoTarget != null)
            return curWhoTarget.id;
        else
            return 0;
    }

    public void pc_SetPicOffset(int i, int j, int k) {
    }

    public void pc_LaunchPPA(String s) {
    }

    synchronized int doScriptWithSync(String script) {
        return scriptMgr.doScript(script);
    }

    public void pc_PrivateMsg(int i, String s) {
    }

    public void pc_Unlock(int id) {
        PPEventDoorLock ulock = new PPEventDoorLock(((Room) (room)).userID, ((Room) (room)).roomID, id, false);
        theCore.sendPPEvent(ulock);
    }

    public void pc_MoveUserRel(int xd, int yd) {
        User usr = room.getUser(((Room) (room)).userID);
        if(usr != null)
            room.moveSelf(usr.x + xd, usr.y + yd);
    }

    public PalaceCommander(IPalaceCore theCore) {
        this.theCore = null;
        room = null;
        scriptMgr = null;
        curWhoChat = null;
        curWhoTarget = null;
        curSpot = null;
        curChatString = "";
        curEventType = 0;
        alarmList = new Vector();
        this.theCore = theCore;
        room = theCore.getRoom();
    }

    public void pc_PlaySound(String name) {
        PalaceSound sound = new PalaceSound(name, theCore);
        sound.start();
    }

    public synchronized void handleAlarm(ScriptAlarm ref) {
        if(alarmList.contains(ref)) {
            alarmList.removeElement(ref);
            switch(ref.type) {
            case 0: // '\0'
                Hotspot hs = room.getHotspot(ref.spotID);
                if(hs != null)
                    triggerHotspotEvent(hs, 6);
                else
                if(theCore.getResourceInfo().getDebug() > 0)
                    System.out.println("Spot not found");
                break;

            case 1: // '\001'
                if(theCore.getResourceInfo().getDebug() > 0 && ref.script != null) {
                    Hotspot hss = room.getHotspot(ref.spotID);
                    Hotspot oldspot = curSpot;
                    if(hss != null)
                        curSpot = hss;
                    pc_ExecuteScript(ref.script);
                    curSpot = oldspot;
                }
                break;
            }
        } else
        if(theCore.getResourceInfo().getDebug() > 0)
            System.out.println("Ignoring Old Alarm");
    }

    public synchronized int pc_DoSpotScript(Hotspot hs, String script) {
        if(scriptMgr != null) {
            curSpot = hs;
            return doScriptWithSync(script);
        } else {
            return -1;
        }
    }

    public void pc_MoveSelf(int x, int y) {
        room.moveUser(((Room) (room)).userID, x, y);
        PPEventUserMove um = new PPEventUserMove(((Room) (room)).userID, x, y);
        theCore.sendPPEvent(um);
    }

    public void pc_ShowLooseProps() {
    }

    public int pc_GotoURL(String urlName) {
        theCore.gotoURL(urlName, "PalaceLink");
        return 0;
    }

    public void pc_MidiPlay(String s) {
    }

    public int pc_GetSpotState(int id) {
        Hotspot hs = room.getHotspot(id);
        if(hs != null)
            return hs.state;
        else
            return 0;
    }

    public String pc_GetServerName() {
        return theCore.getAppletStatus().serverName;
    }
}
