// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.*;
import communities.pkt.*;
import communities.plg.*;
import communities.utl.*;
import java.io.IOException;
import java.io.PrintStream;

// Referenced classes of package communities.pob:
//            Room, PropTable, Room2D, PalaceCommander, 
//            User, User2D, UserRec

public class PalaceEventsThread
    implements Runnable, PalaceMsgStrings {

    IPalaceCore theCore;
    Palace2DCanvas canvas;
    Room2D room;

    void processEvent(PPEvent p) {
        if(theCore.getPluginMgr() != null)
            theCore.getPluginMgr().notifyPPEvent(p);
        switch(p.type()) {
        case 1651273591: 
        {
            PPEventBlowThru pb = (PPEventBlowThru)p;
            if(theCore.getPluginMgr() != null)
                theCore.getPluginMgr().dispatchBlowThruEvent(pb);
            break;
        }

        case 1953069426: 
        {
            room.setUserID(p.refNum());
            String defName = theCore.getUserName();
            PPEventLogon lg = new PPEventLogon(((Room) (room)).userID, defName != null ? defName : theCore.getResourceInfo().defaultName, theCore.getResourceInfo().mRmID);
            theCore.sendPPEvent(lg);
            ((Room) (room)).propTable.ProvideUserID(((Room) (room)).userID);
            break;
        }

        case 1919251312: 
        {
            Connection aConnection = theCore.getConnection();
            if(aConnection != null)
                aConnection.setRespPort(p.refNum());
            break;
        }

        case 1886610802: 
        {
            Connection aConnection = theCore.getConnection();
            if(aConnection != null)
                aConnection.setRespPort(p.refNum());
            break;
        }

        case 1819240224: 
        {
            PPEventUserlog ul = (PPEventUserlog)p;
            theCore.getRoom().totalUsers = ul.userCount();
            theCore.showStatus();
            break;
        }

        case 1936289382: 
        {
            PPEventServerInfo si = (PPEventServerInfo)p;
            theCore.getAppletStatus().serverName = si.serverName();
            break;
        }

        case 1934192230: 
        {
            PPEventExtendedInfo ei = (PPEventExtendedInfo)p;
            System.out.println("Server version: " + ei.strVERS);
            System.out.println("Server name   : " + ei.strNAME);
            if(ei.avatarDir == null || ei.pictureDir == null)
                System.out.println("This server does not fully support InstantPalace.");
            theCore.getResourceInfo().setFacesDir(ei.avatarDir);
            theCore.getResourceInfo().setPicFolder(ei.pictureDir);
            theCore.runIntro();
            break;
        }

        case 1952541803: 
        case 2003331443: 
        {
            if(!theCore.isNavInProgress()) {
                PPEventTalk tlk = (PPEventTalk)p;
                boolean privateFlag = p.type() == 0x77686973;
                User u = room.getUser(tlk.refNum());
                theCore.getUI().logText(u, tlk.msg(), privateFlag);
                if(isSound(tlk.msg()))
                    playSound(tlk.msg());
                else
                if(u != null)
                    room.userSpeech(tlk.refNum(), tlk.msg(), privateFlag);
                else
                    room.roomSpeech(tlk.msg(), privateFlag);
            }
            break;
        }

        case 2020895851: 
        case 2021091699: 
        {
            if(!theCore.isNavInProgress()) {
                PPEventXTalk xtlk = (PPEventXTalk)p;
                User ux = room.getUser(xtlk.refNum());
                boolean privateFlag = p.type() == 0x78776973;
                String xmsg = xtlk.msg();
                theCore.getUI().logText(ux, xmsg, privateFlag);
                if(isSound(xmsg))
                    playSound(xmsg);
                else
                if(ux != null)
                    room.userSpeech(xtlk.refNum(), xmsg, privateFlag);
                else
                    room.roomSpeech(xmsg, privateFlag);
            }
            break;
        }

        case 1919905645: 
        {
            if(canvas != null)
                canvas.freeze(true);
            theCore.NewRoomDesc(p, true);
            break;
        }

        case 1701733490: 
        {
            if(canvas != null)
                canvas.freeze(false);
            break;
        }

        case 1934782317: 
        {
            if(canvas != null)
                canvas.freeze(true);
            theCore.NewRoomDesc(p, false);
            if(canvas != null)
                canvas.freeze(false);
            break;
        }

        case 1933931122: 
        {
            theCore.setNavInProgress(false);
            if(theCore.getUI() != null)
                theCore.getUI().stopCycling();
            break;
        }

        case 1919971955: 
        {
            PPEventUserList uList = (PPEventUserList)p;
            if(canvas != null)
                canvas.freeze(true);
            room.clearUsers();
            theCore.showStatus();
            for(int i = 0; i < uList.userCount(); i++) {
                User2D newUser = newUserFromRec(uList.userRec(i));
                room.addUser(newUser);
                if(((User) (newUser)).id == ((Room) (theCore.getRoom())).userID) {
                    theCore.setUserName(((User) (newUser)).name);
                    theCore.showStatus();
                }
            }

            room.CheckUserProps();
            if(canvas != null)
                canvas.freeze(false);
            break;
        }

        case 1919248233: 
        {
            theCore.getRoom().totalUsers++;
            theCore.showStatus();
            break;
        }

        case 1652122912: 
        {
            PPEventLogoff lgo = (PPEventLogoff)p;
            int lgRefNum = lgo.refNum();
            if(lgRefNum == ((Room) (room)).chatTargetID) {
                room.chatTargetID = 0;
                theCore.getPalaceCommander().pc_SetWhoTarget(null);
                theCore.showStatus();
            }
            room.removeUser(lgRefNum);
            theCore.getRoom().totalUsers = lgo.usersCount();
            theCore.showStatus();
            break;
        }

        case 1852863091: 
        {
            theCore.showStatus();
            PPEventUserNew unew = (PPEventUserNew)p;
            User2D nUser = newUserFromRec(unew.userRec());
            room.addUser(nUser);
            if(((User) (nUser)).id == ((Room) (theCore.getRoom())).userID) {
                theCore.setUserName(((User) (nUser)).name);
                theCore.showStatus();
            }
            break;
        }

        case 1701868147: 
        {
            theCore.showStatus();
            if(p.refNum() == ((Room) (room)).chatTargetID) {
                room.chatTargetID = 0;
                theCore.getPalaceCommander().pc_SetWhoTarget(null);
                theCore.showStatus();
            }
            room.removeUser(p.refNum());
            break;
        }

        case 1967943523: 
        {
            PPEventUserMove umove = (PPEventUserMove)p;
            room.moveUser(umove.refNum(), umove.x, umove.y);
            break;
        }

        case 1970500166: 
        {
            PPEventUserFace uface = (PPEventUserFace)p;
            room.setUserFaceNbr(uface.refNum(), uface.faceNbr);
            break;
        }

        case 1970500163: 
        {
            PPEventUserColor ucolor = (PPEventUserColor)p;
            room.setUserColorNbr(ucolor.refNum(), ucolor.colorNbr);
            break;
        }

        case 1968403553: 
        {
            PPEventUserStatus ustat = (PPEventUserStatus)p;
            theCore.getAppletStatus().userFlags = ustat.status;
            break;
        }

        case 1970500174: 
        {
            PPEventUserName uname = (PPEventUserName)p;
            room.getUser(uname.refNum()).setName(uname.userName);
            if(uname.refNum() == ((Room) (theCore.getRoom())).userID)
                theCore.setUserName(uname.userName);
            if(canvas != null)
                canvas.setRedrawNeeded(true);
            break;
        }

        case 1970500164: 
        {
            PPEventUserDesc udesc = (PPEventUserDesc)p;
            room.setUserDesc(udesc.refNum(), udesc.faceNbr, udesc.colorNbr, udesc.nbrProps, udesc.propIDs, udesc.propCRCs);
            break;
        }

        case 1970500176: 
        {
            PPEventUserProp uprop = (PPEventUserProp)p;
            room.setUserProps(uprop.refNum(), uprop.nbrProps, uprop.propIDs, uprop.propCRCs);
            break;
        }

        case 1885957735: 
        {
            PPEventPong upong = new PPEventPong(((Room) (theCore.getRoom())).userID);
            theCore.sendPPEvent(upong);
            break;
        }

        case 1967944564: 
        {
            theCore.setUserList(((PPEventUserListAll)p).users);
            break;
        }

        case 1917612916: 
        {
            theCore.setRoomList(((PPEventRoomListAll)p).rooms);
            break;
        }

        case 1933669236: 
        {
            PPEventAssetSend asend = (PPEventAssetSend)p;
            ((Room) (room)).propTable.PropFulfillment(asend);
            room.CheckUserProps();
            if(theCore.getPluginMgr() != null)
                theCore.getPluginMgr().CheckUserProps();
            break;
        }

        case 1850765936: 
        {
            PPEventPropNew pnew = (PPEventPropNew)p;
            room.addLooseProp(pnew.propID, pnew.crc, pnew.x, pnew.y);
            break;
        }

        case 1833988720: 
        {
            PPEventPropMove pmove = (PPEventPropMove)p;
            room.moveLooseProp(pmove.propIndex, pmove.x, pmove.y);
            break;
        }

        case 1682993776: 
        {
            PPEventPropDel pdel = (PPEventPropDel)p;
            room.delLooseProp(pdel.propIndex);
            break;
        }

        case 1685026670: 
        {
            PPEventGeneric pg = (PPEventGeneric)p;
            room.ClearRoomDesc();
            String s;
            switch(p.refNum()) {
            case 4: // '\004'
            case 7: // '\007'
            case 13: // '\r'
                s = "You have been kicked off this site.";
                break;

            case 11: // '\013'
            case 12: // '\f'
                s = "You are not currently allowed on this site.";
                break;

            case 6: // '\006'
                s = "Your connection was terminated due to inactivity.";
                break;

            case 3: // '\003'
                s = "Your connection was terminated due to flooding";
                break;

            case 8: // '\b'
                s = "This Palace is currently full - try again later.";
                break;

            case 14: // '\016'
                s = "Guests are not currently allowed on this site.";
                break;

            case 5: // '\005'
                s = "This Palace was shut down by its operator.  Try again later.";
                break;

            case 9: // '\t'
                s = "You have an invalid serial number.";
                break;

            case 10: // '\n'
                s = "There is another user using your serial number.";
                break;

            case 15: // '\017'
                s = "Your Free Demo has expired.";
                break;

            case 16: // '\020'
                if(p.length() > 1)
                    s = new String(pg.bs, 0, 0, pg.length() - 1);
                else
                    s = "Your connection was severed.";
                break;

            case 2: // '\002'
            default:
                s = "Your connection was severed.";
                break;
            }
            if(canvas != null)
                canvas.createGraphicError(s);
            throw new Error("Palace server down");
        }

        case 1819239275: 
        {
            PPEventDoorLock plock = (PPEventDoorLock)p;
            room.setSpotState(plock.roomID, plock.spotID, 1);
            break;
        }

        case 1970170991: 
        {
            PPEventDoorLock pulock = (PPEventDoorLock)p;
            room.setSpotState(pulock.roomID, pulock.spotID, 0);
            break;
        }

        case 1934849121: 
        {
            PPEventSpotState ps = (PPEventSpotState)p;
            room.setSpotState(ps.roomID, ps.spotID, ps.spotState);
            break;
        }

        case 1685418604: 
        {
            PPEventGeneric purl = (PPEventGeneric)p;
            int urlPanel = p.refNum();
            String urlString = new String(purl.bs, 0, 0, purl.length());
            if(urlPanel == 0)
                theCore.gotoURL(urlString, "PPSlideShow");
            else
                theCore.gotoURL(urlString, "Pane" + urlPanel);
            break;
        }
        }
        if(canvas != null)
            canvas.redrawIfNeeded();
    }

    private boolean isSound(String message) {
        if(theCore.getPalacePresents() != null && theCore.getPalacePresents().isStageShowing())
            return false;
        else
            return message.startsWith(")");
    }

    private void playSound(String soundMessage) {
        PalaceSound sound = new PalaceSound(soundMessage, theCore);
        sound.start();
    }

    public PalaceEventsThread(IPalaceCore theCore) {
        this.theCore = null;
        canvas = null;
        room = null;
        this.theCore = theCore;
    }

    protected User2D newUserFromRec(UserRec ur) {
        return new User2D(theCore.getRoom(), ur.name, ur.userId, ur.x, ur.y, ur.roomId, ur.faceNumber, ur.colorNumber, ur.awayFlag, ur.openToMsgs, ur.numberProps, ur.propIDs, ur.propCRCs);
    }

    public synchronized void run() {
        canvas = theCore.getCanvas();
        room = theCore.getRoom();
        do {
            try {
                PPEvent event = theCore.readPPEvent();
                if(event == null)
                    break;
                processEvent(event);
                continue;
            }
            catch(IOException e) { }
            catch(Error e) { }
            break;
        } while(true);
    }
}
