// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.*;
import communities.spb.SerialSpeech;
import communities.utl.*;
import java.util.Enumeration;
import java.util.Vector;

// Referenced classes of package communities.pob:
//            User, Hotspot, LooseProp, PalaceCommander, 
//            PalaceCommands, PropTable

public abstract class Room
    implements PalaceCommands {

    public String name;
    public int roomID;
    public int userID;
    public int totalUsers;
    public int usersInRoom;
    public int chatTargetID;
    public int caps;
    IPalaceCore itsCore;
    public Vector users;
    public Vector looseProps;
    public Vector hotspots;
    public PropTable propTable;
    PalaceCommander itsPC;
    PalaceErrorHandler mErrorHandler;

    public User getUserByName(String name) {
        if(users == null)
            return null;
        for(int n = 0; n < users.size(); n++) {
            User usr = (User)users.elementAt(n);
            if(usr.name.equals(name))
                return usr;
        }

        return null;
    }

    Hotspot getHotspot(int spotID) {
        if(hotspots == null)
            return null;
        for(Enumeration e = hotspots.elements(); e.hasMoreElements();) {
            Hotspot hs = (Hotspot)e.nextElement();
            if(hs.id == spotID)
                return hs;
        }

        return null;
    }

    public abstract void setRedrawNeeded();

    public void setUserFaceNbr(int id, int faceNbr) {
        User u = getUser(id);
        if(u != null) {
            u.setFaceNbr(faceNbr);
            redraw();
        }
    }

    public abstract void redraw();

    public Room(IPalaceCore itsCore, int capabilities) {
        name = "";
        roomID = 0;
        userID = 0;
        totalUsers = 0;
        usersInRoom = 0;
        chatTargetID = 0;
        caps = 0;
        users = null;
        looseProps = null;
        hotspots = null;
        propTable = null;
        itsPC = null;
        mErrorHandler = null;
        this.itsCore = itsCore;
        mErrorHandler = itsCore.getErrorHandler();
        caps = capabilities;
        users = new Vector();
    }

    Hotspot getHotspotByIndex(int i) {
        if(i >= 0 && i < hotspots.size())
            return (Hotspot)hotspots.elementAt(i);
        else
            return null;
    }

    public synchronized void CheckUserProps() {
        boolean redrawFlag = false;
        if(users == null)
            return;
        for(Enumeration e = users.elements(); e.hasMoreElements();) {
            User user = (User)e.nextElement();
            if(user.CheckForNewProps())
                redrawFlag = true;
        }

        if(looseProps == null)
            return;
        for(Enumeration e = looseProps.elements(); e.hasMoreElements();) {
            LooseProp lp = (LooseProp)e.nextElement();
            if(lp.checkReception())
                redrawFlag = true;
        }

        if(redrawFlag)
            setRedrawNeeded();
    }

    public void setPalaceCommander(PalaceCommander pc) {
        itsPC = pc;
    }

    public User getUser(int id) {
        if(users == null)
            return null;
        for(int n = 0; n < users.size(); n++) {
            User usr = (User)users.elementAt(n);
            if(usr.id == id)
                return usr;
        }

        return null;
    }

    public void userSpeech(int userId, String msg, boolean privateFlag, int msgDelay, SerialSpeech serSpch) {
        User u = getUser(userId);
        if(u != null) {
            itsPC.pc_SetChatString(msg);
            itsPC.triggerHotspotEvents(8);
            msg = itsPC.pc_GetChatString();
            u.speech(msg, privateFlag, msgDelay, serSpch);
            redraw();
        }
    }

    public void setUserID(int id) {
        userID = id;
    }

    public void userSpeech(int userId, String msg, boolean privateFlag, int msgDelay) {
        userSpeech(userId, msg, privateFlag, msgDelay, null);
    }

    public void userSpeech(int userId, String msg, boolean privateFlag) {
        userSpeech(userId, msg, privateFlag, 0);
    }

    public abstract void redrawImmediate();

    public void setSpotState(int roomID, int spotID, int spotState) {
        if(this.roomID != roomID)
            return;
        Hotspot hs = getHotspot(spotID);
        if(hs == null)
            return;
        if(hs.state != spotState) {
            hs.setState(spotState);
            redrawImmediate();
        }
    }

    public void setUserColorNbr(int id, int colorNbr) {
        User u = getUser(id);
        if(u != null) {
            u.setColorNbr(colorNbr);
            redraw();
        }
    }

    public void removeUser(int id) {
        User u = getUser(id);
        if(u != null) {
            u.done();
            users.removeElement(u);
        }
        usersInRoom = users.size();
        redraw();
    }

    public void moveSelf(int x, int y) {
        if(!itsCore.getAppletStatus().introInProgress) {
            moveUser(userID, x, y);
            itsPC.pc_MoveSelf(x, y);
        } else {
            moveUser(100, x, y);
        }
    }

    public void moveUser(int id, int x, int y) {
        User u = getUser(id);
        if(u != null) {
            u.setXY(x, y);
            redraw();
        }
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setUserDesc(int id, int faceNbr, int colorNbr, int nbrProps, int propIDs[], int propCRCs[]) {
        User u = getUser(id);
        if(u != null) {
            u.setFaceNbr(faceNbr);
            u.setColorNbr(colorNbr);
            u.setProps(nbrProps, propIDs, propCRCs);
            u.ResolveProps(propTable);
            redraw();
        }
    }

    public void addUser(User user) {
        synchronized(this) {
            users.addElement(user);
            usersInRoom = users.size();
        }
        if(user.id == userID) {
            if(!itsCore.getConnection().didSignOn) {
                itsCore.getConnection().didSignOn = true;
                int faceNbr;
                int colorNbr;
                if(itsCore.getResourceInfo().chooseAvatarEnabled) {
                    faceNbr = itsCore.getUI().getAvatar();
                    colorNbr = itsCore.getUI().getFaceColor();
                } else {
                    faceNbr = itsCore.getResourceInfo().defaultAvatar;
                    colorNbr = itsCore.getResourceInfo().defaultFaceColor;
                }
                itsPC.pc_ChangeFace(faceNbr);
                itsPC.pc_ChangeColor(colorNbr);
                itsPC.triggerHotspotEvents(13);
            }
            itsPC.triggerHotspotEvents(10);
        }
        itsCore.showStatus();
    }

    public void roomSpeech(String s, boolean flag) {
    }

    public void setRoomID(int id) {
        roomID = id;
    }

    public void clearUsers() {
        User user;
        for(Enumeration e = users.elements(); e.hasMoreElements(); user.done())
            user = (User)e.nextElement();

        users.removeAllElements();
        usersInRoom = 0;
        redraw();
    }

    public void setUserProps(int id, int nbrProps, int propIDs[], int propCRCs[]) {
        User u = getUser(id);
        if(u != null) {
            u.setProps(nbrProps, propIDs, propCRCs);
            u.ResolveProps(propTable);
            redraw();
        }
    }

    public void setPropTable(PropTable propTable) {
        this.propTable = propTable;
    }
}
