// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.*;
import communities.adm.IAdministrator;
import communities.spb.*;
import communities.utl.AppletStatus;
import communities.utl.ResourceInfo;
import java.awt.*;
import java.util.*;

// Referenced classes of package communities.pob:
//            Room, LooseProp, User, PalaceCommander, 
//            Hotspot, User2D, ImageOverlay, DrawableObject, 
//            PalaceCommands

public class Room2D extends Room
    implements DrawableObject, Balloon2DClient, PalaceCommands {

    public Palace2DCanvas itsCanvas;
    Hotspot hotspotTarget;
    public Hashtable images;
    Image faceProps[][];
    public Balloon2D roomSpeechBalloon;
    public Balloon2D statusMessageBalloon;
    Font nameLabelFont;
    Font balloonFont;
    Font hotspotFont;
    Image bg;
    Image bgDecode;
    int bgWidth;
    int bgHeight;
    private boolean backgroundFinished;

    public void moveLooseProp(int idx, int x, int y) {
        if(super.looseProps != null && idx >= 0 && idx < super.looseProps.size()) {
            LooseProp lp = (LooseProp)super.looseProps.elementAt(idx);
            if(lp != null)
                lp.moveProp(x, y);
        }
    }

    public void onSpeechBalloonChange(Balloon2D balloon) {
        redraw();
    }

    public synchronized void clearStatusMessage() {
        if(statusMessageBalloon != null)
            statusMessageBalloon.clear();
    }

    public void setRedrawNeeded() {
        itsCanvas.setRedrawNeeded(true);
    }

    public void setBgImage(Image bg) {
        this.bg = bg;
        setBgDimensions(bg);
        setBackgroundFinished(false);
        redraw();
    }

    public Image getBgImage() {
        return bg;
    }

    public void update(Rectangle bounds) {
        if(!super.itsCore.getAppletStatus().introInProgress)
            itsCanvas.redraw();
        else
            itsCanvas.drawRightNow();
    }

    public void redrawImmediate() {
        itsCanvas.drawRightNow();
    }

    public synchronized void statusMessage(String label, String text, int x, int y) {
        if(statusMessageBalloon == null)
            statusMessageBalloon = new Balloon2D(x - 72, y - 32, this, this, null);
        else
            statusMessageBalloon.clear();
        statusMessageBalloon.setXY(x - 72, y - 32);
        statusMessageBalloon.setMessage(text, 128, 0, null, label);
        redraw();
    }

    public void statusMessage(String label, String text) {
        statusMessage(label, text, 256, 192);
    }

    public void statusMessage(String text) {
        statusMessage(null, text);
    }

    private void pause(int msecs) {
        try {
            Thread.sleep(msecs);
        }
        catch(InterruptedException e) { }
    }

    public void setHotspotTarget(Hotspot hs) {
        Hotspot oldSpot = hotspotTarget;
        hotspotTarget = hs;
        if(hotspotTarget != oldSpot)
            redraw();
    }

    public int getBkgWidth() {
        return bgWidth;
    }

    private void drawFakeDoor(Graphics g) {
        if(super.itsCore.getResourceInfo().bRunIntro) {
            g.setColor(Color.blue);
            Rectangle r = itsCanvas.fakeDoorRect;
            g.drawRect(r.x, r.y, r.width, r.height);
            g.drawLine(r.x, r.y + r.height, 15, 384);
            g.drawLine(r.x + r.width, r.y + r.height, 490, 384);
            g.drawOval((r.x + r.width) - 20, r.y + r.height / 2 + 5, 10, 10);
        }
    }

    private void dropUser(User user) {
        int saveX = user.x;
        int saveY = user.y;
        double x = user.x;
        double y = 0.0D;
        double xd = 0.0D;
        double yd = 0.01D;
        double gravityY = 0.29999999999999999D;
        double dampen = 1.0D;
        while(yd > 0.0D || yd < 0.0D && y > (double)saveY)  {
            double nx = x + xd;
            double ny = y + yd;
            if(nx < 0.0D) {
                xd = -(xd * dampen);
                nx = -nx;
            }
            if(nx > (double)getBkgWidth()) {
                xd = -(xd * dampen);
                nx -= 2D * (nx - (double)getBkgWidth());
            }
            if(ny > (double)getBkgHeight()) {
                yd = -(yd * dampen);
                ny -= 2D * (ny - (double)getBkgHeight());
            }
            x = nx;
            y = ny;
            yd += gravityY;
            if(yd < 0.0D && y <= (double)saveY)
                user.setXY(saveX, saveY);
            else
                user.setXY((int)x, (int)y);
            itsCanvas.drawRightNow();
            pause(5);
        }
    }

    private void setBgDimensions(Image bg) {
        if(bg != null) {
            int w = bg.getWidth(itsCanvas);
            if(w != -1)
                bgWidth = w;
            int h = bg.getHeight(itsCanvas);
            if(h != -1)
                bgHeight = h;
        }
    }

    public void setHotspots(Vector hotspots) {
        super.hotspots = hotspots;
        setHotspotTarget(null);
    }

    public boolean selectHotspot(Hotspot hs, int x, int y) {
        super.itsPC.triggerHotspotEvent(hs, 0);
        return true;
    }

    synchronized void drawBackground(Graphics g) {
        if(bgDecode == null)
            return;
        if(!backgroundFinished) {
            setBgDimensions(bg);
            Graphics g2 = bgDecode.getGraphics();
            g2.setColor(Color.darkGray);
            g2.fillRect(0, 0, bgWidth, bgHeight);
            if(bg == null)
                setBackgroundFinished(true);
            else
                setBackgroundFinished(g2.drawImage(bg, 0, 0, itsCanvas));
            g2.dispose();
            if(backgroundFinished) {
                bg = null;
                System.gc();
            }
        }
        g.drawImage(bgDecode, 0, 0, itsCanvas);
    }

    public Room2D(IPalaceCore itsCore, int capabilities) {
        super(itsCore, capabilities);
        itsCanvas = null;
        hotspotTarget = null;
        images = null;
        faceProps = null;
        roomSpeechBalloon = null;
        statusMessageBalloon = null;
        nameLabelFont = null;
        balloonFont = null;
        hotspotFont = null;
        bg = null;
        bgDecode = null;
        bgWidth = 512;
        bgHeight = 384;
        backgroundFinished = false;
        itsCanvas = new Palace2DCanvas(this, itsCore);
        hotspotFont = new Font("TimesRoman", 0, 12);
        nameLabelFont = new Font("Dialog", 0, 10);
        ResourceInfo resInfo = itsCore.getResourceInfo();
        balloonFont = resInfo.balloonFont;
        itsCanvas.setFont(nameLabelFont);
    }

    public void addNotify() {
        if(bgDecode == null) {
            ResourceInfo resInfo = super.itsCore.getResourceInfo();
            bgWidth = resInfo.roomWindowRect.width;
            bgHeight = resInfo.roomWindowRect.height;
            bgDecode = itsCanvas.createImage(bgWidth, bgHeight);
        }
    }

    public void draw(Graphics g) {
        drawBackground(g);
        if(super.itsCore.getAppletStatus().introInProgress && super.itsCore.getResourceInfo().bRunIntro && (super.itsCore.getAppletStatus().introState == 3 || super.itsCore.getAppletStatus().introState == 4))
            drawFakeDoor(g);
        Vector v = super.hotspots;
        if(v != null) {
            Enumeration e = v.elements();
            g.setFont(hotspotFont);
            Hotspot hs;
            for(; e.hasMoreElements(); hs.draw(g, this))
                hs = (Hotspot)e.nextElement();

        }
        if(hotspotTarget != null && hotspotTarget.type != 0)
            hotspotTarget.xorOutline(g);
        v = super.looseProps;
        if(v != null) {
            LooseProp lp;
            for(Enumeration e = v.elements(); e.hasMoreElements(); lp.draw(g))
                lp = (LooseProp)e.nextElement();

        }
        v = super.users;
        if(v != null) {
            Enumeration e1 = v.elements();
            g.setFont(nameLabelFont);
            User2D user;
            for(; e1.hasMoreElements(); user.draw(g))
                user = (User2D)e1.nextElement();

            Enumeration e2 = v.elements();
            g.setFont(balloonFont);
            User2D user;
            for(; e2.hasMoreElements(); user.paintBalloon(g))
                user = (User2D)e2.nextElement();

        }
        if(roomSpeechBalloon != null) {
            g.setFont(balloonFont);
            roomSpeechBalloon.draw(g);
        }
        if(statusMessageBalloon != null) {
            g.setFont(balloonFont);
            statusMessageBalloon.draw(g);
        }
    }

    public void redraw() {
        update(null);
    }

    public void addLooseProp(int id, int crc, int x, int y) {
        if(super.looseProps != null) {
            LooseProp lp = new LooseProp(this, id, crc, x, y);
            super.looseProps.insertElementAt(lp, 0);
            redraw();
        }
    }

    public void delLooseProp(int idx) {
        if(super.looseProps != null) {
            if(idx >= 0 && idx < super.looseProps.size())
                super.looseProps.removeElementAt(idx);
            else
            if(idx == -1)
                super.looseProps.removeAllElements();
            redraw();
        }
    }

    public void done() {
        if(roomSpeechBalloon != null) {
            roomSpeechBalloon.done();
            roomSpeechBalloon = null;
        }
        if(statusMessageBalloon != null) {
            statusMessageBalloon.done();
            statusMessageBalloon = null;
        }
    }

    public synchronized void setBackgroundFinished(boolean bgFinished) {
        if(backgroundFinished != bgFinished) {
            backgroundFinished = bgFinished;
            if(backgroundFinished)
                super.itsCore.getUI().stopCycling();
            if(backgroundFinished && super.users != null && super.propTable != null) {
                User user;
                for(Enumeration e = super.users.elements(); e.hasMoreElements(); user.ResolveProps(super.propTable))
                    user = (User)e.nextElement();

            }
        }
    }

    public void provideFaceProps(Image faceProps[][]) {
        this.faceProps = faceProps;
    }

    public void setLooseProps(Vector looseProps) {
        super.looseProps = looseProps;
        if(super.looseProps != null) {
            LooseProp lp;
            for(Enumeration e = looseProps.elements(); e.hasMoreElements(); lp.setRoom(this))
                lp = (LooseProp)e.nextElement();

        }
    }

    public void ClearRoomDesc() {
        setBgImage(null);
        clearUsers();
        setHotspots(null);
        setLooseProps(null);
        setImageOverlays(null);
    }

    public Palace2DCanvas getCanvas() {
        return itsCanvas;
    }

    public boolean checkHotspots(int x, int y, boolean clickFlag) {
        if(x > bgWidth || y > bgHeight)
            return false;
        if(super.users != null) {
            for(Enumeration e = super.users.elements(); e.hasMoreElements();) {
                User2D user = (User2D)e.nextElement();
                if(user.ptInside(x, y) && ((User) (user)).id != super.userID) {
                    if(clickFlag && (super.caps & 1) != 0) {
                        if(((User) (user)).id != super.chatTargetID) {
                            super.chatTargetID = ((User) (user)).id;
                            super.itsPC.pc_SetWhoTarget(user);
                            redraw();
                        } else {
                            super.chatTargetID = 0;
                            super.itsPC.pc_SetWhoTarget(null);
                            redraw();
                        }
                        super.itsCore.showStatus();
                    }
                    setHotspotTarget(null);
                    return true;
                }
            }

            if(clickFlag)
                clearStatusMessage();
        }
        if(super.looseProps != null) {
            for(Enumeration e = super.looseProps.elements(); e.hasMoreElements();) {
                LooseProp lp = (LooseProp)e.nextElement();
                if(lp.ptInside(x, y)) {
                    if(clickFlag)
                        setHotspotTarget(null);
                    return true;
                }
            }

            if(clickFlag)
                clearStatusMessage();
        }
        if(super.hotspots != null) {
            for(int i = super.hotspots.size() - 1; i >= 0; i--) {
                Hotspot hs = (Hotspot)super.hotspots.elementAt(i);
                Polygon pg = hs.polygon;
                if(pg.inside(x, y)) {
                    if(clickFlag) {
                        if((hs.flags & 2) == 0)
                            moveSelf(x, y);
                        return selectHotspot(hs, x, y);
                    }
                    if(hs.type != 0) {
                        setHotspotTarget(hs);
                        return true;
                    }
                }
            }

            setHotspotTarget(null);
        }
        if(clickFlag)
            moveSelf(x, y);
        return false;
    }

    public void addUser(User2D user) {
        if(backgroundFinished)
            user.ResolveProps(super.propTable);
        else
            user.ClearPropRefs();
        super.addUser(user);
        if(((User) (user)).id == super.userID) {
            if(((User) (user)).x > bgWidth - 34 || ((User) (user)).y > bgHeight - 34) {
                int x = (int)(Math.random() * (double)(bgWidth - 34));
                int y = (int)(Math.random() * (double)(bgHeight - 34));
                moveSelf(x, y);
            }
            if(super.itsCore.getResourceInfo().bounceIntoRoom && !super.itsCore.getAppletStatus().isMacintosh)
                dropUser(user);
        }
        user.setClient(this);
        redraw();
    }

    public ImageOverlay getImageOverlay(int pictID) {
        Hashtable images = this.images;
        if(images == null) {
            return null;
        } else {
            ImageOverlay img = (ImageOverlay)images.get(new Integer(pictID));
            return img;
        }
    }

    public void setImageOverlays(Hashtable images) {
        if(images != null) {
            for(Enumeration e = images.elements(); e.hasMoreElements();) {
                ImageOverlay imgO = (ImageOverlay)e.nextElement();
                if(imgO.picName != null) {
                    Image i = super.itsCore.retrieveImage(imgO.picName, false);
                    imgO.setImage(i);
                }
            }

        }
        this.images = images;
    }

    public void roomSpeech(String msg, boolean privateFlag, int msgDelay, SerialSpeech serSpch) {
        super.roomSpeech(msg, privateFlag);
        if(roomSpeechBalloon == null)
            roomSpeechBalloon = new Balloon2D(-10, 30, this, this, null);
        roomSpeechBalloon.setXY(-10, 30);
        roomSpeechBalloon.setMessage(msg, privateFlag ? 2 : 0, msgDelay, serSpch, null);
        redraw();
        if(msg.indexOf("Page from") == 0) {
            IAdministrator admin = super.itsCore.getAdmin();
            if(admin != null)
                admin.handlePage(msg);
        }
    }

    public void roomSpeech(String msg, boolean privateFlag, int msgDelay) {
        roomSpeech(msg, privateFlag, msgDelay, null);
    }

    public void roomSpeech(String msg, boolean privateFlag) {
        roomSpeech(msg, privateFlag, 0);
    }

    public int getBkgHeight() {
        return bgHeight;
    }

    public void DrawFace(Graphics g, int faceNbr, int colorNbr, int x, int y) {
        if(faceNbr < 0)
            faceNbr = 0;
        if(faceNbr > 12)
            faceNbr = 12;
        if(colorNbr < 0)
            colorNbr = 0;
        if(colorNbr > 7)
            colorNbr = 7;
        if(faceProps == null || faceProps[faceNbr][colorNbr] == null) {
            g.setColor(Color.yellow);
            g.fillOval(x - 22, y - 22, 44, 44);
            g.setColor(Color.black);
            return;
        } else {
            g.drawImage(faceProps[faceNbr][colorNbr], x - 22, y - 22, itsCanvas);
            return;
        }
    }
}
