// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.spb.*;
import java.awt.*;

// Referenced classes of package communities.pob:
//            User, Room2D, PalaceProp, Room, 
//            DrawableObject

public class User2D extends User
    implements DrawableObject {

    Room2D itsRoom;
    public Balloon2D balloon;
    Balloon2DClient client;
    Rectangle bounds;

    public void setClient(Balloon2DClient client) {
        this.client = client;
    }

    public void draw(Object context) {
        Graphics g = (Graphics)context;
        if(!super.hideFaceFlag) {
            int translateFaceColor;
            switch(super.colorNbr) {
            case 3: // '\003'
                translateFaceColor = 2;
                break;

            case 5: // '\005'
                translateFaceColor = 3;
                break;

            case 4: // '\004'
            default:
                translateFaceColor = super.colorNbr >> 1;
                break;
            }
            itsRoom.DrawFace(g, super.faceNbr, translateFaceColor, super.x, super.y);
        }
        synchronized(this) {
            super.hideFaceFlag = false;
            for(int i = 0; i < super.numberProps; i++)
                if(super.pprops[i] != null) {
                    super.pprops[i].DrawProp(g, itsRoom, super.x - 22, super.y - 22);
                    if((super.pprops[i].propFlags & 2) != 0)
                        super.hideFaceFlag = true;
                }

        }
        FontMetrics fm = g.getFontMetrics();
        int namew = fm.stringWidth(super.name);
        int nrw = namew + 6;
        int nrh = fm.getHeight() + 2;
        int nrx = (super.x + 20) - nrw / 2 - 22;
        int nry = (super.y + 40) - 22;
        if(nrx < 0)
            nrx = 0;
        else
        if(nrx + nrw > itsRoom.getBkgWidth())
            nrx -= (nrx + nrw) - itsRoom.getBkgWidth();
        if(nry < 0)
            nry = 0;
        else
        if(nry + nrh > itsRoom.getBkgHeight())
            nry -= (nry + nrh) - itsRoom.getBkgHeight();
        if(((Room) (itsRoom)).chatTargetID != 0) {
            if(super.id != ((Room) (itsRoom)).userID && super.id != ((Room) (itsRoom)).chatTargetID) {
                g.setColor(Color.lightGray);
                g.fillRect(nrx, nry, nrw, nrh);
                g.setColor(Color.white);
                g.drawString(super.name, nrx + 3, nry + 1 + fm.getAscent());
            } else {
                g.setColor(Color.black);
                g.fillRect(nrx, nry, nrw, nrh);
                g.setColor(Color.magenta);
                g.drawString(super.name, nrx + 3, nry + 1 + fm.getAscent());
            }
        } else {
            g.setColor(Color.black);
            g.fillRect(nrx, nry, nrw, nrh);
            g.setColor(Color.white);
            g.drawString(super.name, nrx + 3, nry + 1 + fm.getAscent());
        }
    }

    public User2D(Room2D room, String name, int id, int x, int y, int roomId, int faceNbr, 
            int colorNbr, int awayFlag, int openToMsgs, int numberProps, int propIDs[], int propCRCs[]) {
        super(name, id, x, y, roomId, faceNbr, colorNbr, awayFlag, openToMsgs, numberProps, propIDs, propCRCs);
        itsRoom = null;
        balloon = null;
        client = null;
        bounds = null;
        itsRoom = room;
        bounds = new Rectangle(x - 22, y - 22, 44, 44);
    }

    public void speech(String msg, boolean privateFlag, int msgDelay, SerialSpeech serSpch) {
        synchronized(this) {
            if(balloon == null)
                balloon = new Balloon2D(super.x, super.y, client, itsRoom, this);
        }
        balloon.setXY(super.x, super.y);
        balloon.setMessage(msg, privateFlag ? 2 : 0, msgDelay, serSpch, null);
    }

    public void paintBalloon(Graphics g) {
        if(balloon != null)
            balloon.draw(g);
    }

    public void setXY(int x, int y) {
        Rectangle oldBounds = getBounds();
        super.setXY(x, y);
        if(balloon != null)
            balloon.setXY(x, y);
        synchronized(this) {
            oldBounds.union(getBounds());
        }
        update(oldBounds);
    }

    public void speech(String msg, boolean privateFlag, int msgDelay) {
        speech(msg, privateFlag, msgDelay, null);
    }

    public void speech(String msg, boolean privateFlag) {
        speech(msg, privateFlag, 0);
    }

    public void update(Rectangle bounds) {
        itsRoom.update(bounds);
    }

    public void done() {
        super.done();
        if(balloon != null) {
            balloon.done();
            balloon = null;
        }
    }

    public synchronized boolean CheckForNewProps() {
        boolean retFlag = false;
        boolean nullProps = false;
        super.hideFaceFlag = false;
        for(int i = 0; i < super.numberProps; i++)
            if(super.pprops[i] != null) {
                if(super.propUnfulfilled[i] && !super.pprops[i].unfulfilled) {
                    retFlag = true;
                    super.propUnfulfilled[i] = false;
                }
                if(super.pprops[i].justReceived)
                    super.pprops[i].DecodeProp(itsRoom);
                if((super.pprops[i].propFlags & 2) != 0)
                    super.hideFaceFlag = true;
            } else {
                nullProps = true;
            }

        return retFlag;
    }

    public boolean ptInside(int mx, int my) {
        if(mx >= super.x - 22 && mx < super.x + 22 && my >= super.y - 22 && my < super.y + 22)
            return true;
        if(super.pprops != null) {
            for(int i = 0; i < super.numberProps; i++)
                if(super.pprops[i] != null && super.pprops[i].ptInside(mx, my, super.x - 22, super.y - 22))
                    return true;

        }
        return false;
    }

    public synchronized Rectangle getBounds() {
        bounds.x = super.x - 22;
        bounds.y = super.y - 22;
        bounds.width = 44;
        bounds.height = 44;
        if(super.numberProps > 0 && super.pprops != null) {
            for(int i = 0; i < super.numberProps; i++)
                if(super.pprops[i] != null) {
                    Rectangle r = super.pprops[i].getBounds();
                    r.x += super.x - 22;
                    r.y += super.y - 22;
                    bounds = bounds.union(r);
                }

        }
        return bounds;
    }

    public void clearBalloon() {
        if(balloon != null)
            balloon.clear();
    }
}
