// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:14:58 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.spb;

import communities.pob.*;
import java.awt.*;
import java.util.*;

// Referenced classes of package communities.spb:
//            SpeechMessage, SerialSpeech, Balloon2DClient

public class Balloon2D
    implements Runnable {

    Point pt;
    Rectangle bounds;
    Vector msgs;
    protected Balloon2DClient client;
    Room2D itsRoom;
    User2D itsUser;
    protected Thread thread;
    int corner;
    int displayFlags;
    int balloonType;
    String label;
    Color myMagenta;
    private int cornerRatings[];

    private boolean intersectsABalloon(Rectangle r) {
        if(itsUser == null)
            return false;
        Vector userList = ((Room) (itsRoom)).users;
        synchronized(userList) {
            int numUsers = userList.size();
            for(int i = 0; i < numUsers; i++) {
                User2D user = (User2D)userList.elementAt(i);
                if(user != null && user != itsUser) {
                    Balloon2D balloon = user.balloon;
                    if(balloon != null && r.intersects(balloon.getBounds())) {
                        boolean flag = true;
                        return flag;
                    }
                }
            }

        }
        if(itsRoom.roomSpeechBalloon != null && r.intersects(itsRoom.roomSpeechBalloon.getBounds()))
            return true;
        return itsRoom.statusMessageBalloon != null && r.intersects(itsRoom.statusMessageBalloon.getBounds());
    }

    protected void Wrap(SpeechMessage speechMsg) {
        StringTokenizer st = new StringTokenizer(speechMsg.msg());
        Vector lines = new Vector();
        String line = new String();
        while(st.hasMoreTokens())  {
            String tk = st.nextToken();
            if(line.length() != 0 && line.length() + tk.length() > 24) {
                lines.addElement(line);
                line = new String(tk);
            } else {
                if(line.length() != 0)
                    line += " ";
                line += tk;
            }
            for(; line.length() > 26; line = line.substring(26))
                lines.addElement(line.substring(0, 26));

        }
        if(line.length() != 0)
            lines.addElement(line);
        speechMsg.lines = lines;
    }

    private boolean intersectsScreen(Rectangle r) {
        if(r.x < 0)
            return true;
        if(r.y < 0)
            return true;
        if(r.x + 22 + 8 + r.width > itsRoom.getBkgWidth() - 5)
            return true;
        return (r.y - 22) + r.height > itsRoom.getBkgHeight() - 5;
    }

    int totalLength() {
        int sum = 0;
        for(Enumeration sme = msgs.elements(); sme.hasMoreElements();) {
            SpeechMessage smsg = (SpeechMessage)sme.nextElement();
            sum += smsg.msg().length();
        }

        return sum;
    }

    public Balloon2D(int x, int y, Balloon2DClient client, Room2D itsRoom, User2D itsUser) {
        pt = null;
        bounds = null;
        this.client = null;
        this.itsRoom = null;
        this.itsUser = null;
        thread = null;
        corner = 0;
        displayFlags = 0;
        balloonType = 0;
        label = null;
        cornerRatings = new int[4];
        this.client = client;
        this.itsRoom = itsRoom;
        this.itsUser = itsUser;
        pt = new Point(x, y);
        myMagenta = new Color(190, 0, 200);
        msgs = new Vector();
        bounds = new Rectangle(0, 0, 0, 0);
        if(pt.y > itsRoom.getBkgHeight() - 22 - 1)
            pt.y = itsRoom.getBkgHeight() - 22 - 1;
    }

    public synchronized void draw(Graphics g) {
        if(msgs.size() == 0) {
            bounds.x = 0;
            bounds.y = 0;
            bounds.width = 0;
            bounds.height = 0;
            return;
        }
        FontMetrics fm = g.getFontMetrics();
        int th = fm.getHeight();
        int ta = fm.getAscent();
        int r = 10;
        int d = 2 * r;
        int lineCnt = 0;
        int spewX[] = new int[3];
        int spewY[] = new int[3];
        int maxw = 0;
        int w;
        for(Enumeration sme = msgs.elements(); sme.hasMoreElements();) {
            SpeechMessage smsg = (SpeechMessage)sme.nextElement();
            Vector lines = smsg.lines;
            for(Enumeration e = lines.elements(); e.hasMoreElements();) {
                String line = (String)e.nextElement();
                w = fm.stringWidth(line);
                if(w > maxw)
                    maxw = w;
                lineCnt++;
            }

        }

        int x = pt.x;
        int y = pt.y;
        w = maxw + 10;
        int h = lineCnt * th + 10;
        if(w < d)
            w = d;
        if(h < d)
            h = d;
        checkBalloonPlacement(x, y, w, h);
        boolean foundACorner = false;
        for(int rating = 0; rating <= 3; rating++) {
            for(corner = 0; corner <= 3; corner++) {
                if(cornerRatings[corner] != rating)
                    continue;
                foundACorner = true;
                break;
            }

            if(foundACorner)
                break;
        }

        int ax;
        int ay;
        switch(corner) {
        case 2: // '\002'
            x += 30;
            y -= h - 22;
            ax = x + 5;
            ay = y + (h - 10);
            break;

        case 3: // '\003'
            x -= w + 22 + 8;
            y -= h - 22;
            ax = x + (w - 5);
            ay = y + (h - 10);
            break;

        case 0: // '\0'
            x += 30;
            y -= 22;
            ax = x + 5;
            ay = y + 5 + 5;
            break;

        case 1: // '\001'
        default:
            x -= w + 22 + 8;
            y -= 22;
            ax = x + (w - 5);
            ay = y + 5 + 5;
            break;
        }
        int rightEdge = itsRoom.getBkgWidth() - 5;
        int bottomEdge = itsRoom.getBkgHeight() - 5;
        if(x + w > rightEdge) {
            ax -= (x + w) - rightEdge;
            x -= (x + w) - rightEdge;
        } else
        if(x < 0) {
            ax -= x;
            x = 0;
        }
        if(y + h > bottomEdge) {
            ay -= (y + h) - bottomEdge;
            y -= (y + h) - bottomEdge;
        } else
        if(y < 0) {
            ay -= y;
            y = 0;
        }
        bounds.x = x;
        bounds.y = y;
        bounds.width = w;
        bounds.height = h;
        spewX[0] = ax;
        spewY[0] = ay - 5;
        spewX[1] = (ax + pt.x) / 2;
        spewY[1] = (spewY[0] + pt.y) / 2;
        spewX[2] = ax;
        spewY[2] = ay + 5;
        Color fillColor;
        if(((Room) (itsRoom)).chatTargetID != 0 && (displayFlags & 2) == 0)
            fillColor = Color.lightGray;
        else
            fillColor = Color.white;
        switch(balloonType) {
        case 3: // '\003'
        {
            int signx = (corner & 1) != 0 ? 1 : -1;
            x += 18 * signx;
            g.setColor(Color.black);
            g.drawRect(x + 1, y + 1, w, h);
            g.setColor(Color.black);
            g.drawRect(x, y, w, h);
            g.setColor(fillColor);
            g.fillRect(x + 1, y + 1, w - 2, h - 2);
            break;
        }

        case 1: // '\001'
        {
            g.setColor(fillColor);
            g.fillRoundRect(x, y, w, h, d, d);
            g.setColor(Color.black);
            g.drawRoundRect(x, y, w, h, d, d);
            int signx = (corner & 1) != 0 ? 1 : -1;
            g.setColor(fillColor);
            g.fillOval((ax + 10 * signx) - 6, ay - 6, 12, 12);
            g.setColor(Color.black);
            g.drawOval((ax + 10 * signx) - 6, ay - 6, 12, 12);
            ax = (ax + pt.x) / 2;
            ay = (ay + pt.y) / 2;
            g.setColor(fillColor);
            g.fillOval(ax - 4, ay - 4, 8, 8);
            g.setColor(Color.black);
            g.drawOval(ax - 4, ay - 4, 8, 8);
            break;
        }

        case 2: // '\002'
        {
            Polygon poly = excitedPolygon(x, y, w, h);
            g.setColor(fillColor);
            g.fillPolygon(poly);
            g.setColor(Color.black);
            g.drawPolygon(poly);
            break;
        }

        case 0: // '\0'
        default:
        {
            Color fg = Color.black;
            g.setColor(fillColor);
            g.fillPolygon(spewX, spewY, 3);
            g.setColor(fg);
            g.drawPolygon(spewX, spewY, 3);
            g.setColor(fillColor);
            g.fillRoundRect(x, y, w, h, d, d);
            g.setColor(fg);
            g.drawRoundRect(x, y, w, h, d, d);
            int nsignx = (corner & 1) != 0 ? -1 : 1;
            spewX[0] += nsignx;
            spewX[1] += nsignx;
            spewX[2] += nsignx;
            g.setColor(fillColor);
            g.fillPolygon(spewX, spewY, 3);
            break;
        }
        }
        if((displayFlags & 2) > 0) {
            int pw = fm.stringWidth("private") + 8;
            int ph = fm.getHeight() + 4;
            int px = x + (w - pw) / 2;
            int py = (y + h) - 5;
            g.setColor(Color.black);
            g.drawRect(px, py, pw, ph);
            g.setColor(Color.white);
            g.fillRect(px + 1, py + 1, pw - 2, ph - 2);
            g.setColor(myMagenta);
            g.drawString("private", px + 4, py + 2 + ta);
        } else
        if(label != null) {
            int pw = fm.stringWidth(label) + 8;
            int ph = fm.getHeight() + 4;
            int px = x + (w - pw) / 2;
            int py = (y + h) - 5;
            g.setColor(Color.black);
            g.drawRect(px, py, pw, ph);
            g.setColor(Color.white);
            g.fillRect(px + 1, py + 1, pw - 2, ph - 2);
            g.setColor(Color.red);
            g.drawString(label, px + 4, py + 2 + ta);
        }
        g.setColor(Color.black);
        int tx = x + 5;
        int ty = y + 5;
        for(Enumeration sme = msgs.elements(); sme.hasMoreElements();) {
            SpeechMessage smsg = (SpeechMessage)sme.nextElement();
            Vector lines = smsg.lines;
            Color c = smsg.getColor();
            g.setColor(c);
            for(Enumeration e = lines.elements(); e.hasMoreElements();) {
                String line = (String)e.nextElement();
                g.drawString(line, tx, ty + ta);
                ty += th;
            }

        }

    }

    private boolean intersectsAUser(Rectangle r) {
        if(itsUser == null)
            return false;
        Vector userList = ((Room) (itsRoom)).users;
        int numUsers = userList.size();
        for(int i = 0; i < numUsers; i++) {
            User2D user = (User2D)userList.elementAt(i);
            if(user != itsUser && r.intersects(user.getBounds()))
                return true;
        }

        return false;
    }

    public synchronized void setMessage(String msg, int msgFlags, int msgDelay, SerialSpeech serSpch, String label) {
        if(msg.length() == 0)
            return;
        if(msg.charAt(0) == ';')
            return;
        this.label = label;
        SpeechMessage speechMsg = new SpeechMessage(msg, msgFlags, msgDelay, serSpch);
        Wrap(speechMsg);
        if(thread == null) {
            thread = new Thread(this, "SpeechBalloon");
            try {
                thread.setDaemon(true);
            }
            catch(Exception e) { }
            thread.start();
        }
        if(speechMsg.flags != displayFlags || (speechMsg.flags & 0x40) > 0)
            clear();
        for(; totalLength() > 256 && msgs.size() > 1; killFirstMessage());
        if((speechMsg.flags & 0x40) > 0)
            setXY(speechMsg.spoofX, speechMsg.spoofY);
        msgs.addElement(speechMsg);
        displayFlags = speechMsg.flags;
        if((speechMsg.flags & 4) > 0)
            balloonType = 1;
        else
        if((speechMsg.flags & 1) > 0)
            balloonType = 2;
        else
        if((speechMsg.flags & 0x1a8) > 0)
            balloonType = 3;
        else
            balloonType = 0;
        notify();
    }

    public synchronized void setXY(int x, int y) {
        pt = new Point(x, y);
        if(pt.y > itsRoom.getBkgHeight() - 22 - 1)
            pt.y = itsRoom.getBkgHeight() - 22 - 1;
        if(balloonType == 3 || (displayFlags & 8) != 0)
            clear();
    }

    void killFirstMessage() {
        if(!msgs.isEmpty()) {
            SpeechMessage smsg = (SpeechMessage)msgs.elementAt(0);
            msgs.removeElementAt(0);
            if(smsg.m_serSpch != null)
                smsg.m_serSpch.doneSpch();
        }
    }

    public void done() {
        if(thread != null) {
            thread.stop();
            thread = null;
        }
        clear();
    }

    Polygon excitedPolygon(int left, int top, int w, int h) {
        int right = left + w;
        int bottom = top + h;
        int hp = w / 12;
        if(hp < 2)
            hp = 2;
        int vp = h / 12;
        if(vp < 2)
            vp = 2;
        int hw = w / hp;
        int vw = h / vp;
        int n = 0;
        int nPts = hp * 4 + vp * 4 + 1;
        int xAry[] = new int[nPts];
        int yAry[] = new int[nPts];
        xAry[n] = left;
        yAry[n] = top;
        n++;
        for(int x = 0; x < hp; x++) {
            int px = (left + x * hw + hw / 2 + (x * 20) / (hp - 1)) - 10;
            int py = top - 16;
            xAry[n] = px;
            yAry[n] = py;
            n++;
            xAry[n] = left + x * hw + hw;
            yAry[n] = top;
            n++;
        }

        for(int y = 0; y < vp; y++) {
            int px = right + 16;
            int py = (top + y * vw + vw / 2 + (y * 20) / (vp - 1)) - 10;
            xAry[n] = px;
            yAry[n] = py;
            n++;
            xAry[n] = right;
            yAry[n] = top + y * vw + vw;
            n++;
        }

        for(int x = 0; x < hp; x++) {
            int px = ((right - x * hw - hw / 2) + ((hp - 1 - x) * 20) / (hp - 1)) - 10;
            int py = bottom + 16;
            xAry[n] = px;
            yAry[n] = py;
            n++;
            xAry[n] = right - x * hw - hw;
            yAry[n] = bottom;
            n++;
        }

        for(int y = 0; y < vp; y++) {
            int px = left - 16;
            int py = ((bottom - y * vw - vw / 2) + ((vp - 1 - y) * 20) / (vp - 1)) - 10;
            xAry[n] = px;
            yAry[n] = py;
            n++;
            xAry[n] = left;
            yAry[n] = bottom - y * vw - vw;
            n++;
        }

        return new Polygon(xAry, yAry, nPts);
    }

    public synchronized void clear() {
        for(; msgs.size() > 0; killFirstMessage());
        label = null;
    }

    public Rectangle getBounds() {
        return bounds;
    }

    public void run() {
        while(true) 
            try {
                synchronized(this) {
                    for(; msgs.size() == 0; wait());
                    SpeechMessage smsg = (SpeechMessage)msgs.elementAt(0);
                    long delay = smsg.getDelayTime();
                    if(delay == -1L)
                        killFirstMessage();
                    else
                        wait(delay);
                }
                client.onSpeechBalloonChange(this);
            }
            catch(InterruptedException e) {
                return;
            }
    }

    private void checkBalloonPlacement(int x, int y, int w, int h) {
        Rectangle r = new Rectangle(x, y, w, h);
        for(corner = 0; corner <= 3; corner++) {
            switch(corner) {
            case 0: // '\0'
                r.x = x + 22 + 8;
                r.y = y - 22;
                break;

            case 1: // '\001'
                r.x = x - (w + 22 + 8);
                r.y = y - 22;
                break;

            case 2: // '\002'
                r.x = x + 22 + 8;
                r.y = y - (h - 22);
                break;

            case 3: // '\003'
                r.x = x - (w + 22 + 8);
                r.y = y - (h - 22);
                break;
            }
            if(intersectsScreen(r))
                cornerRatings[corner] = 3;
            else
            if(intersectsABalloon(r))
                cornerRatings[corner] = 2;
            else
            if(intersectsAUser(r))
                cornerRatings[corner] = 1;
            else
                cornerRatings[corner] = 0;
            if(cornerRatings[corner] == 0)
                break;
        }

        r = null;
    }
}
