// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import communities.IPalaceCore;
import communities.pkt.*;
import communities.plg.PluginMgr;
import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import java.io.*;
import java.net.*;

// Referenced classes of package communities.utl:
//            PalaceURL, NetDataInputStream, NetDataOutputStream, NetDataStreams

public final class Connection
    implements Runnable, Privileged {

    private NetDataInputStream mIn;
    private NetDataOutputStream mOut;
    private Socket mSock;
    private URL mTCPHost;
    private URL mHTTPHost;
    private int mHTTPDelay;
    private int mRespPort;
    private PalacePacketSender mPPSender;
    private PalacePacketGrabber mPPGrabber;
    private PluginMgr mPlugMgr;
    private boolean mError;
    private int mConnMode;
    private boolean mBigEndian;
    private IPalaceCore mCore;
    private int mConnID;
    private boolean mForgetTCP;
    private boolean mEndianSet;
    public boolean didSignOn;
    private transient IPalaceSecurity mSecurity;

    public void close() {
        switch(mConnMode) {
        case 2: // '\002'
            closeHTTP();
            break;

        case 1: // '\001'
            closeTCP();
            break;
        }
    }

    public void setSecurity(IPalaceSecurity m) {
        mSecurity = m;
    }

    private void closeHTTP() {
        setConnMode(0);
        try {
            if(mIn != null)
                mIn.close();
            if(mOut != null)
                mOut.close();
            if(mSock != null)
                mSock.close();
        }
        catch(IOException e) { }
        mSock = null;
        mIn = null;
        mOut = null;
    }

    public void open() {
        setError(false);
        if(mHTTPHost != null) {
            if(mHTTPDelay == 0) {
                System.out.println("AUTO HTTP connection type enabled, tunnel_tryafter parameter was 0");
                connectHTTP();
            } else {
                Thread t = new Thread(this, "Connection");
                try {
                    t.setDaemon(true);
                }
                catch(Exception e) { }
                t.start();
                try {
                    synchronized(this) {
                        wait(mHTTPDelay * 1000);
                    }
                }
                catch(InterruptedException ie) {
                    System.out.println("Interrupted while doing TCP timeout, " + ie.toString());
                }
                if(mSock == null || mError) {
                    setError(false);
                    setForgetTCP(true);
                    connectHTTP();
                }
            }
        } else {
            connectTCP();
        }
    }

    public boolean isHTTPConn() {
        return mConnMode == 2;
    }

    private NetDataInputStream getInputStream() {
        NetDataInputStream in = null;
        switch(mConnMode) {
        case 2: // '\002'
            in = mIn;
            break;

        case 1: // '\001'
            in = mIn;
            break;

        default:
            in = null;
            break;
        }
        return in;
    }

    public Connection(PalaceURL tcpHost, PalaceURL httpHost, int httpDelay, PluginMgr plugMgr, IPalaceCore theCore) {
        mIn = null;
        mOut = null;
        mSock = null;
        mTCPHost = null;
        mHTTPHost = null;
        mHTTPDelay = 1;
        mRespPort = 0;
        mPPSender = null;
        mPPGrabber = null;
        mPlugMgr = null;
        mError = false;
        mConnMode = 0;
        mBigEndian = true;
        mCore = null;
        mConnID = 0;
        mForgetTCP = false;
        mEndianSet = false;
        didSignOn = false;
        mTCPHost = tcpHost == null ? null : tcpHost.getURL();
        mHTTPHost = httpHost == null ? null : httpHost.getURL();
        mHTTPDelay = httpDelay;
        mPlugMgr = plugMgr;
        mCore = theCore;
        mPPSender = new PalacePacketSender(this, theCore);
        mPPGrabber = new PalacePacketGrabber(this, mPlugMgr);
    }

    public PPEvent readEvent() {
        PPEvent ret = null;
        try {
            NetDataInputStream ndis = getInputStream();
            if(ndis != null)
                ret = mPPGrabber.getIncomingPacket(getInputStream());
        }
        catch(IOException ioe) { }
        return ret;
    }

    public void writeEvent(PPEvent theEvent) {
        mPPSender.sendPPEvent(theEvent);
    }

    public boolean isEndianSet() {
        return mEndianSet;
    }

    private synchronized void setForgetTCP(boolean forgetIt) {
        mForgetTCP = forgetIt;
    }

    private void connectTCP() {
        setConnMode(1);
        System.out.println("in connectTCP");
        if(mTCPHost != null) {
            try {
                Connection$SocketOpener opener = new Connection$SocketOpener(this, mTCPHost);
                mSecurity.connectTo(mTCPHost, opener);
                opener.checkIOException();
                mSock = opener.mSocket;
                pause();
                mIn = new NetDataInputStream(mSock.getInputStream());
                pause();
                java.io.OutputStream os = mSock.getOutputStream();
                pause();
                BufferedOutputStream bos = new BufferedOutputStream(os, 1536);
                pause();
                mOut = new NetDataOutputStream(bos);
                System.out.println("tcp connected to: " + mTCPHost);
            }
            catch(IOException e) {
                if(isForgetTCP())
                    mSock = null;
                else
                    setError(true);
                return;
            }
            catch(SecurityException e) {
                setError(true);
                return;
            }
        } else {
            setError(true);
            return;
        }
    }

    private void setConnMode(int mode) {
        mConnMode = mode;
    }

    public boolean isError() {
        return mError;
    }

    public URL getHost() {
        switch(mConnMode) {
        case 1: // '\001'
            return mTCPHost;

        case 2: // '\002'
            return mHTTPHost;
        }
        return null;
    }

    private synchronized boolean isForgetTCP() {
        return mForgetTCP;
    }

    private void closeTCP() {
        setConnMode(0);
        NetDataInputStream ndis = mIn;
        if(ndis != null) {
            try {
                ndis.close();
            }
            catch(IOException e) { }
            mIn = null;
        }
        NetDataOutputStream ndos = mOut;
        if(ndos != null) {
            try {
                ndos.close();
            }
            catch(IOException e) { }
            mOut = null;
        }
        Socket sock = mSock;
        if(sock != null) {
            try {
                sock.close();
            }
            catch(IOException e) { }
            mSock = null;
        }
    }

    public void setRespPort(int respPort) {
        mRespPort = respPort;
    }

    private void pause() {
        try {
            Thread.sleep(50L);
        }
        catch(InterruptedException e) { }
    }

    public NetDataStreams getNDS() {
        NetDataStreams nds = null;
        switch(mConnMode) {
        case 2: // '\002'
            nds = getHttpOutputStream();
            break;

        case 1: // '\001'
            nds = new NetDataStreams(getInputStream(), getTcpOutputStream());
            break;
        }
        return nds;
    }

    public void setConnID(int connID) {
        mConnID = connID;
    }

    public void run() {
        connectTCP();
        synchronized(this) {
            notify();
        }
    }

    public void setBigEndian(boolean bigEndian) {
        mBigEndian = bigEndian;
        mEndianSet = true;
        if(mIn != null)
            mIn.setBigEndian(bigEndian);
        if(mOut != null)
            mOut.setBigEndian(bigEndian);
    }

    public int getConnID() {
        if(mConnID <= 0)
            System.out.println("inappropriate connection id->" + Integer.toHexString(mConnID));
        return mConnID;
    }

    private void connectHTTP() {
        setConnMode(2);
        System.out.println("in connectHTTP");
        if(mHTTPHost != null) {
            try {
                Connection$ConnectionOpener opener = new Connection$ConnectionOpener(this, mHTTPHost);
                mSecurity.connectTo(mHTTPHost, opener);
                opener.checkIOException();
                URLConnection conn = opener.mURLConnection;
                conn.setDoInput(true);
                conn.setDefaultUseCaches(false);
                conn.setUseCaches(false);
                URLConnection.setDefaultAllowUserInteraction(true);
                conn.setAllowUserInteraction(true);
                System.out.println("http connected to: " + mHTTPHost);
                mIn = new NetDataInputStream(conn.getInputStream());
            }
            catch(IOException e) {
                setError(true);
                return;
            }
            catch(SecurityException e) {
                setError(true);
                return;
            }
        } else {
            setError(true);
            return;
        }
    }

    private NetDataStreams getHttpOutputStream() {
        NetDataStreams nds = null;
        NetDataOutputStream out = null;
        URLConnection in = null;
        if(mHTTPHost != null)
            try {
                URL theURL = mHTTPHost;
                if(mRespPort > 0)
                    theURL = new URL("http", mHTTPHost.getHost(), mRespPort, null);
                Connection$ConnectionOpener opener = new Connection$ConnectionOpener(this, theURL);
                mSecurity.connectTo(theURL, opener);
                opener.checkIOException();
                URLConnection conn = opener.mURLConnection;
                conn.setDefaultUseCaches(false);
                conn.setUseCaches(false);
                conn.setDoInput(true);
                conn.setDoOutput(true);
                BufferedOutputStream bos = new BufferedOutputStream(conn.getOutputStream(), 1536);
                out = new NetDataOutputStream(bos);
                out.setBigEndian(mBigEndian);
                in = conn;
                nds = new NetDataStreams(in, out);
            }
            catch(MalformedURLException e) {
                System.out.println("Connection.getHTTPOutputStream: mue");
            }
            catch(SecurityException e) { }
            catch(IOException ioe) {
                System.out.println("problem getting output stream in HTTP mode " + ioe.toString());
            }
        else
            setError(true);
        return nds;
    }

    private NetDataOutputStream getTcpOutputStream() {
        return mOut;
    }

    private void setError(boolean error) {
        mError = error;
        if(error) {
            mIn = null;
            mOut = null;
            close();
            mSock = null;
        }
    }
}
