// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import java.awt.*;
import java.awt.image.ImageObserver;

public class ImagePane extends Canvas
    implements ImageObserver {

    private Image mImage;
    private boolean errored;
    private int mWidth;
    private int mHeight;
    private boolean mCentered;
    private Image mOffImage;

    public synchronized void invalidate() {
        super.invalidate();
        mOffImage = null;
    }

    private void drawBackground(Graphics g) {
        Color save = g.getColor();
        g.setColor(getBackground());
        g.fillRect(0, 0, size().width, size().height);
        g.setColor(save);
    }

    public ImagePane(Image image, int width, int height) {
        mImage = null;
        errored = false;
        mWidth = 0;
        mHeight = 0;
        mCentered = true;
        mOffImage = null;
        mImage = image;
        mHeight = height;
        mWidth = width;
        setBackground(Color.lightGray);
        resize(width, height);
    }

    public synchronized void paint(Graphics g) {
        Image image = getImage();
        if(image != null)
            g.drawImage(image, getUpperLeft().x, getUpperLeft().y, this);
    }

    public Dimension minimumSize() {
        return preferredSize();
    }

    public synchronized void update(Graphics g) {
        if(mOffImage == null)
            mOffImage = createImage(size().width, size().height);
        Graphics og = mOffImage.getGraphics();
        drawBackground(og);
        paint(og);
        g.drawImage(mOffImage, 0, 0, null);
        og.dispose();
    }

    public Dimension preferredSize() {
        return new Dimension(mWidth, mHeight);
    }

    public synchronized void setImage(Image image) {
        mImage = image;
        repaint();
    }

    public Image getImage() {
        return mImage;
    }

    protected Point getUpperLeft() {
        return new Point(0, 0);
    }
}
