// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import communities.PalaceErrorHandler;
import communities.sec.IPalaceSecurity;
import java.io.*;
import java.net.URL;
import java.util.Vector;

public class ItemLister {

    private transient IPalaceSecurity mSecurity;
    private PalaceErrorHandler mErrorHandler;
    URL mUrl;
    private Vector mList;
    private boolean mCreated;

    public void setSecurity(IPalaceSecurity m) {
        mSecurity = m;
    }

    private void closeStream(InputStream in) {
        if(in != null)
            try {
                in.close();
            }
            catch(IOException e) {
                mErrorHandler.reportError("IO Exception reading list: " + e.getMessage(), 1);
            }
    }

    public ItemLister(PalaceErrorHandler errorHandler, URL url) {
        mErrorHandler = errorHandler;
        mCreated = false;
        mUrl = url;
    }

    public Vector getList() {
        if(!mCreated) {
            mCreated = true;
            createList();
        }
        return mList;
    }

    private void createList() {
        mList = null;
        if(mUrl == null)
            return;
        try {
            Vector aList = new Vector();
            DataInputStream in = null;
            ItemLister$StreamOpener opener = new ItemLister$StreamOpener(this);
            mSecurity.connectTo(mUrl, opener);
            opener.checkIOException();
            in = new DataInputStream(opener.mInputStream);
            String line;
            while((line = in.readLine()) != null) 
                aList.addElement(line);
            mList = aList;
            closeStream(in);
        }
        catch(SecurityException e) {
            mErrorHandler.reportError("Security Exception reading list", 1);
        }
        catch(IOException e) {
            mErrorHandler.reportError("IO Exception reading list: " + e.getMessage(), 1);
        }
    }
}
