// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;


public class NavHistory {

    private int mHistory[];
    private int mCurrRoomIndex;
    private int mLastInHistoryIndex;

    public NavHistory(int roomID) {
        mHistory = null;
        mCurrRoomIndex = 0;
        mLastInHistoryIndex = 0;
        mHistory = new int[16];
        mCurrRoomIndex = -1;
        mLastInHistoryIndex = -1;
        gotoNewRoom(roomID);
    }

    private int getNextAvailableIndex() {
        int index;
        if(isHistoryFull()) {
            removeOldest();
            index = 15;
        } else {
            index = mCurrRoomIndex + 1;
        }
        return index;
    }

    public synchronized boolean isForwardAvailable() {
        return mCurrRoomIndex < mLastInHistoryIndex;
    }

    public synchronized int getCurrRoomID() {
        return mHistory[mCurrRoomIndex];
    }

    public synchronized void gotoNewRoom(int roomID) {
        mCurrRoomIndex = getNextAvailableIndex();
        mHistory[mCurrRoomIndex] = roomID;
        mLastInHistoryIndex = mCurrRoomIndex;
    }

    public synchronized int goBack() {
        int roomID;
        if(isBackAvailable()) {
            mCurrRoomIndex--;
            roomID = getCurrRoomID();
        } else {
            roomID = -1;
        }
        return roomID;
    }

    public synchronized int goForward() {
        int roomID;
        if(isForwardAvailable()) {
            mCurrRoomIndex++;
            roomID = getCurrRoomID();
        } else {
            roomID = -1;
        }
        return roomID;
    }

    private boolean isHistoryFull() {
        return mCurrRoomIndex == 15;
    }

    private void removeOldest() {
        for(int i = 0; i < mLastInHistoryIndex; i++)
            mHistory[i] = mHistory[i + 1];

    }

    public synchronized boolean isBackAvailable() {
        return mCurrRoomIndex > 0;
    }
}
