// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import java.io.*;

public class NetDataInputStream extends FilterInputStream
    implements DataInput {

    protected boolean bigEndian;
    protected DataInputStream dis;
    protected int bytesRead;

    public int skipBytes(int n) throws IOException {
        int i = dis.skipBytes(n);
        bytesRead += n;
        return i;
    }

    public boolean readBoolean() throws IOException {
        boolean b = dis.readBoolean();
        bytesRead++;
        return b;
    }

    public byte readByte() throws IOException {
        byte b = dis.readByte();
        bytesRead++;
        return b;
    }

    public int readUnsignedByte() throws IOException {
        int b = readUnsignedByte();
        bytesRead++;
        return b;
    }

    public float readFloat() throws IOException {
        float f = dis.readFloat();
        bytesRead += 4;
        return f;
    }

    public long readLong() throws IOException {
        byte b1 = readByte();
        byte b2 = readByte();
        byte b3 = readByte();
        byte b4 = readByte();
        byte b5 = readByte();
        byte b6 = readByte();
        byte b7 = readByte();
        byte b8 = readByte();
        if(bigEndian)
            return (long)((b1 << 56) + ((b2 & 0xff) << 48) + ((b3 & 0xff) << 40) + ((b4 & 0xff) << 32) + ((b5 & 0xff) << 24) + ((b6 & 0xff) << 16) + ((b7 & 0xff) << 8) + (b8 & 0xff));
        else
            return (long)((b8 << 56) + ((b7 & 0xff) << 48) + ((b6 & 0xff) << 40) + ((b5 & 0xff) << 32) + ((b4 & 0xff) << 24) + ((b3 & 0xff) << 16) + ((b2 & 0xff) << 8) + (b1 & 0xff));
    }

    public NetDataInputStream(InputStream is) {
        super(is);
        bigEndian = true;
        dis = null;
        bytesRead = 0;
        dis = new DataInputStream(is);
    }

    public void readFully(byte b[]) throws IOException {
        dis.readFully(b);
        bytesRead += b.length;
    }

    public void readFully(byte b[], int off, int len) throws IOException {
        dis.readFully(b, off, len);
        bytesRead += len;
    }

    public boolean isBigEndian() {
        return bigEndian;
    }

    public int read(byte b[]) throws IOException {
        int i = super.read(b);
        bytesRead += i;
        return i;
    }

    public short readShort() throws IOException {
        byte b1 = readByte();
        byte b2 = readByte();
        if(bigEndian)
            return (short)((b1 << 8) + (b2 & 0xff));
        else
            return (short)((b2 << 8) + (b1 & 0xff));
    }

    public int readUnsignedShort() throws IOException {
        byte b1 = readByte();
        byte b2 = readByte();
        if(bigEndian)
            return ((b1 & 0xff) << 8) + (b2 & 0xff);
        else
            return ((b2 & 0xff) << 8) + (b1 & 0xff);
    }

    public double readDouble() throws IOException {
        double d = dis.readDouble();
        bytesRead += 8;
        return d;
    }

    public String readLine() throws IOException {
        String s = dis.readLine();
        bytesRead += s.length();
        return s;
    }

    public int bytesRead() {
        int br = bytesRead;
        bytesRead = 0;
        return br;
    }

    public char readChar() throws IOException {
        char c = dis.readChar();
        bytesRead += 2;
        return c;
    }

    public String readUTF() throws IOException {
        String s = dis.readUTF();
        bytesRead += s.length() * 2;
        return s;
    }

    public int readInt() throws IOException {
        byte b1 = readByte();
        byte b2 = readByte();
        byte b3 = readByte();
        byte b4 = readByte();
        if(bigEndian)
            return ((b1 & 0xff) << 24) + ((b2 & 0xff) << 16) + ((b3 & 0xff) << 8) + (b4 & 0xff);
        else
            return ((b4 & 0xff) << 24) + ((b3 & 0xff) << 16) + ((b2 & 0xff) << 8) + (b1 & 0xff);
    }

    public void setBigEndian(boolean isBig) {
        bigEndian = isBig;
    }
}
