// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import java.io.*;

public class NetDataOutputStream extends FilterOutputStream
    implements DataOutput {

    protected boolean bigEndian;
    protected DataOutputStream dos;

    public void writeBoolean(boolean v) throws IOException {
        dos.writeBoolean(v);
    }

    public void writeByte(int v) throws IOException {
        dos.writeByte(v);
    }

    public void writeFloat(float v) throws IOException {
        dos.writeFloat(v);
    }

    public boolean isBigEndian() {
        return bigEndian;
    }

    public void writeLong(long v) throws IOException {
        byte b1;
        byte b2;
        byte b3;
        byte b4;
        byte b5;
        byte b6;
        byte b7;
        byte b8;
        if(bigEndian) {
            b1 = (byte)(int)(v >> 56);
            b2 = (byte)(int)(v >> 48);
            b3 = (byte)(int)(v >> 40);
            b4 = (byte)(int)(v >> 32);
            b5 = (byte)(int)(v >> 24);
            b6 = (byte)(int)(v >> 16);
            b7 = (byte)(int)(v >> 8);
            b8 = (byte)(int)v;
        } else {
            b1 = (byte)(int)v;
            b2 = (byte)(int)(v >> 8);
            b3 = (byte)(int)(v >> 16);
            b4 = (byte)(int)(v >> 24);
            b5 = (byte)(int)(v >> 32);
            b6 = (byte)(int)(v >> 40);
            b7 = (byte)(int)(v >> 48);
            b8 = (byte)(int)(v >> 56);
        }
        dos.writeByte(b1);
        dos.writeByte(b2);
        dos.writeByte(b3);
        dos.writeByte(b4);
        dos.writeByte(b5);
        dos.writeByte(b6);
        dos.writeByte(b7);
        dos.writeByte(b8);
    }

    public NetDataOutputStream(OutputStream os) {
        super(os);
        bigEndian = true;
        dos = null;
        dos = new DataOutputStream(os);
    }

    public void writeShort(int v) throws IOException {
        byte b1;
        byte b2;
        if(bigEndian) {
            b1 = (byte)(v >> 8);
            b2 = (byte)v;
        } else {
            b1 = (byte)v;
            b2 = (byte)(v >> 8);
        }
        dos.writeByte(b1);
        dos.writeByte(b2);
    }

    public void writeDouble(double v) throws IOException {
        dos.writeDouble(v);
    }

    public void writeBytes(String s) throws IOException {
        dos.writeBytes(s);
    }

    public void write(int b) throws IOException {
        dos.write(b);
    }

    public void write(byte b[]) throws IOException {
        dos.write(b);
    }

    public void write(byte b[], int off, int len) throws IOException {
        dos.write(b, off, len);
    }

    public void writeChars(String s) throws IOException {
        dos.writeChars(s);
    }

    public void writeChar(int v) throws IOException {
        dos.writeChar(v);
    }

    public void writeUTF(String str) throws IOException {
        dos.writeUTF(str);
    }

    public void writeInt(int v) throws IOException {
        byte b1;
        byte b2;
        byte b3;
        byte b4;
        if(bigEndian) {
            b1 = (byte)(v >> 24);
            b2 = (byte)(v >> 16);
            b3 = (byte)(v >> 8);
            b4 = (byte)v;
        } else {
            b1 = (byte)v;
            b2 = (byte)(v >> 8);
            b3 = (byte)(v >> 16);
            b4 = (byte)(v >> 24);
        }
        dos.writeByte(b1);
        dos.writeByte(b2);
        dos.writeByte(b3);
        dos.writeByte(b4);
    }

    public void setBigEndian(boolean isBig) {
        bigEndian = isBig;
    }
}
