// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import java.net.MalformedURLException;
import java.net.URL;

public class PalaceURL {

    private boolean isPalace;
    private URL mURL;
    static URL defaultURL;

    public String toString() {
        if(mURL == null)
            return "" + null;
        if(isPalace)
            return "palace:" + mURL.toString();
        else
            return mURL.toString();
    }

    public PalaceURL(String protocol, String host, int port, String file) throws MalformedURLException {
        isPalace = false;
        try {
            mURL = new URL(protocol, host, port, file);
        }
        catch(MalformedURLException e) {
            isPalace = protocol.equalsIgnoreCase("palace");
            if(isPalace)
                mURL = new URL("http", host, port, file);
            else
                throw e;
        }
    }

    public PalaceURL(URL aURL) {
        isPalace = false;
        mURL = aURL;
    }

    public PalaceURL(String spec) throws MalformedURLException {
        isPalace = false;
        try {
            mURL = new URL(spec);
        }
        catch(MalformedURLException e) {
            parsePalaceURL(spec);
            if(!isPalace)
                throw e;
        }
    }

    public boolean isPalaceProtocol() {
        return isPalace;
    }

    public URL getURL() {
        return mURL;
    }

    boolean parsePalaceURL(String spec) {
        isPalace = false;
        spec = spec.trim();
        String t = spec.toLowerCase();
        if(t.startsWith("palace")) {
            String u = t.substring("palace".length()).trim();
            if(u.charAt(0) == ':')
                try {
                    mURL = new URL(defaultURL, "http:" + u.substring(1));
                    isPalace = true;
                }
                catch(MalformedURLException e) { }
        }
        return isPalace;
    }

    static  {
        try {
            defaultURL = new URL("http://PalaceURL.xxx");
        }
        catch(MalformedURLException e) { }
    }
}
